unit fMHA_BatteryRename;

interface

uses
  Windows,
  Messages,
  SysUtils,
  System.Contnrs,
  Classes,
  Graphics,
  Controls,
  Forms,
  StdCtrls,
  ExtCtrls,
  RzLabel,
  RzPanel,
  Buttons,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons;

type
  TfrmMHA_BatteryRename = class(TForm)
    pnlButton: TPanel;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    pnlNew: TPanel;
    lblNewName: TLabel;
    edtNewName: TEdit;
    lstBattery: TListBox;
    btnCancel: TJvXPButton;
    btnOK: TJvXPButton;
    procedure FormCreate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtNewNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ConfigureForm;
    procedure lstBatteryClick(Sender: TObject);
    procedure edtNewNameKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure PopulateBatteryList;
  private
    { Private declarations }

  public
    { Public declarations }

  end;

var
  frmMHA_BatteryRename        : TfrmMHA_BatteryRename;

implementation

uses
  uIA_Const,
  uMHA_Const,
  uMHA_Registry,
  fIA_dialogs, Dialogs,
  uIA_GUIControl,
  uMHA_Battery,
  uMHA_Battery_OPS;

{$R *.DFM}
var
  lvInitialize                : Boolean;

procedure TfrmMHA_BatteryRename.FormCreate(Sender: TObject);
begin
  lvInitialize := True;
  Position := poDesigned;
  ConfigureForm;

  edtNewName.Text := '';
  PopulateBatteryList;

  if (gvUseScreenReader) then
    begin
      if gvShowOptionTabs = 'D' then // Delete
        Caption := 'Remove a Battery '
      else
        Caption := 'Change Battery Name';
    end
  else
    Caption := MHA_Caption;


  lvInitialize := False;
  Screen.Cursor := crDefault;
  ActiveControl := lstBattery;
  ShowModal;
end;

procedure TfrmMHA_BatteryRename.PopulateBatteryList;
var
  i                           : Integer;
begin
  lstBattery.Clear;

  if Battery_OPS.ListOfBatteries.Count = 0 then
    lstBattery.Items.Add('No batteries')
  else
    for i := 0 to Battery_OPS.ListOfBatteries.Count - 1 do
      // Add name of battery
      lstBattery.Items.Add(TBattery(Battery_OPS.ListOfBatteries[i]).BatteryName);
end;

procedure TfrmMHA_BatteryRename.ConfigureForm;
begin
  // See FormResize for left positions
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Width := GetWidth(5 * ButtonWidthNormal); //CheckWidth(400, Width);
      Height := GetHeight((4 * pnlHeaderHeight) +
        (9 * ButtonHeight));

      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      pnlHeader.Height := pnlHeaderHeight;
      lblHeader.Font.Size := lblHeaderFontSize;

      lstBattery.Left := ButtonWidthNormal div 2;
      lstBattery.Width := ClientWidth - ButtonWidthNormal;
      lstBattery.Top := pnlHeader.Height + TextHeight('Yy', Font);
      lstBattery.Height := pnlHeader.Height * 4;

      lblNewName.Left := lstBattery.Left;
      lblNewName.Top := TextHeight('Yy', Font);
      edtNewName.Top := lblNewName.Top + lblNewName.Height + TextHeight('Yy', Font) div 2;
      edtNewName.Left := lstBattery.Left;
      edtNewName.Width := lstBattery.Width;
      pnlNew.Height := 3 * ButtonHeight;

      edtNewName.Enabled := False;
      lblHeader.alignment := taCenter;

      pnlButton.Height := (3 * ButtonHeight) div 2;
      btnOK.Top := (pnlButton.Height - ButtonHeight) div 2;
      btnOK.Height := ButtonHeight;
      btnOK.Width := ButtonWidthNormal;

      btnCancel.Top := btnOK.Top;
      btnCancel.Height := ButtonHeight;
      btnCancel.Width := ButtonWidthNormal;

      if gvShowOptionTabs = 'D' then // Delete
        begin
          //lblBattery.Caption := 'Select a battery to remove';
          lblHeader.Caption := 'Select a battery to remove';
          pnlNew.Visible := False;
        end
      else
        begin
          //lblBattery.Caption := 'Select a battery to rename';
          lblHeader.Caption := 'Select a battery to rename';
          pnlNew.Visible := True;
        end;

      if gvUseScreenReader then
        begin
          Left := 0;
          Width := Screen.Width;
          //btnOK.caption := btnOK.Caption + ' button';
          //btnCancel.caption := btnCancel.Caption + ' button';
        end;
    end;
end;

procedure TfrmMHA_BatteryRename.btnOkClick(Sender: TObject);
var
  Reply,
    ErrorMsg                  : string;
begin

  ErrorMsg := OK;

  if gvShowOptionTabs = 'D' then // Delete
    begin

      if MsgDlgFrm('Are you sure you want to delete the battery  ' + CRLF + CRLF +
        Trim(lstBattery.Items[lstBattery.ItemIndex]) + '?' + CRLF + CRLF +
        '(Note: The instruments listed in the battery will not be deleted.)', MHA_Caption,
        mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        begin

          Reply := Battery_OPS.DeleteBattery(lstBattery.Items[lstBattery.ItemIndex]); // uMHA_Battery
          if Reply <> OK then
            begin
              MsgDlgFrm('Unable to delete battery. ' + CRLF + CRLF +
                Reply + CRLF + CRLF +
                '(Note: The instruments listed in the battery were not be deleted.)', MHA_Caption,
                mtError, [mbYes, mbNo], 0);
              Exit;
            end;

          // Re-populate the battery list
          reply := Battery_OPS.LoadBatteries;

          if (reply = '0') or (reply = OK) then
            //PopulateBatteryList
          else
            begin
              MsgDlgFrm('Sorry, an error has occurred while loading the batteries. ' +
                #13 + #13 + Reply, MHA_Caption, mtError, [mbok], 0);
              Exit;
            end;
        end;

      Close;
      Exit;
    end; // Remove

  // Rename stuff follows

  if edtNewName.Text = '' then
    begin
      close;
      Exit;
    end;

  // Make sure this name for the battery is unique
  if Battery_OPS.BatteryNameUnique(edtNewName.text) then
    begin
      if lstBattery.ItemIndex = -1 then
        Exit;

      ErrorMsg := Battery_OPS.RenameBattery(lstBattery.Items[lstBattery.ItemIndex],
        edtNewName.text);

      if ErrorMsg = '' then
        begin
          MsgDlgFrm('The battery was not renamed. The original name was not found.',
            MHA_Caption, mtError, [mbOk], 0);
          exit;
        end;

      if ErrorMsg <> OK then
        begin
          MsgDlgFrm('Rename battery: ' + ErrorMsg,
            MHA_Caption, mtError, [mbOk], 0);
          exit;
        end;
    end
  else // Not a unique name
    begin
      MsgDlgFrm('The name for this battery is already in use. Please provide ' +
        'a new name.', MHA_Caption,
        mtInformation, [mbOk], 0);
      exit;
    end;

  close;
end;

procedure TfrmMHA_BatteryRename.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_BatteryRename.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
      Exit;
    end;
end;

procedure TfrmMHA_BatteryRename.edtNewNameKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = vk_Return then
    btnOkClick(Sender);
end;

procedure TfrmMHA_BatteryRename.lstBatteryClick(Sender: TObject);
begin
  edtNewName.Enabled := True;
  edtNewName.Text := lstBattery.Items[lstBattery.ItemIndex];
end;

procedure TfrmMHA_BatteryRename.edtNewNameKeyPress(Sender: TObject;
  var Key: Char);
begin
  if CharInSet(Key, [#61, #62, #94]) then // = > ^
    begin
      Key := #0;
      MsgDlgFrm('Sorry, this key cannot be used in a battery name.  ',
        MHA_Caption,
        mtInformation, [mbok], 0);
    end;
end;

procedure TfrmMHA_BatteryRename.FormResize(Sender: TObject);
begin
  btnOK.Left := pnlButton.Width - btnOK.Width - btnOK.Width div 3;
  btnCancel.Left := btnOK.Width div 3;

  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

end.

