unit fMHA_Progress;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  fIA_dialogs, Dialogs,
  StdCtrls,
  JvProgressBar,
  JvXPProgressBar,
  ExtCtrls;

type
  TfrmMHA_Progress = class(TForm)
    pnlProgress: TPanel;
    pbrProgress: TJvXPProgressBar;
    lblProgress: TLabel;
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetupProgressBar(CaptionIn: string; TotalPartsIn: integer);
    procedure IncreaseProgressBar;
  end;

var
  frmMHA_Progress             : TfrmMHA_Progress;

implementation

{$R *.DFM}

uses
  uIA_Const,
  uMHA_Registry,
  uIA_GUIControl;

procedure TfrmMHA_Progress.FormCreate(Sender: TObject);
begin
  // Keep Position out of ConfigureForm when ConfigureForm can be called
  // more than once with the form.
  Position := poDesigned;

  if gvUseScreenReader then
    Caption := 'Please wait while files are updated. ';

  Scaled := True;
  AutoScroll := False;
  AutoSize := False;
  PixelsPerInch := 120;
  KeyPreview := True;
  HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
  VertScrollBar.Range := 0;
  Font.Assign(gvFont);

  with GUI_Control do
    begin
      lblProgress.Height := 3 * TextHeight('Yy', gvFont) div 2;
      pbrProgress.Height := lblProgress.Height;

      Width := GetWidth(6 * ButtonWidthNormal);
      Height := GetHeight(3 * ButtonHeight);
      Left := gvLeft + gvWidth div 4;
      Top := gvTop + gvHeight div 4;
      Refresh;
    end;

  Show;
end;

procedure TfrmMHA_Progress.SetupProgressBar(CaptionIn: string;
  TotalPartsIn: integer);
begin
  lblProgress.Caption := CaptionIn;

  pbrProgress.Min := 0;
  pbrProgress.Max := TotalPartsIn;
  lblProgress.Update;
end;

procedure TfrmMHA_Progress.IncreaseProgressBar;
begin
  pbrProgress.Position := pbrProgress.Position + 1;
  refresh;
end;


end.

