unit fMHA_ReviewAnswers;



interface

uses
  Windows,
  Messages,
  SysUtils,
  System.Contnrs,
  Classes,
  Graphics,
  Controls,
  Forms,
  fIA_dialogs, Dialogs,
  StdCtrls,
  ExtCtrls,
  Grids,
  BaseGrid,
  AdvGrid,
  RzLabel,
  RzPanel,
  Menus,
  uIA_Instrument,
  uMHA_Administration,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons, AdvObj;

type
  // Do not change this name: required for Secure Desktop
  TfrmMHA3_Want_Review = class(TForm)
    pnlButtons: TPanel;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    lblPatient: TRzLabel;
    pnlSpacer: TPanel;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    lblInfo: TLabel;
    pnlInfoSpacer: TPanel;
    pnlHeaderSpacer: TPanel;
    mnuHelp: TMenuItem;
    mnuOnlineSupport: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    grpAnswers: TRzGroupBox;
    grdAnswers: TAdvStringGrid;
    btnEdit: TJvXPButton;
    btnClose: TJvXPButton;

    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ConfigureForm;

    procedure btnEditClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuOnlineSupportClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure grdAnswersDblClick(Sender: TObject);

  private
    FChangeAnswer: string;
    procedure ResizeGrid;

    { Private declarations }
  public
    { Public declarations }
    property ChangeAnswer: string read FChangeAnswer write FChangeAnswer;
    procedure DisplayQA(aAdmin: TAdministration; aInstrument: TInstrument);
  end;

var
  frmMHA3_Want_Review         : TfrmMHA3_Want_Review;

implementation

uses
  uIA_Utils,
  uMHA_Registry,
  uIA_Patient,
  uIA_Const,
  uMHA_Const,
  uIA_Answer,
  uIA_Question,
  uMHA_Administration_OPS,
  uIA_GUIControl,
  fMHA_About,
  uMHA_Proctor;

{$R *.DFM}

var
  lvInitialize                : Boolean;

procedure TfrmMHA3_Want_Review.FormCreate(Sender: TObject);
begin
  lvInitialize := False;
  // Keep Position out of ConfigureForm when ConfigureForm can be called
  // more than once with the form.
  Position := poDesigned;

  FChangeAnswer := '';
  ConfigureForm;

  lvInitialize := False;
  Screen.Cursor := crDefault;
  ActiveControl := grdAnswers;
end;

procedure TfrmMHA3_Want_Review.ConfigureForm;
begin
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;

      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Height := GetHeight(gvHeight - 40); //CheckHeight(480, Height);
      Width := GetWidth(gvWidth - 40); //CheckWidth(640, Width);
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      lblHeader.Font.Size := lblHeaderFontSize;
      lblHeader.Width := TextWidth(lblHeader.Caption, lblHeader.Font);

      //lblpatient.Caption := StringReplace(Patient.CaptionInfo, #13, '', [rfReplaceAll]);
      lblpatient.Caption := Patient.CaptionInfo;
      lblpatient.Font.Size := lblPatientFontSize;
      lblpatient.Width := TextWidth(lblpatient.Caption, lblpatient.Font);
      pnlHeader.Height := 3 * TextHeight('Yy', lblpatient.Font);

      lblInfo.Font.Assign(gvFont);
      lblInfo.Font.Color := clNavy;

      btnClose.Font.Assign(gvFont);
      btnEdit.Font.Assign(gvFont);
      grdAnswers.Font.Assign(gvFont);
      grdAnswers.FixedFont.Assign(gvFont);
      grdAnswers.ActiveCellFont.Assign(gvFont);
      grdAnswers.FixedRowHeight := TextHeightByFont(gvFont.Handle, 'Yy');
      grdAnswers.DefaultRowHeight :=
        3 * TextHeightByFont(gvFont.Handle, 'Yy') div 2;
      pnlButtons.Height := 2 * ButtonHeight;
      btnEdit.Height := ButtonHeight;
      btnClose.Height := ButtonHeight;
      btnEdit.Top := ButtonHeight div 2;
      btnClose.Top := ButtonHeight div 2;
      btnEdit.Width := ButtonWidth(btnEdit.caption);
      btnClose.Width := ButtonWidthNormal;
      btnClose.Left := pnlButtons.Width - btnClose.Width - btnClose.Height div 2;
      btnEdit.Left := pnlButtons.Width - btnEdit.Width - btnClose.Width -
        btnClose.Height;
      lblInfo.Width := pnlButtons.Width - btnEdit.Left - 5;
      lblInfo.Height := pnlButtons.Height;
      lblInfo.Layout := tlCenter;
    end;

  mnuFile.Visible := not (Proctor.DataEntryMode = emPatient);
  mnuHelp.Visible := mnuFile.Visible;
end;

procedure TfrmMHA3_Want_Review.DisplayQA(aAdmin: TAdministration; aInstrument: TInstrument);
var
  i                           : Integer;
begin

  if aInstrument.PrintTitle = '' then
    lblHeader.Caption := '  ' + aInstrument.InstrumentName
  else
    lblHeader.Caption := '  ' + aInstrument.PrintTitle;

  with grdAnswers do
    begin
      if gvUseScreenReader then
        begin
          SelectionRectangle := True;
          ShowSelection := True;
          Options := [goHorzLine, goDrawFocusSelected, goColSizing, goRowSelect];
          FixedRowAlways := False;
          FixedColAlways := False;
          FixedRows := 0;
          FixedCols := 0;
          Cells[0, 0] := 'Number';
        end
      else
        begin
          SelectionRectangle := False;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
          FixedFont.Assign(gvFont);
          FixedRowAlways := True;
          FixedColAlways := false;
          FixedRows := 1;
          FixedCols := 0;
          FixedRowHeight := DefaultRowHeight;
          Cells[0, 0] := 'No.';
        end;

      Cells[1, 0] := 'Question';
      Cells[2, 0] := 'Answer';
      RowCount := aInstrument.ListOfQuestions.Count + FixedRows;

      for i := 0 to aInstrument.ListOfQuestions.Count - 1 do
        begin
          Cells[0, i + FixedRows] := TQuestion(aInstrument.ListOfQuestions[i]).Designator;
          Cells[1, i + FixedRows] := TQuestion(aInstrument.ListOfQuestions[i]).qText;
          Cells[2, i + FixedRows] := TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerText;

          if TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerValue = CHOICE_ID_OF_SKIPPED_QUESTION then
            Cells[2, i + FixedRows] := SKIPPED;
          if TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerValue = CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION then
            Cells[2, i + FixedRows] := SKIPPED_BY_RULE;
          if TAnswer(aAdmin.ListOfAdminAnswers[i]).AnswerValue = CHOICE_ID_OF_SKIPPED_REQUIRED_QUESTION then
            Cells[2, i + FixedRows] := SKIPPED_BUT_REQUIRED;

          Cells[3, i + FixedRows] := TQuestion(aInstrument.ListOfQuestions[i]).QuestionID;
        end; //for irow
    end;

  ResizeGrid;
  btnEdit.Enabled := (grdAnswers.RowCount > 1);

  if gvUseScreenReader then
    begin
      Left := 0;
      Width := Screen.Width;
      Caption := 'Review answers on ' + aInstrument.InstrumentName + ' for ' + Patient.Name;

      grpAnswers.Caption :=
        'The following grid summarizes all answers. Each row states' +
        ' the question and its answer.' +
        ' Navigate with the arrow keys, select with enter key. Enter grid by pressing tab key.';
      grpAnswers.TabStop := True; // Allow reader to read it more than once.
      ActiveControl := grpAnswers;
    end
  else
    grpAnswers.TabStop := False;

  grpAnswers.Update;
  grdAnswers.Update;
end;

procedure TfrmMHA3_Want_Review.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA3_Want_Review.ResizeGrid;
begin
  with grdAnswers do
    begin
      ColWidths[0] := TextWidthByFont(Font.Handle, 'XXXX');
      ColWidths[2] := TextWidthByFont(Font.Handle, 'XXXXXXXXXXXXXXXXXXXX'); //20;
      ColWidths[1] := Width - ColWidths[0] - ColWidths[2];
      ColWidths[3] := 0;
    end;
end;

procedure TfrmMHA3_Want_Review.FormResize(Sender: TObject);
begin
  ResizeGrid;

  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

procedure TfrmMHA3_Want_Review.btnEditClick(Sender: TObject);
begin
  if grdAnswers.Cells[1, grdAnswers.Row] <> '' then
    FChangeAnswer := grdAnswers.Cells[3, grdAnswers.Row];
  Close;
end;

procedure TfrmMHA3_Want_Review.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA3_Want_Review.FormKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ((ActiveControl.ClassName = 'TAdvStringGrid') and
    (key = #13)) then
    grdAnswersDblClick(sender);
end;

procedure TfrmMHA3_Want_Review.FormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    Close;
end;

procedure TfrmMHA3_Want_Review.mnuOnlineSupportClick(Sender: TObject);
begin
  VisitURL(MHA_ONLINE_SUPPORT_URL);
end;

procedure TfrmMHA3_Want_Review.About1Click(Sender: TObject);
begin
  frmMHA_About := TfrmMHA_About.Create(nil);
  try
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end; //try
end;

procedure TfrmMHA3_Want_Review.grdAnswersDblClick(Sender: TObject);
begin
  if btnEdit.Enabled then
    btnEditClick(Self);
end;




end.

