unit fMHA_Summary;

(*
  This form is not in use. It is folded into InstrumentResults as a tab.




*)

interface

uses
  Windows,
  Messages,
  SysUtils,
  DateUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons,
  ExtCtrls,
  fIA_dialogs, Dialogs,
  StdCtrls,
  JvPageSetup,
  JvBaseDlg,
  JvWinDialogs,
  RzLabel,
  Menus,
  TeeProcs,
  TeEngine,
  Chart,
  Series;

type
  TfrmMHA_Summary = class(TForm)
    pnlButtons: TPanel;
    btnCancel: TJvXPButton;
    btnPrint: TJvXPButton;
    pnlHeader: TPanel;
    lblHeader: TLabel;
    JvShellAboutDialog1: TJvShellAboutDialog;
    JvPageSetupDialog1: TJvPageSetupDialog;
    PrintDialog1: TPrintDialog;
    imgBackup: TImage;
    lblPatient: TRzLabel;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    mnuPageSetup: TMenuItem;
    mnuPrint: TMenuItem;
    N1: TMenuItem;
    sbSummary: TScrollBox;
    pnlRight: TPanel;
    pnlLeft: TPanel;
    crtPHQ9: TChart;
    Series1: TBarSeries;
    gbPHQ9: TGroupBox;
    pnlGuide: TPanel;
    lblGuide: TLabel;
    crtPCLM: TChart;
    BarSeries1: TBarSeries;
    gbVisits: TGroupBox;
    pnlSpacerR: TPanel;
    lblInitial: TLabel;
    lblDaysLast: TLabel;
    lblVisitsYear: TLabel;
    pnlPtInfo: TPanel;
    lblDOB: TLabel;
    lblGender: TLabel;
    pnlSpacer1: TPanel;
    pnlSpacer2: TPanel;
    pnlSpacer3: TPanel;
    crtSF36: TChart;
    Series2: TBarSeries;
    Series3: TBarSeries;
    Series4: TBarSeries;
    pnlSF36Guide: TPanel;
    lblSF36Guide: TLabel;
    crtBAI: TChart;
    BarSeries2: TBarSeries;
    pnlBAIGuide: TPanel;
    lblBAIGuide: TLabel;
    gbPCLM: TGroupBox;
    pnlSpaceR4: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure ConfigureForm;
    procedure btnCancelClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);

    procedure imgBackupClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);

    procedure DrawPtInfo;
    procedure DrawPHQ9Graph;
    procedure DrawPCLMItems(WhichOne: Integer);
    procedure DrawSF36Graph;
    procedure DrawPCLMGraph;
    procedure DrawPHQ9Items(WhichOne: Integer);
    procedure DrawBAIGraph;
    procedure DrawVisits;

    procedure GetResults;
    function LoadInstrumentRecords: Boolean;
    function HowManyNotes: integer;
    procedure FormResize(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure crtPCLMClickSeries(Sender: TCustomChart;
      Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure crtPHQ9ClickSeries(Sender: TCustomChart;
      Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMHA_Summary              : TfrmMHA_Summary;

implementation

{$R *.dfm}

uses
  uIA_Const,
  uMHA_Const,
  uIA_GUIControl,
  uIA_Utils,
  uIA_Patient,
  uIA_ThisUser,
  uIA_Question,
  uIA_Answer,
  uIA_Instrument,
  uIA_Instrument_OPS,
  uMHA_AResult,
  uMHA_Result_OPS,
  uMHA_Report_IO,
  uMHA_DM;

const
  // Abbreviated version of the PHQ9 questions, 10 items
  PHQ9Questions               : string =
    'Little interest or pleasure ^' +
    'Down, depressed, hopeless ^' +
    'Trouble sleeping ^' +
    'Tired or no energy ^' +
    'Poor appetite or overeting ^' +
    'Feeeling like a failure ^' +
    'Trouble concentrating ^' +
    'Moving or speaking slowly ^' +
    'Better off dead ^' +
    'Difficulty caused by problems';

var
  lvPHQ9Answers,
    lvPCLMAnswers,
    lvSF36Results,
    lvPCLMResultsOverall,
    lvBAIResults,
    lvPHQ9Results             : string;

  lvPCLMResultsReexp,
    lvPCLMResultsAvoid,
    lvPCLMResultsArousal      : Integer;

procedure TfrmMHA_Summary.FormCreate(Sender: TObject);
begin
  Caption := MHA_Caption + ': In use by ' + ThisUser.Name;
  lblHeader.Caption := '    Health Summary ';
  Position := poMainFormCenter;
  ShowModal;
end;

procedure TfrmMHA_Summary.FormShow(Sender: TObject);
var
  i                           : Integer;
begin
  ConfigureForm;

  if not LoadInstrumentRecords then
    Exit;

  GetResults;

  if Result_OPS.ListOfResults.count = 0 then
    begin
      ShowMessage('No data for this veteran.');
      Close;
      Exit;
    end;

 // frmMHA_Main.Hide;
  DrawPtInfo;
  DrawPHQ9Graph;
  DrawPHQ9Items(-1); // Initial administration
  DrawSF36Graph;
  DrawPCLMGraph;
  DrawPCLMItems(-1); // Initial administration
  DrawBAIGraph;
  DrawVisits;

  Screen.Cursor := crDefault;
end;


procedure TfrmMHA_Summary.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  gvTop := Top;
  gvLeft := Left;
  gvWidth := Width;
  gvHeight := Height;
end;


procedure TfrmMHA_Summary.GetResults;
var
  i, j                        : Integer;
  TempStr                     : string;
begin
  lvPHQ9Results := '';
  lvPCLMResultsOverall := '';
  lvSF36Results := '';
  lvBAIResults := '';

  for i := 0 to Result_OPS.ListOfResults.Count - 1 do
    begin

      if TAResult(Result_OPS.ListOfResults[i]).Name = 'PHQ9' then
        begin
          with TAResult(Result_OPS.ListOfResults[i]) do
            begin
              ListOfScores := AResult.LoadScores(
                AnswersAreInLegacyFile, AdministrationIENS,
                Name, Patient.DFN, DateGiven);

              lvPHQ9Results := lvPHQ9Results +
                AdministrationIENS + U +
                DateGiven + U +
                Piece(ListOfScores, EQ, 2) + RECORD_END;

              lvPHQ9Answers := lvPHQ9Answers +
                AdministrationIENS + U +
                DateGiven + U +
                LoadAnswersForSummary(AdministrationIENS,
                DataModule1.RPCBroker1) +
                RECORD_END;
            end;
        end;

      if TAResult(Result_OPS.ListOfResults[i]).Name = 'SF36' then
        begin
        // This instrument has 8 scales
          with TAResult(Result_OPS.ListOfResults[i]) do
            begin

              ListOfScores := AResult.LoadScores(
                AnswersAreInLegacyFile, AdministrationIENS,
                Name, Patient.DFN, DateGiven);

              lvSF36Results := lvSF36Results +
                AdministrationIENS + U +
                DateGiven + U;

              for j := 1 to NumberOfPieces(ListOfScores, RECORD_END) do
                begin
                  TempStr := Piece(ListOfScores, RECORD_END, j);

                  lvSF36Results := lvSF36Results +
                    Piece(TempStr, EQ, 1) + EQ +
                    Piece(Piece(TempStr, EQ, 2), U, 2) + U;
                end;

              lvSF36Results := lvSF36Results + RECORD_END;
            end;
        end;

      if TAResult(Result_OPS.ListOfResults[i]).Name = 'PCLM' then
        begin
          with TAResult(Result_OPS.ListOfResults[i]) do
            begin
              ListOfScores := AResult.LoadScores(
                AnswersAreInLegacyFile, AdministrationIENS,
                Name, Patient.DFN, DateGiven);

              lvPCLMResultsOverall := lvPCLMResultsOverall +
                AdministrationIENS + U +
                DateGiven + U +
                Piece(ListOfScores, EQ, 2) + RECORD_END;

              lvPCLMAnswers := lvPCLMAnswers +
                AdministrationIENS + U +
                DateGiven + U +
                LoadAnswersForSummary(AdministrationIENS,
                DataModule1.RPCBroker1) +
                RECORD_END;
            end;
        end;

      if TAResult(Result_OPS.ListOfResults[i]).Name = 'BAI' then
        begin
          with TAResult(Result_OPS.ListOfResults[i]) do
            begin
              ListOfScores := AResult.LoadScores(
                AnswersAreInLegacyFile, AdministrationIENS,
                Name, Patient.DFN, DateGiven);

              lvBAIResults := lvBAIResults +
                AdministrationIENS + U +
                DateGiven + U +
                Piece(ListOfScores, EQ, 2) + RECORD_END;
            end;
        end;
    end;

end;

procedure TfrmMHA_Summary.ConfigureForm;
begin
  with GUI_Control do
    begin
      Scaled := True;
      sbSummary.AutoScroll := False;

      PixelsPerInch := 120;
      KeyPreview := True;

      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Width := CheckWidth(750, Width);
      Height := CheckHeight(550, Height);

      pnlSpacer1.Width := 8;
      pnlSpacer2.Width := 8;
      pnlSpacer3.Width := 8;

      pnlLeft.Width := (pnlHeader.Width div 2) - pnlSpacer1.Width -
        pnlSpacer2.Width div 2;

      pnlHeader.Height := pnlHeaderHeight;
      lblHeader.Font.Size := lblHeaderFontSize;
      pnlButtons.Height := 3 * ButtonHeight div 2;

      btnCancel.Left := btnCancel.Width div 3;
      btnCancel.Top := ButtonHeight div 4;
      btnCancel.Height := ButtonHeight;
      btnCancel.Width := ButtonWidthNormal;

      btnPrint.Left := pnlButtons.Width - btnPrint.Width - btnCancel.Left;
      btnPrint.Top := btnCancel.Top;
      btnPrint.Height := ButtonHeight;
      btnPrint.Width := ButtonWidthNormal;

      lblHeader.Caption := '  VA Patient Health Summary';
      lblHeader.Font.Size := lblHeaderFontSize;
      lblPatient.Caption := Patient.CaptionInfo;
      lblPatient.Font.Size := lblPatientFontSize;

      pnlGuide.Height := GetWrapHeight(lblGuide.Caption,
        lblGuide.Width, gvFont);

      pnlSF36Guide.Height := GetWrapHeight(lblSF36Guide.Caption,
        lblSF36Guide.Width, gvFont);

      pnlBAIGuide.Height := GetWrapHeight(lblBAIGuide.Caption,
        lblBAIGuide.Width, gvFont);

      Update;
    end;

end;


procedure TfrmMHA_Summary.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_Summary.btnPrintClick(Sender: TObject);
begin
(*
  if cbInstruments.Text = '' then
    begin
      ShowMessage('No instrument selected');
      Exit;
    end;

  if PrintDialog1.Execute then
    try

      if cbInstruments.Text = 'PTSD Status Form' then
        PrintPSF(sender); // uPrintPSF.pas

    except
      on E: exception do
        begin
          msgDlg(E.message, 'Printing', mterror, [mbok], 0);
          exit;
        end;
    end; {- try -}
*)
end;


procedure TfrmMHA_Summary.imgBackupClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_Summary.mnuExitClick(Sender: TObject);
begin
  Close;
end;


procedure TfrmMHA_Summary.DrawPtInfo;
begin
  lblDOB.AutoSize := False;
  lblDOB.Height := 3 * GUI_COntrol.GetStandardHeight(gvFont) div 2;
  lblDOB.Layout := tlCenter;
  lblDOB.Caption := '    DOB: ' + Patient.DOB + '  (' +
    IntToStr(YearsBetween(Now, StrToDate(DateStrToMMDDYYYYFormat(Patient.DOB, '/')))) + ')';

  lblGender.AutoSize := False;
  lblGender.Height := lblDOB.Height;
  lblGender.Layout := tlCenter;
  if Patient.Sex = 'F' then
    lblGender.Caption := '    Gender: Female'
  else
    lblGender.Caption := '    Gender: Male';

  pnlPtInfo.Height := lblDOB.Height + lblGender.Height + 10;
end;


procedure TfrmMHA_Summary.DrawPHQ9Graph;
var
  i                           : Integer;
  TempStr                     : string;
  TempColor                   : TColor;
begin
  with crtPHQ9 do
    begin
      Height := 200;
      BackColor := clWhite;

      Title.Text.Clear;
      Title.text.add('PHQ-9');
      Title.Font.Assign(gvFont);
      Title.Font.Style := [fsBold];

      LeftAxis.LabelsFont.Assign(gvFont);
      LeftAxis.Automatic := False;
      LeftAxis.Minimum := 0;
      LeftAxis.Maximum := 27;

      if lvPHQ9Results = '' then
        begin
          Series[0].Clear;
          BottomAxis.Visible := False;
          Exit;
        end;

      for i := 1 to NumberofPieces(lvPHQ9Results, RECORD_END) - 1 do
        begin
          TempStr := Piece(lvPHQ9Results, RECORD_END, i);

          if (StrToInt(Piece(TempStr, U, 3)) <= 27) and
            (StrToInt(Piece(TempStr, U, 3)) > 15) then
            TempColor := clRed;

          if (StrToInt(Piece(TempStr, U, 3)) <= 14) and
            (StrToInt(Piece(TempStr, U, 3)) > 5) then
            TempColor := clMaroon;

          if (StrToInt(Piece(TempStr, U, 3)) <= 4) and
            (StrToInt(Piece(TempStr, U, 3)) > 0) then
            TempColor := clgreen;

          Series[0].Add(StrToInt(Piece(TempStr, U, 3)), Piece(TempStr, U, 2), TempColor);
        end;
    end;
end;

procedure TfrmMHA_Summary.DrawSF36Graph;
const
  cSF36Scales                 : string =
    'Phy^R-P^Pain^Gen^Vit^Soc^Emo^MH^';
var
  i, j, x                     : Integer;
  TempStr,
    TempStr1                  : string;

  TempSeries                  : TChartSeries;
  ColorList                   : array[0..2] of TColor;

(*  procedure BuildSeries(SeriesIn: TChartSeries; TitleIn: string);
  begin
    with SeriesIn do
      begin
        Style := Bar;
        BarStyle = bsRectangle;
        Title := TitleIn; // date
        Name := 'SF36Series' + IntToStr(WhichOne);

      end;
  end; *)
  (*
  procedure AddThisSeries(NameIn, LabelIn: string; Value: Double);
  var
    ii                        : Integer;
  begin
    for ii := 1 to crtSF36.SeriesCount do
      if crtSF36.Series[ii].Name = NameIn then
        begin
          crtSF36.Series[ii].Add(Value, LabelIn, ColorList[ii]);
        end;
  end;*)

begin

  with crtSF36 do
    begin
      Height := 200;
      BackColor := clWhite;

      Title.Text.Clear;
      Title.text.add('SF-36');
      Title.Font.Assign(gvFont);
      Title.Font.Style := [fsBold];

      LeftAxis.LabelsFont.Assign(gvFont);
      LeftAxis.Automatic := False;
      LeftAxis.Minimum := 0;
      LeftAxis.Maximum := 100;

      if lvSF36Results = '' then
        begin
          Series[0].Clear;
          Series[1].Clear;
          Series[2].Clear;
          BottomAxis.Visible := False;
          Exit;
        end;

      ColorList[0] := clLime;
      ColorList[1] := clSilver;
      ColorList[2] := clAqua;

      x := 0;

      Series[0].ShowInLegend := False;
      Series[1].ShowInLegend := False;
      Series[2].ShowInLegend := False;
//ShowMessage(lvSF36Results);
//ShowMessage(inttostr(NumberofPieces(lvSF36Results, RECORD_END)));
      // Start at most recent, go backwards.
      for i := NumberofPieces(lvSF36Results, RECORD_END) - 1 downto 0 do
        begin

          TempStr := Piece(lvSF36Results, RECORD_END, i);
          //BuildSeries(TChartSeries.Create(crtSF36), Piece(TempStr, U, 2)) ;
          Series[x].Active := True;
          Series[x].ShowInLegend := True;
          Series[x].Title := Piece(TempStr, U, 2);

          for j := 3 to NumberofPieces(TempStr, U) - 2 do
            begin
              TempStr1 := Piece(TempStr, U, j);

              Series[x].Add(StrToFloat(Piece(TempStr1, EQ, 2)), // Value
                Piece(cSF36Scales, U, j - 2), // Label
                ColorList[x]);
            end;
          Inc(x);
          if x > 2 then
            Exit;
        end;
    end;
end;

procedure TfrmMHA_Summary.DrawPCLMGraph;
var
  i                           : Integer;
  TempStr                     : string;
  TempColor                   : TColor;
begin

  with crtPCLM do
    begin
      Height := 200;
      BackColor := clWhite;

      Title.Text.Clear;
      Title.text.add('PCL-M');
      Title.Font.Assign(gvFont);
      Title.Font.Style := [fsBold];

      LeftAxis.LabelsFont.Assign(gvFont);
      LeftAxis.Automatic := False;
      LeftAxis.Minimum := 0;
      LeftAxis.Maximum := 85;

      if lvPCLMResultsOverall = '' then
        begin
          Series[0].Clear;
          BottomAxis.Visible := False;
          Exit;
        end;

      for i := 1 to NumberofPieces(lvPCLMResultsOverall, RECORD_END) - 1 do
        begin
          TempStr := Piece(lvPCLMResultsOverall, RECORD_END, i);

          if (StrToInt(Piece(TempStr, U, 3)) <= 85) and
            (StrToInt(Piece(TempStr, U, 3)) > 50) then
            TempColor := clRed;

          if (StrToInt(Piece(TempStr, U, 3)) <= 49) and
            (StrToInt(Piece(TempStr, U, 3)) > 18) then
            TempColor := clMaroon;

          if (StrToInt(Piece(TempStr, U, 3)) <= 17) and
            (StrToInt(Piece(TempStr, U, 3)) > 0) then
            TempColor := clGreen;

          Series[0].Add(StrToInt(Piece(TempStr, U, 3)), Piece(TempStr, U, 2), TempColor);
        end;
    end;
end;

procedure TfrmMHA_Summary.DrawBAIGraph;
var
  i                           : Integer;
  TempStr                     : string;
  TempColor                   : TColor;
begin

  with crtBAI do
    begin
      Height := 200;
      BackColor := clWhite;

      Title.Text.Clear;
      Title.text.add('BAI');
      Title.Font.Assign(gvFont);
      Title.Font.Style := [fsBold];

      LeftAxis.LabelsFont.Assign(gvFont);
      LeftAxis.Automatic := False;
      LeftAxis.Minimum := 0;
      LeftAxis.Maximum := 63;

      if lvBAIResults = '' then
        begin
          Series[0].Clear;
          BottomAxis.Visible := False;
          Exit;
        end;

      for i := 1 to NumberofPieces(lvBAIResults, RECORD_END) - 1 do
        begin
          TempStr := Piece(lvBAIResults, RECORD_END, i);

          if (StrToInt(Piece(TempStr, U, 3)) <= 63) and
            (StrToInt(Piece(TempStr, U, 3)) > 30) then
            TempColor := clRed;

          if (StrToInt(Piece(TempStr, U, 3)) <= 29) and
            (StrToInt(Piece(TempStr, U, 3)) > 19) then
            TempColor := clMaroon;

          if (StrToInt(Piece(TempStr, U, 3)) <= 18) and
            (StrToInt(Piece(TempStr, U, 3)) > 10) then
            TempColor := clPurple;

          if (StrToInt(Piece(TempStr, U, 3)) <= 9) and
            (StrToInt(Piece(TempStr, U, 3)) > 0) then
            TempColor := clGreen;

          Series[0].Add(StrToInt(Piece(TempStr, U, 3)), Piece(TempStr, U, 2), TempColor);
        end;
    end;
end;


function TfrmMHA_Summary.LoadInstrumentRecords: boolean;
var
  reply                       : string;
begin
  result := False;

  reply := Result_OPS.LoadCompleteResults(Patient.DFN); // uMHA_Results_OPS

  if reply <> OK then
    begin
      ShowMessage('Unable to load results.' + reply);
      Exit;
    end;
  result := True;
end;


procedure TfrmMHA_Summary.DrawPHQ9Items(WhichOne: Integer);
const
  Space                       : Integer = 1;

var
  QuestionTop,
    i                         : Integer;
  TempStr                     : string;

  function BuildItem(LabelIn: TLabel; CaptionIn: string): integer;
  begin
    with LabelIn do
      begin
        Parent := gbPHQ9;
        AutoSize := False;
        Top := QuestionTop;
        Left := 10;
        Width := gbPHQ9.Width - (2 * Left);
        Font.Assign(gvFont);
        Alignment := taLeftJustify;
        WordWrap := False;
        Caption := CaptionIn;

        // Check for wrapping of the caption
//        Height := GUI_Control.GetWrapHeight(Caption, Width, gvFont);
//        if Height > GUI_Control.GetStandardHeight(gvFont) then
//          Layout := tlTop
//        else
//          Layout := tlCenter;
        Height := GUI_Control.GetStandardHeight(gvFont);
        Result := Height;
      end;
  end;

  function GetAnswerText(ChoiceID: string): string;
  begin
    Result := '';
    if ChoiceID = '212' then
      Result := 'Not at all';
    if ChoiceID = '1008' then
      Result := 'Several days';
    if ChoiceID = '1009' then
      Result := 'More than half the days';
    if ChoiceID = '1010' then
      Result := 'Nearly every day';
    if ChoiceID = '1334' then
      Result := 'Not difficult at all';
    if ChoiceID = '1335' then
      Result := 'Somewhat difficult';
    if ChoiceID = '1336' then
      Result := 'Very difficult';
    if ChoiceID = '1337' then
      Result := 'Extremely difficult';
  end;

begin
  QuestionTop := 20;

  if PHQ9Questions = '' then
    begin
      gbPHQ9.Visible := False;
      pnlGuide.Visible := False;
      Exit;
    end;

  gbPHQ9.Font.Assign(gvFont);
  gbPHQ9.Font.Style := [fsBold];

  // Hide old items should this be a new request for items
  for i := 0 to ComponentCount - 1 do
    begin
      if Components[i] is TLabel then
        if TLabel(Components[i]).Parent = gbPHQ9 then
          begin
            TLabel(Components[i]).Visible := False;
          end;
    end;

  if WhichOne = -1 then // Initial request from FormShow
    begin
      i := NumberOfPieces(lvPHQ9Answers, RECORD_END);
      // Answers from last PHQ-9
      TempStr := Piece(lvPHQ9Answers, RECORD_END, i - 1);
    end
  else
    TempStr := Piece(lvPHQ9Answers, RECORD_END, WhichOne + 1);

  if Pos(BAD_DATA, TempStr) > 0 then
    begin
      TempStr := '';
      gbPHQ9.Caption := '   Bad data for PHQ-9 responses   ';
      gbPHQ9.Height := QuestionTop + 10;
      Exit;
    end
  else
    gbPHQ9.Caption := '   ' + Piece(TempStr, U, 2) + ' PHQ-9 responses   ';

  for i := 3 to 12 do
    begin
      QuestionTop := QuestionTop + //Space +
        BuildItem(TLabel.Create(self),
        Piece(PHQ9Questions, U, i - 2) + ': ' +
        GetAnswerText(Piece(TempStr, U, i)));
    end;

  gbPHQ9.Height := QuestionTop + 10;

end;

procedure TfrmMHA_Summary.DrawPCLMItems(WhichOne: Integer);
const
  Space                       : Integer = 1;

var
  QuestionTop,
    i                         : Integer;
  TempStr                     : string;

  function BuildItem(LabelIn: TLabel; CaptionIn: string): integer;
  begin
    with LabelIn do
      begin
        Parent := gbPCLM;
        AutoSize := False;
        Top := QuestionTop;
        Left := 10;
        Width := gbPCLM.Width - (2 * Left);
        Font.Assign(gvFont);
        Alignment := taLeftJustify;
        WordWrap := False;
        Caption := CaptionIn;

        // Check for wrapping of the caption
//        Height := GUI_Control.GetWrapHeight(Caption, Width, gvFont);
//        if Height > GUI_Control.GetStandardHeight(gvFont) then
//          Layout := tlTop
//        else
//          Layout := tlCenter;
        Height := GUI_Control.GetStandardHeight(gvFont);
        Result := Height;
      end;
  end;


begin
  QuestionTop := 20;

  gbPCLM.Font.Assign(gvFont);
  gbPCLM.Font.Style := [fsBold];

  for i := 0 to ComponentCount - 1 do
    begin
      if Components[i] is TLabel then
        if TLabel(Components[i]).Parent = gbPCLM then
          begin
            TLabel(Components[i]).Visible := False;
          end;
    end;

  if lvPCLMAnswers = '' then
    begin
      gbPCLM.Visible := False;
      Exit;
    end;

  if WhichOne = -1 then
    begin
      i := NumberOfPieces(lvPCLMAnswers, RECORD_END);
      // Answers from last PCLM
      TempStr := Piece(lvPCLMAnswers, RECORD_END, i - 1);
    end
  else
    TempStr := Piece(lvPCLMAnswers, RECORD_END, WhichOne + 1);

  if Pos(BAD_DATA, TempStr) > 0 then
  begin
    TempStr := '';
     gbPCLM.Caption := '   Bad data ';
      gbPCLM.Height := QuestionTop + 10;
     Exit;
    end
    else
     gbPCLM.Caption := '   ' + Piece(TempStr, U, 2) + ' Symptom endorsement ';

  lvPCLMResultsReexp := 0;
  lvPCLMResultsAvoid := 0;
  lvPCLMResultsArousal := 0;

  for i := 3 to 20 do
    begin
      if (Piece(TempStr, U, i) = '718') or
        (Piece(TempStr, U, i) = '719') or
        (Piece(TempStr, U, i) = '720') then
        begin
          if (i > 0) and (i < 6) then
            Inc(lvPCLMResultsReexp);
          if (i > 5) and (i < 13) then
            Inc(lvPCLMResultsAvoid);
          if (i > 12) and (i < 18) then
            Inc(lvPCLMResultsArousal);
        end;
    end;

  if lvPCLMResultsReexp > 0 then
    QuestionTop := QuestionTop + //Space +
      BuildItem(TLabel.Create(self),
      'Re-experiencing criteria met (' +
      IntToStr(lvPCLMResultsReexp) + ' of 5).')
  else
    QuestionTop := QuestionTop + //Space +
      BuildItem(TLabel.Create(self),
      'Re-experiencing criteria not met (1 of 5).');

  if lvPCLMResultsAvoid > 2 then
    QuestionTop := QuestionTop + //Space +
      BuildItem(TLabel.Create(self),
      'Avoidance criteria met (' +
      IntToStr(lvPCLMResultsAvoid) + ' of 7).')
  else
    QuestionTop := QuestionTop + //Space +
      BuildItem(TLabel.Create(self),
      'Avoidance criteria not met (3 of 7).');

  if lvPCLMResultsArousal > 1 then
    QuestionTop := QuestionTop + //Space +
      BuildItem(TLabel.Create(self),
      'Arousal criteria met (' +
      IntToStr(lvPCLMResultsArousal) + ' of 5).')
  else
    QuestionTop := QuestionTop + //Space +
      BuildItem(TLabel.Create(self),
      'Arousal criteria not met (2 of 5).');

  if (lvPCLMResultsReexp > 0) and (lvPCLMResultsAvoid > 2) and
    (lvPCLMResultsArousal > 1) then
    QuestionTop := QuestionTop + //Space +
      BuildItem(TLabel.Create(self),
      'DSM IV diagnostic criteria B, C, and D met for PTSD.');

  gbPCLM.Height := QuestionTop + 10;

end;

function TfrmMHA_Summary.HowManyNotes: Integer;
var
  TempStr                     : string;
  TS                          : TStrings;
  i                           : Integer;
begin
  result := 0;
  TempStr := '';

  TS := TStringList.Create;
  //TS.Assign(GetPatientInfo(Patient.DFN, DataModule1.RPCBroker1));

  //ShowMessage(TS[0]);
  TS.Free;

 // TempStr := GetAllNotes(Patient.DFN, 'T-365', 'T', DataModule1.RPCBroker1);

  if TempStr <> '' then
    result := NumberOfPieces(TempStr, RECORD_END);
end;

procedure TfrmMHA_Summary.DrawVisits;
begin
  lblVisitsYear.AutoSize := False;
  lblVisitsYear.Font.Assign(gvFont);
  lblVisitsYear.Height := GUI_Control.GetStandardHeight(gvFont);
  lblVisitsYear.Layout := tlCenter;
  lblVisitsYear.Caption := '    Number of visits last year: ' + IntToStr(HowManyNotes);

  lblInitial.AutoSize := False;
  lblInitial.Font.Assign(gvFont);
  lblInitial.Height := lblVisitsYear.Height;
  lblInitial.Layout := tlCenter;
  lblInitial.Caption := '    Initial visit: ';

  lblDaysLast.AutoSize := False;
  lblDaysLast.Font.Assign(gvFont);
  lblDaysLast.Height := lblVisitsYear.Height;
  lblDaysLast.Layout := tlCenter;
  lblDaysLast.Caption := '    Days since last visit: ';

  gbVisits.Font.Assign(gvFont);
  gbVisits.Font.Style := [fsBold];
  gbVisits.Height := 4 * lblVisitsYear.Height;
end;

procedure TfrmMHA_Summary.FormResize(Sender: TObject);
begin
  pnlLeft.Width := (pnlHeader.Width div 2) - pnlSpacer1.Width -
    pnlSpacer2.Width div 2;
  refresh;
end;

procedure TfrmMHA_Summary.Button1Click(Sender: TObject);
var
  i                           : Integer;
  TempList                    : TStringList;
begin
  TempList := TStringList.Create;
  //memo1.Lines.Clear;

  //TempList.Assign(GetPatientInfo(Patient.DFN, DataModule1.RPCBroker1));
  TempList.Assign(GetNotesList(Patient.DFN, DataModule1.RPCBroker1));
  //TempList.Delete(0);
  //memo1.Lines.Assign(TempList);

  templist.Free;

//  for i := 0 to RPCResult.Count - 1 do
//    begin
//      TempStr := RPCResult[i];
//      TempNote := Piece(TempStr, U, 2);
//      if ((Pos('MH', UpperCase(TempNote)) > 0) or
//        (Pos('M/H', UpperCase(TempNote)) > 0) or
//        (Pos('PSY', UpperCase(TempNote)) > 0) or
//        (Pos('PTSD', UpperCase(TempNote)) > 0) or
//        (Pos('SOCIAL', UpperCase(TempNote)) > 0) or
//        (Pos('BEHAV', UpperCase(TempNote)) > 0) or
//        (Pos('MENTAL', UpperCase(TempNote)) > 0)) then
//        begin
//          ItemsList.Add('4^' +
//              {Name} MixedCase(Piece(TempStr, U, 2)) + Delimiter +
//              {Date Start} Piece(TempStr, U, 3) + Delimiter +
//              //{Date End} Delimiter +
//              {Provider} MixedCase(Piece(Piece(TempStr, U, 5), ';', 2)) + Delimiter +
//              {IENS} Piece(TempStr, U, 1));
//          ListDiagnoses(Piece(TempStr, U, 1));
//        end;

end;

procedure TfrmMHA_Summary.crtPCLMClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DrawPCLMItems(ValueIndex);
end;

procedure TfrmMHA_Summary.crtPHQ9ClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DrawPHQ9Items(ValueIndex);
end;

end.

