unit fMHA_UploadAdmin;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  fIA_dialogs, Dialogs,
  StdCtrls,
  RzLabel,
  RzPanel,
  ORCtrls,
  ExtCtrls,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons;

type

  TfrmMHA_UploadAdmin = class(TForm)
    pnlLeft: TPanel;
    grpOrderer: TGroupBox;
    cbxOrderedBy: TORComboBox;
    grpInterviewer: TGroupBox;
    cbxInterviewer: TORComboBox;
    grpLocation: TGroupBox;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    pnlSpacer0: TPanel;
    pnlHeaderSpacer: TPanel;
    lblPatient: TRzLabel;
    cbxLocation: TORComboBox;
    btnOK: TJvXPButton;
    btnCancel: TJvXPButton;
    grpConsult: TGroupBox;
    cbxConsult: TORComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ConfigureForm(Sender: TObject);
    procedure cbxOrderedByChange(Sender: TObject);
    procedure cbxOrderedByDropDown(Sender: TObject);
    procedure cbxOrderedByNeedData(Sender: TObject;
      const StartFrom: string; Direction, InsertAt: Integer);
    procedure cbxInterviewerChange(Sender: TObject);
    procedure cbxInterviewerDropDown(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxLocationChange(Sender: TObject);
    procedure cbxLocationNeedData(Sender: TObject; const StartFrom: string;
      Direction, InsertAt: Integer);
    procedure cbxLocationDropDown(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure cbxConsultChange(Sender: TObject);
    procedure cbxConsultDropDown(Sender: TObject);
  private
    { Private declarations }
    FDiscontinue: boolean;
    FPatientDFN,
      FConsultIEN,
      FLocation,
      FLocationIEN,
      FOrdererDUZ,
      FAdminBy: string;
  public
    { Public declarations }
    property Discontinue: boolean read FDiscontinue write FDiscontinue;

    property Location: string read FLocation write FLocation;
    property LocationIEN: string read FLocationIEN write FLocationIEN;
    property OrdererDUZ: string read FOrdererDUZ write FOrdererDUZ;
    property ConsultIEN: string read FConsultIEN write FConsultIEN;
    property PatientDFN: string read FPatientDFN write FPatientDFN;
    property AdminBy: string read FAdminBy write FAdminBy;
  end;

var
  frmMHA_UploadAdmin          : TfrmMHA_UploadAdmin;

implementation

uses
  uIA_Const,
  uMHA_Const,
  uMHA_Administration,
  uMHA_Administration_OPS,
  uIA_ThisUser,
  uIA_Utils,
  uIA_GUIControl,
  uMHA_Registry,
  uIA_Staff_OPS,
  uMHA_Location_IO,
  uIA_Consult_OPS,
  //fMHA_UploadResults,
  uMHA_DM;

{$R *.DFM}

var
  lvInitialize                : Boolean;

procedure TfrmMHA_UploadAdmin.FormCreate(Sender: TObject);
begin

  lvInitialize := True;
  // Keep Position out of ConfigureForm when ConfigureForm can be called
  // more than once with the form.
  Position := poDesigned;
  FDiscontinue := true;

  ConfigureForm(Sender);
end;


procedure TfrmMHA_UploadAdmin.FormShow(Sender: TObject);
begin

  if (DataBaseMode = dbVistA) then
    begin
      cbxOrderedBy.Text := ThisUser.Name;
      cbxInterviewer.Text := ThisUser.Name;

      FOrdererDUZ := ThisUser.DUZ;
      FAdminBy := ThisUser.DUZ;
      FConsultIEN := '';

      //frmMHA_UploadResults.UploadAdministration.Orderer.DUZ := ThisUser.DUZ;
      //frmMHA_UploadResults.UploadAdministration.AdministeredBy := ThisUser.DUZ;
    end
  else
    // Can not continue unless hooked to Vista
    Close;

  Application.ProcessMessages;

  if (Piece(gvLastLocation, U, 1) = '-1') or
    (Piece(gvLastLocation, U, 1) = '') then
    begin
      cbxLocation.InitLongList('');
      cbxLocation.ItemIndex := 0;
    end
  else
    begin
    // Name of location
      cbxLocation.InitLongList(Piece(gvLastLocation, U, 2));
      cbxLocation.ItemIndex :=
        cbxlocation.SelectByIEN(StrToIntDef(Piece(gvLastLocation,
        U, 1), 0));
    end;

  FLocationIEN := IntToStr(cbxLocation.ItemIEN);
  FLocation := cbxLocation.Text;

  //frmMHA_UploadResults.UploadAdministration.LocationIEN := IntToStr(cbxLocation.ItemIEN);
  //frmMHA_UploadResults.UploadAdministration.LocationStr := cbxLocation.Text;

  if gvUseScreenReader then
    begin
      // Caption is handled in UploadResults form
      grpOrderer.Caption := 'Ordered &By: vista combo box';
      grpInterviewer.Caption := '&Interviewer: vista combo box';
      grpLocation.Caption := 'Visit &Location: vista combo box';
      grpConsult.Caption := 'Consultation: vista combo box';
    end;

  lvInitialize := False;
  Screen.Cursor := crDefault;

  if gvUseScreenReader then
    ActiveControl := grpOrderer
  else
    ActiveControl := cbxOrderedBy;
end;

procedure TfrmMHA_UploadAdmin.ConfigureForm(Sender: TObject);
begin
  Caption := MHA_Caption + ' in use by ' + ThisUser.Name;
  with GUI_Control do
    begin

      Scaled := True;
      AutoScroll := False;
      AutoSize := False;

      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      pnlHeader.Height := pnlHeaderHeight;

      Height := GetHeight(pnlHeader.Height + (8 * grpOrderer.Height) +
        (ButtonHeight div 2));
      Width := GetWidth(3 * ButtonWidthNormal + (3 * (ButtonWidthNormal div 4)));
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      lblHeader.Font.Size := lblHeaderFontSize;
      //lblHeader.Caption := '  ' +
      //  frmMHA_UploadResults.UploadAdministration.InstrumentName;

      pnlSpacer0.Width := ButtonHeight div 4;
      pnlLeft.Width := 3 * ButtonWidthNormal;

      grpOrderer.Height := 2 * ButtonHeight;
      grpInterviewer.Height := grpOrderer.Height;
      grpLocation.Height := grpOrderer.Height;
      grpConsult.Height := grpOrderer.Height;

      cbxOrderedBy.Top := grpOrderer.Height div 3;
      cbxInterviewer.Top := cbxOrderedBy.Top;
      cbxLocation.Top := cbxOrderedBy.Top;
      cbxConsult.Top := cbxOrderedBy.Top;

      cbxOrderedBy.Left := pnlSpacer0.Width;
      cbxInterviewer.Left := cbxOrderedBy.Left;
      cbxLocation.Left := cbxOrderedBy.Left;
      cbxConsult.Left := cbxOrderedBy.Left;

      cbxOrderedBy.Width := grpOrderer.Width - (2 * pnlSpacer0.Width);
      cbxInterviewer.Width := cbxOrderedBy.Width;
      cbxLocation.Width := cbxOrderedBy.Width;
      cbxConsult.Width := cbxOrderedBy.Width;

      btnOk.Top := (pnlLeft.Height + pnlHeader.Height) - ButtonHeight -
        pnlSpacer0.Width;
      btnOk.Height := ButtonHeight;
      btnOk.Width := ButtonWidthNormal;

      btnCancel.Height := btnOk.Height;
      btnCancel.Width := btnOk.Width;
      btnCancel.Top := btnOK.Top;
      btnCancel.Left := pnlHeader.Width - btnCancel.Width - pnlSpacer0.Width;
      btnOk.Left := pnlHeader.Width - (2 * btnCancel.Width) -
        (2 * pnlSpacer0.Width);

      if gvUseScreenReader then
        begin
          Left := 0;
          Width := Screen.Width;
          //btnOK.caption := btnOK.Caption + ' button';
          //btnCancel.caption := btnCancel.Caption + ' button';
        end;
    end;
end;

procedure TfrmMHA_UploadAdmin.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with MHA_Registry do
    begin
    //  gvLastLocation := frmMHA_UploadResults.UploadAdministration.LocationIEN + U + cbxLocation.Text;
      // IEN^Location
      gvLastLocation := FLocationIEN + U + cbxLocation.Text;
      SaveRegistry;
    end;

end;

procedure TfrmMHA_UploadAdmin.cbxOrderedByChange(Sender: TObject);
//var
//  tmpDUZ                      : string;
begin
//  tmpDUZ := IntToStr(cbxOrderedBy.ItemIEN);

  FOrdererDUZ := IntToStr(cbxOrderedBy.ItemIEN);
  (*
  if not (tmpDUZ = '0')
    and not (tmpDUZ = frmMHA_UploadResults.UploadAdministration.Orderer.DUZ) then
    begin
      frmMHA_UploadResults.UploadAdministration.Orderer.Load(tmpDUZ,
        False {off-line}, DataModule1.RPCBroker1);
    end; *)
end;

procedure TfrmMHA_UploadAdmin.cbxOrderedByDropDown(Sender: TObject);
 // OnFormShow does not load cbxOrderedBy items because the method is very
 // slow, and in most cases the Administration.Orderer will indeed be the
 // User. This method will load the items the first time the user clicks
 // on the combobox's down arrow (i.e., when item.count = 0
begin

  if (cbxOrderedBy.Items.Count = 0) then
    begin
      cbxOrderedBy.InitLongList(ThisUser.Name);
      // Patch 129 fix for DUZ's with greater than 9 digits ; changed StrtoInt to StrToInt64 llh
      cbxOrderedBy.SelectByIEN(StrToInt64(ThisUser.DUZ));
    end;

end;

procedure TfrmMHA_UploadAdmin.cbxOrderedByNeedData(Sender: TObject;
  const StartFrom: string; Direction, InsertAt: Integer);
begin
  inherited;
  (Sender as TORComboBox).ForDataUse(Staff_OPS.LoadStaffSubSet(StartFrom,
    Direction, DataModule1.RPCBroker1));
end;

procedure TfrmMHA_UploadAdmin.cbxInterviewerChange(Sender: TObject);
//var
//  tmpDUZ                      : string;
begin
//  tmpDUZ := IntToStr(cbxInterviewer.ItemIEN);
  FAdminBy := IntToStr(cbxInterviewer.ItemIEN);

 // frmMHA_UploadResults.UploadAdministration.AdministeredBy := tmpDUZ;
end;

procedure TfrmMHA_UploadAdmin.cbxInterviewerDropDown(Sender: TObject);
// OnFormShow does not load cbxInterviewer items because the method is very
  // slow, and in most cases the Administration.AdministeredBy will indeed be the
  // User. This method will load the items the first time the user clicks
  // on the combobox's down arrow (i.e., when item.count = 0
begin
  if (cbxInterviewer.Items.Count = 0) then
    begin
      cbxInterviewer.InitLongList(ThisUser.Name);
      // Patch 129 fix for DUZ's with greater than 9 digits ; changed StrtoInt to StrToInt64 llh
      cbxInterviewer.SelectByIEN(StrToInt64(ThisUser.DUZ));
    end;

end;

procedure TfrmMHA_UploadAdmin.cbxConsultChange(Sender: TObject);
begin
  if cbxLocation.ItemIndex <> -1 then
    begin
      FConsultIEN :=
        Piece(cbxConsult.Items[cbxConsult.ItemIndex], U, 1);
    end
  else
    begin
      FConsultIEN := '';
    end;

end;

procedure TfrmMHA_UploadAdmin.cbxConsultDropDown(Sender: TObject);
begin
  // OnFormShow does not load cbxConsult items because the method is very
  // slow, and in most cases the consult will not change.
  // This method will load the items the first time the user clicks
  // on the combobox's down arrow (i.e., when item.count = 0

  if (cbxConsult.Items.Count = 0) then
    begin
      cbxConsult.Items.AddStrings(Consult_OPS.LoadConsultSubSet(FPatientDFN,
        DataModule1.RPCBroker1));
      cbxConsult.DropDownCount := cbxConsult.Items.Count - 1;
    end;

end;

procedure TfrmMHA_UploadAdmin.btnOKClick(Sender: TObject);
begin
  (*
  if (cbxOrderedBy.Items.Count = 0) then
    frmMHA_UploadResults.UploadAdministration.OrdererDUZForNewAdministrations := ThisUser.DUZ
  else
    frmMHA_UploadResults.UploadAdministration.OrdererDUZForNewAdministrations :=
      IntToStr(cbxOrderedBy.ItemIEN);

  if (cbxInterviewer.Items.Count = 0) then
    frmMHA_UploadResults.UploadAdministration.AdministeredBy := ThisUser.DUZ
  else
    frmMHA_UploadResults.UploadAdministration.AdministeredBy := IntToStr(cbxInterviewer.ItemIEN);
 *)
  if (cbxOrderedBy.Items.Count = 0) then
    OrdererDUZ := ThisUser.DUZ
  else
    OrdererDUZ := IntToStr(cbxOrderedBy.ItemIEN);

  if (cbxInterviewer.Items.Count = 0) then
    FAdminBy := ThisUser.DUZ
  else
    FAdminBy := IntToStr(cbxInterviewer.ItemIEN);

  FDiscontinue := false;
  Close;
end;

procedure TfrmMHA_UploadAdmin.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
    end;
end;

procedure TfrmMHA_UploadAdmin.btnCancelClick(Sender: TObject);
begin
  FDiscontinue := true;
  Close;
end;



procedure TfrmMHA_UploadAdmin.cbxLocationChange(Sender: TObject);
begin

  if cbxLocation.ItemIndex <> -1 then
    begin
      //frmMHA_UploadResults.UploadAdministration.LocationIEN := IntToStr(cbxLocation.ItemIEN);
      //frmMHA_UploadResults.UploadAdministration.LocationStr := cbxLocation.Text;
      FLocationIEN := IntToStr(cbxLocation.ItemIEN);
      FLocation := cbxLocation.Text;
    end
  else
    begin
      //frmMHA_UploadResults.UploadAdministration.LocationIEN := '';
      //frmMHA_UploadResults.UploadAdministration.LocationStr := '';
      FLocationIEN := '';
      FLocation := '';
    end;

end;

procedure TfrmMHA_UploadAdmin.cbxLocationNeedData(Sender: TObject;
  const StartFrom: string; Direction, InsertAt: Integer);
begin
  inherited;
  (Sender as TORComboBox).ForDataUse(SubSetOfLocations(StartFrom,
    Direction, DataModule1.RPCBroker1));
end;

procedure TfrmMHA_UploadAdmin.cbxLocationDropDown(Sender: TObject);
begin
  // OnFormShow does not load cbxLocation items because the method is very
   // slow, and in most cases the location will not change.
   // This method will load the items the first time the user clicks
   // on the combobox's down arrow (i.e., when item.count = 0

  if (cbxLocation.Items.Count = 0) then
    begin
      cbxLocation.InitLongList(cbxLocation.text);
      cbxLocation.SelectByIEN(StrToIntDef(Piece(gvLastLocation, U,
        1), 1));
    end;
end;

procedure TfrmMHA_UploadAdmin.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

end.

