unit uMHA_InstrumentResults;

interface

uses
  dialogs,
  comctrls,
  Contnrs,
  Classes;

type
  TIRKind = (irASI, irLegacy, irNew);

  TAResult = class
  private
    FKind: TIRKind;
    FAdministrationIENS,
      FName,
      FID,
      FDateSaved,
      FDateGiven,
      FOrderedBy,
      FAdminBy,
      FLocation,
      FPrivledge: string;
      //FComments: string;
    FUserHasPermissionToView,
      FAnswersAreInLegacyFile,
      //FCommentsExist,
    FWriteFullText,
      FIsMultiScale: Boolean;
    FTestIENS: Integer;

    //procedure Clear;
    (*
    function LoadReportTemplate(var ReportMemo: TRichEdit): string;
    function LoadLegacyTestReport(ADFN: string; var ReportMemo: TRichEdit):
      string;
    function LoadDefaultReport: string;
    function BuildSectionHeader(ACaption: string): string;
    function AddCommentsToReport: string;
    *)
  protected
  public
  (*
    procedure LoadScores;
    //procedure Load(ARecord: string);
    function LoadReport(ADFN: string; var ReportMemo: TRichEdit): string;
    function LoadReportIncomplete(AName,
      ADFN, AdminID: string; ADate: TDateTime; Legacy: boolean;
      var ReportMemo: TRichEdit): string;
      *)
    destructor Destroy; override;
    constructor Create;

    //procedure LoadKeys(WhichInstrument: string);
    //procedure LoadScales(WhichInstrument: string);
    (*
    function Score(AScaleName: string): string;
    function SaveComments: string;
    procedure LoadComments;
    *)
    property Kind: TIRKind read FKind write FKind;
    property AdministrationIENS: string read FAdministrationIENS write
      FAdministrationIENS;
    //   property DateStr: string read FDateStr write FDateStr;
    property Name: string read FName write FName;
    property Privledge: string read FPrivledge write FPrivledge;
    property UserHasPermissionToView: BOOLEAN read FUserHasPermissionToView write
      FUserHasPermissionToView;
    property IsMultiScale: BOOLEAN read FIsMultiScale write FIsMultiScale;
    property ID: string read FID write FID;
    property TestIENS: Integer read FTestIENS write FTestIENS;
    property WriteFullText: Boolean read FWriteFullText write FWriteFullText;
    property AnswersAreInLegacyFile: BOOLEAN read FAnswersAreInLegacyFile write
      FAnswersAreInLegacyFile;
    //property Comments: string read FComments write FComments;
    //property CommentsExist: BOOLEAN read FCommentsExist write FCommentsExist;
    property DateSaved: string read FDateSaved write FDateSaved;
    property DateGiven: string read FDateGiven write FDateGiven;
    property OrderedBy: string read FOrderedBy write FOrderedBy;
    property Location: string read FLocation write FLocation;
    property AdminBy: string read FAdminBy write FAdminBy;

  published
  end; { Result }

var
  AResult                     : TAResult;

implementation

uses
  uIA_Const,
  SysUtils,
  uIA_Utils,
  uIA_ThisUser;


destructor TAResult.Destroy;
begin
  inherited Destroy;
end;

constructor TAResult.Create;
begin
  inherited Create;
end;

(*
procedure TIResults.LoadScales(WhichInstrument: string);
begin
  ListOfScales.Clear;

  // See uMHA_Scales_IO
  if not ReadScales(WhichInstrument) then //
    ShowMessage('Unable to load scales for ' + WhichInstrument + '.');
end;

procedure TIResults.LoadKeys(WhichInstrument: string);
begin
  ListOfKeys.Clear;

  if not ReadScoringKeys(WhichInstrument) then // uMHA_Keys_IO
    ShowMessage('Unable to load the scoring keys for ' + WhichInstrument);
end;
 *)

  (*
procedure TResults.Clear;
begin
  FID := '';
  FAdministrationIENS := '';
  FName := '';
  FDateGiven := '';
  FDateSaved := '';
  FOrderedBy := '';
  FAdminBy := '';
  FLocation := '0';
  FKind := irNew;
  FPrivledge := '';
  FTestIENS := -1;
  FUserHasPermissionToView := False;
  FIsMultiScale := False;
  FIsCopyrighted := False;
  FAnswersAreInLegacyFile := False;
  FComments := '';
  FCommentsExist := False;
end; *)

(*
procedure TResults.Load(ARecord: string);

  function StrToIRKind(AKind: string): TIRKind;
  begin

    Result := irNew; //this will be the default
    if (AKind = 'ASI') then
      Result := irASI;
    if (AKind = 'Y') then
      Result := irLegacy;
  end;

var
  tmpValue, tmpExempt         : string;
begin
  Clear;
  if (ARecord = '') then
    Exit;

  //
  //    FList.Add(IntToStr(ID) + '='
  //    1  + tmpAdminID + U
  //    2  + tmpName + U
  //    3  + tmpDateGiven + U
  //    4  + tmpDateSaved + U
  //    5  + tmpIsLegacy + U
  //    6  + tmpYSP + U  Any key actually
  //    7  + tmpIENS + U
  //    8  + tmpIsCopyrighted + U
  //    9  + tmpOrderedBy + U
  //    10 + tmpAdminBy + U
  //    11 + tmpLocation);

  FID := Piece(ARecord, EQ, 1);

  tmpValue := Piece(ARecord, EQ, 2);
  FAdministrationIENS := Piece(tmpValue, U, 1);
  FName := Piece(tmpValue, U, 2);
  FDateGiven := Piece(tmpValue, U, 3);
  FDateSaved := Piece(tmpValue, U, 4);
  FKind := StrToIRKind(Piece(tmpValue, U, 5));
  // The key required to use this instrument is passed here.
  tmpExempt := Piece(tmpValue, U, 6);

  if tmpExempt = '' then
    FIsExempt := True
  else
    FIsExempt := False;

  FTestIENS := StrToIntDef(Piece(tmpValue, U, 7), -1);
  FIsCopyrighted := StrToBool(Piece(tmpValue, U, 8));
  FOrderedBy := Piece(tmpValue, U, 9);
  FAdminBy := Piece(tmpValue, U, 10);
  FLocation := Piece(tmpValue, U, 11);

  FUserHasPermissionToView := FIsExempt
    // or
    //((tmpExempt = 'YSP') and User.HasYSPKey) // Requires YSP key
  or
    ((Piece(User.ReadProperties(User.DUZ, tmpExempt), U, 3) = '1'));
    // Requires ANYKEY key

//**

  FIsMultiScale := (Scale_List.TotalNumberOfScaleNames > 2);
  FAnswersAreInLegacyFile := (StrToIntDef(FAdministrationIENS, -1) = -1);
end;*)

(*
function TResults.LoadLegacyTestReport(ADFN: string;
  var ReportMemo: TRichEdit): string;
var
  YSText                      : string;

const
  ErrorMsg                    = 'Unable to retrieve the report for this administration.' + CRLF;
begin
  Result := 'ERROR';

  if (InstrumentTResults.TestIENS < 0) then
    begin
      Result := ErrorMsg + 'No InstrumentTResults.TestIENS for ' +
        InstrumentTResults.Name + '.';
      Exit;
    end;

  if (FAdministrationIENS = '') then
    begin
      //Set YSText = FMDate of the test + ',' + test iens
      YSText := FDateSaved
        + ',' + IntToStr(FTestIENS);
      ReportMemo.Text := LegacyResultsReadTestReport1(ADFN, YSText);
    end
  else
    begin
      ReportMemo.Text := LegacyResultsReadTestReport2(ADFN, FAdministrationIENS);
    end;

  with ReportMemo do
    begin
    // remove excessive blank lines
      Text := StringReplace(Text, #13#10#13#10#13#10, #13,
        [rfReplaceAll, rfIgnoreCase]);
      Text := StringReplace(Text, #13#13#13, #13,
        [rfReplaceAll, rfIgnoreCase]);
      Text := StringReplace(Text, #13#13#13, #13,
        [rfReplaceAll, rfIgnoreCase]);

      SelStart := 0;
      SelLength := 9000;
      SelAttributes.Name := 'Courier New';
      SelAttributes.Size := GUI_Control.guiFont.Size;
      SelAttributes.Color := GUI_Control.guiFont.color;
      SelAttributes.Style := GUI_Control.guiFont.style;
    end;

  Result := 'OK';

end; *)

(*
function TResults.BuildSectionHeader(ACaption: string): string;
var
  tmpLine                     : string;
begin
  tmpLine := MySeparator;
  Insert(ACaption, tmpLine, Length(space) + 1);
  Result := CRLF
    + copy(tmpLine, 1, Length(tmpLine) - Length(ACaption)) + CRLF + CRLF;
end;

function TResults.LoadReportTemplate(var ReportMemo: TRichEdit):
  string;
var
  ReportID                    : string;
begin
  Result := 'ERROR';

  Instrument.Load(FName);

  Answers.Load(FAdministrationIENS);

  ReportID := '0';

  if MHA_Report.ReadRoughReport(Instrument.Name,
    InstrumentTResults.AdminBy,
    InstrumentResults.OrderedBy,
    InstrumentResults.Location,
    InstrumentResults.DateGiven,
    InstrumentResults.DateSaved,
    ReportMemo, ReportID) = 'ERROR' then
    exit;

  if ReportID = '0' then // No Report-Template
    begin

      with ReportMemo do
        begin
          Text := LoadDefaultReport;
          SelStart := 0;
          SelLength := 9000;
          SelAttributes.Name := 'Courier New';
          SelAttributes.Size := GUI_Control.guiFont.Size;
          SelAttributes.Color := GUI_Control.guiFont.color;
          SelAttributes.Style := GUI_Control.guiFont.style;
        end;

      Result := 'OK';
      exit;
    end;

  MHA_Report.FinalReport(ReportMemo, Answers.AnswerList, False {EditorMode});
  // Scripts processed.

  with ReportMemo do
    begin
      SelStart := 0;
      SelLength := 9000;
      SelAttributes.Name := GUI_Control.guiFont.Name;
      SelAttributes.Size := GUI_Control.guiFont.Size;
      SelAttributes.Color := GUI_Control.guiFont.color;
      SelAttributes.Style := GUI_Control.guiFont.style;
    end;

  Result := 'OK';
end;

function TResults.LoadDefaultReport: string;
var
  i, j                        : integer;
  tmpQuestionID,
    tmpQuest,
    tmpAns,
    tmpLine,
    tmpCaption,
    tmpScore                  : string;
const
  MyLine                      =
    '                                                                                ';
begin

  // These are instruments with scales
  //if InstrumentResults.Kind <> irNoScales then

  if Scale_List.NumberOfScaleGroups > 0 then
    begin
      LoadScores;
    end;

  //Instrument Section
  if (Instrument.PrintTitle = '') then
    tmpCaption := Result + Instrument.Name
  else
    tmpCaption := Result + Instrument.PrintTitle;

  Result := BuildSectionHeader('Instrument')
    + space + 'Name:       ' + tmpCaption + CRLF
    + space + 'Date Given: ' + FDateGiven + CRLF;

  //Patient Info Section
  Result := Result + BuildSectionHeader('Patient Information');

  Result := Result + space + 'Name:    ' + Patient.Name + CRLF
    + space + 'SSN:     ' + Patient.FormattedSSN + CRLF
    + space + 'Gender:  ' + Patient.Sex + CRLF
    + space + 'DOB:     ' + Patient.DOB + CRLF
    + space + 'Age:     ' + IntToStr(Patient.Age) + CRLF;

  //Scores Section
  //if InstrumentResults.Kind <> irNoScales then
  if Scale_List.NumberOfScaleGroups > 0 then
    begin
      Result := Result + BuildSectionHeader('Scores');
    //To get rid of extra line feed
      Result := DropTrailer(Result);

      for i := 0 to Scale_List.NumberOfScaleGroups - 1 do
        begin
          Scale_List.LoadScaleGroupByIndex(i);
          Result := Result + CRLF + space + ScaleGroup.Name + CRLF;

          for j := 0 to ScaleGroup.NumberOfScales - 1 do
            begin
              ScaleGroup.LoadScaleByIndex(j);
              tmpLine := MyLine;
              Insert(Scale.Name, tmpLine, 2 * Length(space));
              tmpScore := Score(Scale.Name);

              Insert(tmpScore, tmpLine, Scale_List.LengthOfLongestName + 12 -
                Length(tmpScore));
              tmpLine := TrimRight(tmpLine);
              Result := Result + tmpLine + CRLF;
            end; //j = NumberOfScales
        end; //i = NumberOfScaleGroups
    end;

  Result := Result + BuildSectionHeader('Answers');

  for i := 0 to Instrument.NumberOfQuestions - 1 do
    begin
      tmpQuestionID := Instrument.QuestionIDOnly(i);
      Question.Load(tmpQuestionID);

      tmpAns := Answers.ReadAnswer(tmpQuestionID);

      if (Question.ResponseType = rtMultiChoice) then
        case StrToIntDef(tmpAns, -1) of
          1155: tmpAns := SKIPPED;
          1156: tmpAns := SKIPPED_BY_RULE;
        else
          begin
            tmpAns := Question.MultiChoice.ChoiceIDToText(tmpAns);
          end;
        end; //case tmpAns

      if (Question.ResponseType <> rtMultiChoice) then
        case StrToIntDef(tmpAns, -1) of
          1155: tmpAns := SKIPPED;
          1156: tmpAns := SKIPPED_BY_RULE;
        end; //case tmpAns

      if Instrument.WriteFullText then
        tmpQuest := Question.Caption + CRLF + space + space + tmpAns
      else
        tmpQuest := Question.Designator + space + tmpAns;

      Result := Result + space + tmpQuest + CRLF;
    end;

  Result := DropTrailer(Result);

end;

function TResults.LoadReport(ADFN: string;
  var ReportMemo: TRichEdit): string;
begin

  if (FKind = irLegacy) then
    begin
      Result := LoadLegacyTestReport(ADFN, ReportMemo);
    end
  else
    begin
      Result := LoadReportTemplate(ReportMemo);
    end;
  if Result = 'ERROR' then
    exit;

  ReportMemo.text := ReportMemo.Text + AddCommentsToReport;
end;

function TResults.LoadReportIncomplete(AName,
  ADFN, AdminID: string; ADate: TDateTime; Legacy: boolean;
  var ReportMemo: TRichEdit): string;
begin
  FName := AName;
  FAdministrationIENS := AdminID;
  FDateGiven := DateToStr(ADate);

  if Legacy then
    begin
      FKind := irLegacy;
      Result := LoadLegacyTestReport(ADFN, ReportMemo)
    end
  else
    begin
      FKind := irNew;
      Result := LoadReportTemplate(ReportMemo);
    end;

  if Result = 'ERROR' then
    exit;

  ReportMemo.Text := ReportMemo.Text + AddCommentsToReport;
end;  *)


(*
function TResults.Score(AScaleName: string): string;

  function IsANumber(AScore: string): BOOLEAN;
  var
    i                         : integer;
    tmpCharacter              : string;
  begin
    if (AScore = '') then
      begin
        Result := False;
        Exit;
      end;

    Result := True;
    for i := 1 to Length(AScore) do
      begin
        tmpCharacter := copy(AScore, i, 1);
        if not (StrToIntDef(tmpCharacter, -1) > -1)
          and not (tmpCharacter = '.') then
          begin
            Result := False;
            Break;
          end;
      end;
  end;

var
  tmpValue, tmpScore          : string;
  tmpScoreInt                 : integer;
  AddOne                      : BOOLEAN;
begin
  if (FScores.IndexOfName(AScaleName) = -1) then
    tmpScore := 'X'
  else
    begin
      tmpValue := FScores.Values[AScaleName];
      tmpScore := Piece(tmpValue, U, 2);
      if IsANumber(tmpScore) then
        begin
      //convert real number to integer
          if (pos('.', tmpScore) > 0) then
            begin
              tmpScoreInt := StrToIntDef(Piece(tmpScore, '.', 1), 0);
              AddOne := (StrToIntDef(copy(Piece(tmpScore, '.', 2), 1, 1), 0) >
                4);
              if AddOne then
                inc(tmpScoreInt);
              tmpScore := IntToStr(tmpScoreInt);
            end;
        end
      else
        tmpScore := Piece(tmpValue, U, 1);

    //To get rid of leading zero's
      if (StrToIntDef(tmpScore, -99) > -99) then
        tmpScore := IntToStr(StrToInt(tmpScore));
    end;

  Result := tmpScore;

end;

procedure TResults.LoadScores;
var
  tmpScores                   : string;
begin

  tmpScores := ReadScores(FAnswersAreInLegacyFile, FAdministrationIENS, FName,
    Patient.DFN, FDateSaved);

  if (tmpScores = BAD_DATA) then
    FScores.Clear
  else
    PiecesToList(tmpScores, RECORD_END, FScores);

end;

function TResults.SaveComments: string;
begin
  //Result := WriteComments(FAdministrationIENS, FComments);
end;

procedure TResults.LoadComments;
begin

  FComments := ReadComments(FAdministrationIENS);
  if (FComments = BAD_DATA) then
    FComments := '';

  FCommentsExist := not (FComments = '');

end;

function TResults.AddCommentsToReport: string;
begin
  if (FAdministrationIENS = '') then
    begin
      Result := '';
      Exit;
    end;

  LoadComments;
  if FCommentsExist then
    begin
      Result := Result + CRLF + BuildSectionHeader('Comments') + FComments;
      Result := StringReplace(Result, RECORD_END, CRLF, [rfReplaceAll]);
    end;

end;   *)

end.

