unit uMHA_Location_IO;

interface

uses
  Classes,
  Trpcb,
  Sysutils;

function SubSetOfLocations(const StartFrom: string; Direction: Integer;
  Broker: TRPCBroker):
  TStrings;
function LocationIndexToName(aIENS: string; Broker: TRPCBroker): string;

implementation

uses
  uIA_Utils,
  uIA_Const,
  uMHA_LocalFiles,
  uMHA_Const;

function SubSetOfLocations(const StartFrom: string; Direction: Integer;
  Broker: TRPCBroker):
  TStrings;
{ returns a pointer to a list of locations (for use in a long list box) -  The return value is
a pointer to RPCBroker1.Results, so the data must be used BEFORE the next broker call! }
begin

  with Broker do
    begin
      ClearResults := True;

    //To prevent an undefined result
      Result := Results;
      if not (DataBaseMode = dbVista) then
        Exit;

      ClearParameters := True;
      CreateContext('OR CPRS GUI CHART');
      //* LocalFiles.UpdateAPILog('Call to ORWU HOSPLOC.');
      RemoteProcedure := 'ORWU HOSPLOC';
      Param[0].Value := StartFrom;
      Param[1].Value := IntToStr(Direction);
      Param[0].PType := literal;
      Param[1].PType := literal;

      try
        Call;

      except
        on E: EBrokerError do
          begin
            //* LocalFiles.UpdateAPILog('Call to ORWU HOSPLOC: Error ');
            //* LocalFiles.UpdateAPILog('   ' + 'Broker Error: ' + E.message);
            exit;
          end;
        on E: EAccessViolation do
          begin
            //* LocalFiles.UpdateAPILog('Call to ORWU HOSPLOC: Error ');
            //* LocalFiles.UpdateAPILog('   ' + 'Access Violation: ' + E.message);
            exit;
          end;
      end; // try

      MixedCaseList(Results);
      Result := Results;
      //* LocalFiles.UpdateAPILog('Call to ORWU HOSPLOC: Successful');
    end;
end;

function LocationIndexToName(aIENS: string; Broker: TRPCBroker): string;
var
  i                           : integer;
begin
  result := '';

  with Broker do
    begin
      ClearParameters := True;
      ClearResults := True;
      //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: 44, .01, ' + aIENS + '.');
      CreateContext('YS BROKER1');
      RemoteProcedure := 'YTQ CAPIE';
      Param[0].Mult['"FILEN"'] := '44';
      Param[0].Mult['"FIELDS"'] := '.01';
      Param[0].Mult['"IENS"'] := aIENS;
      Param[0].PType := List;

      try
        Call;

      except
        on E: EBrokerError do
          begin
            //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: Error ');
            //* LocalFiles.UpdateAPILog('   ' + 'Broker Error: ' + E.message);
            exit;
          end;
        on E: EAccessViolation do
          begin
            //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: Error ');
            //* LocalFiles.UpdateAPILog('   ' + 'Access Violation: ' + E.message);
            exit;
          end;
      end; // try

      // Returns:
      //[DATA]
      //12^Name^2 NORTH

      if not (Results[0] = DATA) then
        begin
          //* LocalFiles.UpdateAPILog('Call to YTQ CAPIE: Error ');
          //* if Results.Count > 0 then
            //* LocalFiles.UpdateAPILog('   ' + 'Access Violation: ' + Results[1]);
          Result := '';
        end
      else
        begin
          if Results.Count > 0 then
            begin
              for i := 1 to Results.Count - 1 do
                if POS('NAME', Results[i]) > 0 then
                  Result := Piece(Results[1], U, 3);
            end;
        end;
    end;
end;

end.

