unit uMHA_Vista_IO;

interface

uses
  Trpcb;

function SendHL7Message(
  anAdministrationID: string;
  Broker: TRPCBroker): string;

//function AnswerWriteComment(const AFileNumber: string; const AIEN: string;
//  const AField: string; const ACommentString: string): Boolean;

implementation

uses
  uIA_Const;

const
 //Following constants borrowed from CPRS

  TX_VER1                     = 'This is version ';
  TX_VER2                     = ' of YS_MHA.DLL.';
  TX_VER3                     = #13 + 'The running server version is ';
  TX_VER_REQ                  = ' version server is required.';
  TX_VER_OLD                  = #13 + 'It is strongly recommended that you upgrade.';
  TX_VER_OLD2                 = #13 +
    'The program cannot be run online until the CLIENT is upgraded.';
  TX_VER_NEW                  = #13 +
    'The program cannot be run online until the SERVER is upgraded.';

 { values that can be passed to FileVersionValue }
  FILE_VER_FILEVERSION        = '\StringFileInfo\040904E4\FileVersion';
  FILE_VER_INTERNALNAME       = '\StringFileInfo\040904E4\InternalName';
  FILE_VER_PRODUCTVERSION     = '\StringFileInfo\040904E4\ProductVersion';



function SendHL7Message(anAdministrationID: string;
  Broker: TRPCBroker): string;
begin
  //NAME: YTQ HL7
  //    Input: AD as administration ID
  //    Output : DATA vs ERROR
  result := '';
  with Broker do
    begin
      ClearParameters := True;
      ClearResults := True;
      CreateContext('YS BROKER1');
      RemoteProcedure := 'YTQ HL7';
      Param[0].Mult['"AD"'] := anAdministrationID;
      Param[0].PType := List;
      Call;
      Result := Results[0];
    end;
end;

    (*
function AnswerWriteComment(const AFileNumber: string; const AIEN: string;
  const AField: string; const ACommentString: string): BOOLEAN;
var
  i                           : integer;
  YS                          : string;
begin

  with DataModule1.RPCBroker1 do
    begin
      ClearParameters := True;
      ClearResults := True;
      RemoteProcedure := 'YTQ WP FILER';
      Param[0].Mult['"FILEN"'] := AFileNumber;
      Param[0].Mult['"IEN"'] := AIEN;
      Param[0].Mult['"FIELD"'] := AField;

      for i := 1 to NumberOfPieces(ACommentString, U) do
        begin
          YS := '"' + IntToStr(i) + '"';
          Param[0].Mult[YS] := Piece(ACommentString, U, i);
        end;

      Param[0].PType := List;

      Call;

      Result := (Results[0] = DATA);

    end;

end; *)

end.

