unit fMHA_DLL_DataEntry;

interface

uses
  Windows,
  Messages,
  SysUtils,
  DateUtils,
  Classes,
  Graphics,
  Controls,
  Contnrs,
  Forms,
  Dialogs,
  Printers,
  StdCtrls,
  ComCtrls,
  ExtCtrls,
  ORCtrls,
  Mask,
  RzRadGrp,
  RzSpnEdt,
  uIA_Instrument,
  uIA_Question,
  Menus,
  RzChkLst,
  RzLstBox,
  Buttons,
  ExTrackBar,
  RzLabel,
  RzPanel,
  JvValidateEdit,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons,
  JvProgressBar,
  JvXPProgressBar,
  JvExStdCtrls,
  JvEdit,
  JvExMask,
  JvToolEdit,
  JvMaskEdit,
  JvCheckedMaskEdit,
  JvDatePickerEdit,
  JvXPCheckCtrls,
  JvComputerInfoEx,
  Trpcb, JvComponentBase;

type
  TfrmMHA_DLL_DataEntry = class(TForm)
    pnlTop: TPanel;
    tbctrlRight: TTabControl;
    sbDataEntry: TScrollBox;
    pnlBottom: TPanel;
    btnFinished: TJvXPButton;
    btnCancel: TJvXPButton;
    pnlStatus: TRzStatusBar;
    prgbrStatus: TJvXPProgressBar;
    cbSpeedTab: TJvXPCheckbox;
    JvComputerInfoEx1: TJvComputerInfoEx;
    lblHint: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShutDown;

    procedure BuildForm;
    procedure BuildEvents;
    procedure BuildTabsRight;
    function AdjustTabWidth: Integer;
    function GetDPI: Integer;
    function GetDefaultEntry(QID: integer): string;
    function GetFormerAnswer(QID: string): string;
    function GetChoiceOnly(StringIn: string): string;
    function GetLegacyValue(aQuestionID, ItemIndexStr: string): string;
    function GetChoiceID(aQuestionID, ItemIndexStr: string): string;
    function GetItemIndex(aQuestionID, ChoiceID: string): string;

    //--------------------------------------------------------------------------
    procedure HighlightTurnOff;
    procedure CenterComponentInScrollBox(TopIn: Integer);
    procedure HighlightRadioGroup(Sender: TObject);
    procedure HighlightLabel(NameIn: string);
    procedure HighlightMemo(Sender: TObject);
    procedure HighlightSpinEdit(Sender: TObject);
    procedure HighlightCurrency(Sender: TObject);
    procedure HighlighTJvDatePickerEdit(Sender: TObject);
    procedure HighlightCheckListBox(Sender: TObject);
    procedure HighlightListBox(Sender: TObject);
    procedure HighlightComboBox(Sender: TObject);
    procedure HighlightORComboBox(Sender: TObject);
    procedure HighlightMaskEdit(Sender: TObject);
    procedure HighlightTrackBar(Sender: TObject);
    procedure HighlightEdit(Sender: TObject);
    procedure HighlightTrackBarLabel(NameIn: string;
      WhichOne: byte);
    procedure HighlightGroupBox(Sender: TObject);

    function IsEnabled(TagIn: integer): Boolean;
    procedure UpdateComponentsAndAnswerList(aQID, aAnswer: string);
    procedure GetScaleScore;

    //--------------------------------------------------------------------------
    function KeyPressRadioGroup(K: word; CurrentRadioGrp: string): Boolean;
    function KeyPressTrackBar(K: word; LastTrackBar: string): boolean;
    function KeyPressListBox(K: word; CurrentListBox: string): boolean;
    function KeyPressComboBox(K: word; CurrentComboBox: string): Boolean;
    procedure OnExitEvent(sender: TObject);
    procedure OnChangeEvent(sender: TObject);
    procedure OnClickLabel(sender: TObject);
    procedure OnClickRadioGroup(Sender: TObject);
    procedure OnClickListBox(Sender: TObject);
    procedure OnClickComboBox(Sender: TObject);
    procedure OnChangeTrackBar(Sender: TObject);
    procedure OnChangeCheckList(Sender: TObject;
      Index: Integer; NewState: TCheckBoxState);
    procedure DoubleClickMessage(Sender: TObject);
    procedure CheckForRule(QID, Answer: string);
    //function CheckForCustomOperation: Boolean;
    procedure UpdateStatusBar(NewCaption: string);
    procedure RecordAnswer(QID, aAnswerValue, aAnswerText, aIsMultiChoice: string);
    procedure GoToFirstItem;
    procedure tbctrlRightChange(Sender: TObject);
    procedure cmbStaffNeedData(Sender: TObject;
      const StartFrom: string; Direction, InsertAt: Integer);
    procedure btnCancelClick(Sender: TObject);
    procedure btnFinishedClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ProcessAnswer(QID, Answer: string);
    procedure IsScreenReaderInUse;
    procedure cbSpeedTabClick(Sender: TObject);
    function VerifyAnswers: Boolean;
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    //FRPCBroker : TRPCBroker;
  public
    { Public declarations }
    //property deBroker: TRPCBroker read FRPCBroker Write FRPCBroker;
  end;

var
  frmMHA_DLL_DataEntry        : TfrmMHA_DLL_DataEntry;

implementation

{$R *.DFM}

uses
  uIA_Const,
  uMHA_DLL_Const,
  uMHA_DLL_Registry,
  fIA_Dialogs,
  uIA_GUIControl,
  uIA_Introduction,
  uIA_SectionLabel,
  uIA_Display,
  uIA_Answer,
  uIA_Scale,
  uIA_Key,
  uIA_Keys_IO,
  uIA_Utils,
  uIA_Build,
  uIA_Patient,
  uIA_Staff_OPS,
  uIA_Consult_OPS,
  uIA_Rule_OPS;

const
  lcStartComponent            : integer = 5;

var
  lvRightTab                  : array[0..RIGHT_TAB_MAX] of Integer; // Scroll bar locators for current form

  lvNumberOfSkippedAnswers    : Integer;

  lvInitialize                : Boolean;

  lvDateSeparator,
    lvTimeSeparator           : Char;

  lvLongTimeFormat,
    lvShortDateFormat,
    lvOldRules                : string;


procedure TfrmMHA_DLL_DataEntry.FormCreate(Sender: TObject);
var
  CPRSFont                    : HFONT;
begin
  lvInitialize := True; // defeat OnChange, OnExit & OnEnter events

  // The screen dimensions are set to the user's last setting.
  MHA_DLL_Registry.ReadRegistry;

  Top := gvTop;
  Left := gvLeft;
  Height := gvHeight;
  if Height < 300 then
    Height := 300;
  Width := gvWidth;
  if Width < 400 then
    Width := 400;
  gvUseDesignFont := True;

  // Look for CPRS main window's class
  gvCPRS_Instance_Handle := FindWindow('TfrmFrame', nil); //CPRS
  if gvCPRS_Instance_Handle <> 0 then // Window found
    begin
      CPRSFont := SendMessage(gvCPRS_Instance_Handle, WM_GETFONT, 0, 0);
      gvFont := MakeFontFromHFont(CPRSFont);
    end;

  Font.Assign(gvFont);
  GUI_Control.ConfigureGUI(gvFont);

  // Since TDate & TDateTime, used in this program, are set by the user
  // for this PC, we will set them to our standard and return them to user
  // settings at close.
  lvDateSeparator := FormatSettings.DateSeparator;
  FormatSettings.DateSeparator := '/';
  lvTimeSeparator := FormatSettings.TimeSeparator;
  FormatSettings.TimeSeparator := ':';
  lvShortDateFormat := FormatSettings.ShortDateFormat;
  FormatSettings.ShortDateFormat := 'MM/dd/yyyy';
  lvLongTimeFormat := FormatSettings.LongTimeFormat;
  FormatSettings.LongTimeFormat := 'hh:nn:ss AM/PM';

  IsScreenReaderInUse;

  gvScrollBarWidthWS := TextWidthbyFont(Font.handle, 'XXXX');
  // While it may seem unnecessary, those with DPI settings at 120,
  // instead of 96, will defeat the GUI's "normal" arrangements when
  // IDE is set to 96.
  btnCancel.Left := btnCancel.Width div 3;
  btnFinished.Left := pnlBottom.Width - btnFinished.Width - btnFinished.Width div 3;
  cbSpeedTab.Left := btnCancel.Width + (2 * btnCancel.Width div 3);
  lblHint.Left := cbSpeedTab.Left;
  prgbrStatus.Left := pnlStatus.Width div 2;
  prgbrStatus.Width := (pnlStatus.Width div 2) - 20;
  lvOldRules := '';

  BuildForm;
  BuildTabsRight;

  ShowModal;

end;


procedure TfrmMHA_DLL_DataEntry.FormShow(Sender: TObject);
begin
  BuildEvents;

  Caption := gvInstrument.InstrumentName + ': ' + Patient.Name + '  ';

  cbSpeedTab.Checked := gvSpeedTab;
  if cbSpeedTab.Checked then
    lblHint.caption := 'Hint: Use the number key of the item to speed data entry.'
  else
    lblHint.caption := 'Hint: Press carriage return to move to next question.';

  if gvUseScreenReader then
    begin
      cbSpeedTab.Visible := False;
      lblHint.Visible := False;
      prgbrStatus.Visible := False;
      gvSpeedTab := False;
    end;

  if gvInstrument.ListOfQuestions.Count > 0 then
    GoToFirstItem;

  lvInitialize := False; // return to normal component functioning
  // This will update status bar
  RecordAnswer('', '', '', '');

  screen.cursor := crDefault;

end;

procedure TfrmMHA_DLL_DataEntry.FormActivate(Sender: TObject);
begin
  if (gvFirstUse) and
    (not gvUseScreenReader) then
    begin
      cbSpeedTab.Checked := True;
      MsgDlgFrm('For much faster data entry, use the number key ' + #13 +
        'that corresponds to the answer. The focus will ' + #13 +
        'move to the next question automatically.',
        'First use instructions', mtInformation, [mbOK], 0);
      gvFirstUse := False;
      //MHA_DLL_Registry.SaveRegistry;
    end;
end;


procedure TfrmMHA_DLL_DataEntry.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin

  FormatSettings.DateSeparator := lvDateSeparator;
  FormatSettings.TimeSeparator := lvTimeSeparator;
  FormatSettings.ShortDateFormat := lvShortDateFormat;
  FormatSettings.LongTimeFormat := lvLongTimeFormat;

  gvTop := Top;
  gvLeft := Left;
  gvHeight := Height;
  gvWidth := Width;

  MHA_DLL_Registry.SaveRegistry;
  Action := caFree;
end;

procedure TfrmMHA_DLL_DataEntry.ShutDown;
begin
  Application.Terminate;
end;


procedure TfrmMHA_DLL_DataEntry.IsScreenReaderInUse;
var
  ListStateOn                 : longbool;
  Success                     : longbool;
begin
  //Determine if a screen reader, like JAWS, is currently being used.
{$WARN UNSAFE_CODE OFF}
  Success := SystemParametersInfo(SPI_GETSCREENREADER, 0, @ListStateOn, 0);
{$WARN UNSAFE_CODE ON}
  if Success and ListStateOn then
    gvUseScreenReader := True
  else
    gvUseScreenReader := False;
end;

function TfrmMHA_DLL_DataEntry.GetFormerAnswer(QID: string): string;
var
  i                           : Integer;
  TempAns                     : string;
  TempStrList                 : TStringList;

begin
  Result := '';

  if gvSaveTempToVista then
    begin
      for i := 0 to gvInstrument.ListOfAnswers.Count - 1 do
        begin

          if QID = TAnswer(gvInstrument.ListOfAnswers[i]).QuestionID then
            begin
              TempAns := TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue;

              if (TempAns = NOT_ASKED) or (TempAns = SKIPPED) or
                (TempAns = '1155') or (TempAns = '1156') or
                (TempAns = '1157') then
                Exit;

              if TAnswer(gvInstrument.ListOfAnswers[i]).IsMultiChoice then
                Result := GetItemIndex(TAnswer(gvInstrument.ListOfAnswers[i]).QuestionID,
                  TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue)
              else
                Result := TAnswer(gvInstrument.ListOfAnswers[i]).AnswerText;
            end; // QID =
        end; // for i
    end
  else
    begin

      TempStrList := TStringList.Create;
      TempStrList.LoadFromFile(gvFileName);

// Format is:
//  543^512^Yes^Y^YES^
//  544^513^No^N^YES^
//  545^512^Yes^Y^YES^
//  546^513^No^N^YES^

      for i := 0 to TempStrList.Count - 1 do
        if QID = Piece(TempStrList[i], U, 1) then
          begin
            TempAns := Piece(TempStrList[i], U, 2);

            if (TempAns = NOT_ASKED) or (TempAns = SKIPPED) or
              (TempAns = '1155') or (TempAns = '1156') or
              (TempAns = '1157') then
              Exit;

            if Piece(TempStrList[i], U, 5) = YES then // Multiple Choice
              Result := GetItemIndex(Piece(TempStrList[i], U, 1), Piece(TempStrList[i], U, 2))
            else
              Result := Piece(TempStrList[i], U, 3)
          end;

      TempStrList.Free;
    end;
end;

procedure TfrmMHA_DLL_DataEntry.cmbStaffNeedData(Sender: TObject;
  const StartFrom: string; Direction, InsertAt: Integer);
begin
  inherited;

  (Sender as TORComboBox).ForDataUse(Staff_OPS.LoadStaffSubSet(StartFrom,
    Direction, gvBroker));
end;



//------------------------------------------------------------------------------
//       Highlight operations
//------------------------------------------------------------------------------

procedure TfrmMHA_DLL_DataEntry.HighlightTurnOff;
// "OnEnter" event activates this procedure.
//  1) Turn off highlight on all items.
var
  i                           : Integer;
begin

  with GUI_Control do
    begin
      for i := lcStartComponent to ComponentCount - 1 do
        begin
          if Components[i] is TGroupBox then
            with TGroupBox(Components[i]) do
              begin
                Color := clBtnFace;
                Font.Color := gvFont.Color;
              end;
          if Components[i] is TRzRadioGroup then
            with TRzRadioGroup(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                    ItemFont.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TEdit then
            with TEdit(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TJvValidateEdit then
            with TJvValidateEdit(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TComboBox then
            with TComboBox(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TORComboBox then
            with TORComboBox(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TJvDatePickerEdit then
            with TJvDatePickerEdit(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TExTrackBar then
            with TExTrackBar(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TRzSpinEdit then
            with TRzSpinEdit(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TLabel then
            with TLabel(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TMemo then
            with TMemo(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TMaskEdit then
            with TMaskEdit(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TRzCheckList then
            with TRzCheckList(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
          if Components[i] is TRzListBox then
            with TRzListBox(Components[i]) do
              begin
                if Enabled then
                  begin
                    Color := clWindow;
                    Font.Color := gvFont.Color;
                  end
                else
                  begin
                    Color := clBtnFace;
                    Font.Color := gvFont.Color;
                  end;
              end;
        end;
    end;
end;

procedure TfrmMHA_DLL_DataEntry.CenterComponentInScrollBox(TopIn: Integer);
var
  i                           : Integer;
begin
  if not gvSpeedTab then
    Exit;

  // Place the control in the middle of the scroll box.
  if TopIn > sbDataEntry.Height div 2 then
    sbDataEntry.VertScrollBar.Position :=
      sbDataEntry.VertScrollBar.Position + TopIn - (sbDataEntry.Height div 2);

  // Ensure the proper right tab is active.
  if tbctrlRight.Visible then
    begin
      with sbDataEntry.VertScrollBar do
        for i := 0 to (RIGHT_TAB_MAX - 1) do
          if ((Position >= lvRightTab[i]) and (Position < lvRightTab[i + 1])) then
            tbctrlRight.TabIndex := i;
    end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightRadioGroup(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TRzRadioGroup then
    with Sender as TRzRadioGroup do
      begin
        //CenterComponentInScrollBox(Top);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightTrackBar(Sender: TObject);
begin
  HighlightTurnOff;
  if Sender is TExTrackBar then
    with Sender as TExTrackBar do
      begin
        CenterComponentInScrollBox(Top);
        HighlightTrackBarLabel(Name, 1);
        HighlightTrackBarLabel(Name, 2);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightEdit(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TEdit then
    with Sender as TEdit do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightGroupBox(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TGroupBox then
    with Sender as TGroupBox do
      begin
        CenterComponentInScrollBox(Top);
        //HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightMaskEdit(Sender: TObject);
begin
  HighlightTurnOff;
  if Sender is TMaskEdit then
    with Sender as TMaskEdit do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightCheckListBox(Sender: TObject);
begin

  HighlightTurnOff;

  with Sender as TRzCheckList do
    begin
      CenterComponentInScrollBox(Top);
      HighLightLabel(Name);
      Color := gvHighlightBackground;

      // It makes no sense at all, but placing the following line in OnEnter
      // event where it logically belongs will cause the first item to be
      // checked, regardless of the item that is clicked, when the CheckBox is
      // entered with a click event.
      // Font.Color := gvHighlightForeground;
      // The line is now in the OnChange event.
    end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightListBox(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TRzListBox then
    with Sender as TRzListBox do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightComboBox(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TComboBox then
    with Sender as TComboBox do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightORComboBox(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TORComboBox then
    with Sender as TORComboBox do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlighTJvDatePickerEdit(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TJvDatePickerEdit then
    with Sender as TJvDatePickerEdit do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightSpinEdit(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TRzSpinEdit then
    with Sender as TRzSpinEdit do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightCurrency(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TJvValidateEdit then
    with Sender as TJvValidateEdit do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightLabel(NameIn: string);
var
  i                           : Integer;
  LabelToHighlight            : string;
begin
  LabelToHighlight := NameIn;
  Delete(LabelToHighlight, 1, 3);
  LabelToHighlight := 'lbl' + LabelToHighlight;

  for i := lcStartComponent to ComponentCount - 1 do
    begin
      if Components[i] is TLabel then
        with TLabel(Components[i]) do
          begin
            if Name = LabelToHighlight then
              begin
                Color := gvHighlightBackground;
                Font.Color := gvHighlightForeground;
              end;
          end;
    end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightTrackBarLabel(NameIn: string;
  WhichOne: byte);
var
  i                           : Integer;
  LabelToHighlight            : string;
begin
  LabelToHighlight := NameIn;
  Delete(LabelToHighlight, 1, 3);
  if WhichOne = 1 then
    LabelToHighlight := cTrackBarLabel1 + LabelToHighlight
  else
    LabelToHighlight := cTrackBarLabel2 + LabelToHighlight;

  for i := lcStartComponent to ComponentCount - 1 do
    begin
      if Components[i] is TLabel then
        with TLabel(Components[i]) do
          begin
            if Name = LabelToHighlight then
              begin
                Color := gvHighlightBackground;
                Font.Color := gvHighlightForeground;
              end;
          end;
    end;
end;

procedure TfrmMHA_DLL_DataEntry.HighlightMemo(Sender: TObject);
begin
  HighlightTurnOff;

  if Sender is TMemo then
    with Sender as TMemo do
      begin
        CenterComponentInScrollBox(Top);
        HighLightLabel(Name);
        Color := gvHighlightBackground;
        Font.Color := gvHighlightForeground;
      end;
end;

//------------------------------------------------------------------------------
//       Skip Questions: Enable/Disable Questions
//------------------------------------------------------------------------------

function TfrmMHA_DLL_DataEntry.IsEnabled(TagIn: Integer): Boolean;
// Rule_OPS.SkipQuestions is a list of QuestionIDs. If the current question
// is one the list, then make it disabled.
var
  i                           : Integer;
begin
  Result := true;

  if Pos(U + InttoStr(TagIn) + U, Rule_OPS.SkipQuestions) > 0 then
    begin
      RecordAnswer(InttoStr(TagIn), CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION,
        CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION, YES);
      Result := False;
    end;

  // Handle questions that were once set to "skipped by rule" but are now
  // okay to answer. Remove the "1156"
  if (Pos(U + InttoStr(TagIn) + U, lvOldRules) > 0) and
    (Pos(U + InttoStr(TagIn) + U, Rule_OPS.SkipQuestions) = 0) then
    begin
      for i := 0 to gvInstrument.ListOfAnswers.Count - 1 do
        if InttoStr(TagIn) = TAnswer(gvInstrument.ListOfAnswers[i]).QuestionID then
          if TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue =
            CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION then
            RecordAnswer(InttoStr(TagIn), NOT_ASKED, NOT_ASKED, '');
    end;
end;


procedure TfrmMHA_DLL_DataEntry.UpdateComponentsAndAnswerList(aQID, aAnswer: string);
// When a OnChange event occurs there may be one or more components that may need
// to be enabled/disabled, or inconsistencies to be flagged for the user.
var
  i                           : integer;
  QID, Answer                 : string;
begin
  QID := aQID;
  Answer := aAnswer;

  for i := lcStartComponent to ComponentCount - 1 do
    begin

      if Components[i] is TRzRadioGroup then
        with TRzRadioGroup(Components[i]) do
          begin
            Enabled := IsEnabled(Tag {QuestionID});
            if IntToStr(Tag) = QID then
              begin
                if ItemIndex <> -1 then
                  RecordAnswer(QID,
                    IntToStr(ItemIndex),
                    GetChoiceOnly(Items[ItemIndex]),
                    YES {MultiChoice});
              end;
          end;

      if Components[i] is TRzListBox then
        with TRzListBox(Components[i]) do
          begin
            Enabled := IsEnabled(Tag {QuestionID});
            if IntToStr(Tag) = QID then
              begin // ItemIndex cannot be -1 here
                RecordAnswer(QID,
                  IntToStr(ItemIndex),
                  GetChoiceOnly(Items[ItemIndex]),
                  YES {MultiChoice});
              end;
          end;

      if Components[i] is TRzCheckList then
        with TRzCheckList(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            // This component has already been saved. It has special processing
            // handled at the OnChange event.
          end;

      if Components[i] is TEdit then
        with TEdit(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, '', Answer, NO {MultiChoice});
          end;

      if Components[i] is TJvValidateEdit then
        with TJvValidateEdit(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, '', Answer, NO {MultiChoice});
          end;

      if Components[i] is TComboBox then
        with TComboBox(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, Answer, Text, YES {MultiChoice});
          end;

      if Components[i] is TORComboBox then
        with TORComboBox(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              begin
                if Pos(cComboBoxConsult, Name) > 0 then
                  RecordAnswer(QID, Piece(Items[ItemIndex], U, 1), {ConsultIEN}
                    Piece(Items[ItemIndex], U, 7), {Consult Name Text}
                    NO {MultiChoice})
                else
                  RecordAnswer(QID, Answer, Text, NO {MultiChoice});
              end;
          end;

      if Components[i] is TJvDatePickerEdit then
        with TJvDatePickerEdit(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, '', Answer, NO {MultiChoice});
          end;

      if Components[i] is TExTrackBar then
        with TExTrackBar(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, '', Answer, NO {MultiChoice});
          end;

      if Components[i] is TRzSpinEdit then
        with TRzSpinEdit(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, '', Answer, NO {MultiChoice});
          end;

      if Components[i] is TLabel then
        begin
          if (Pos(cSection, TLabel(Components[i]).Name) > 0) or
            (Pos(cIntroduction, TLabel(Components[i]).Name) > 0) then // do nothing
          else
            TLabel(Components[i]).Enabled :=
              IsEnabled(TLabel(Components[i]).Tag);
        end;

      if Components[i] is TMemo then
        with TMemo(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, '', Answer, NO {MultiChoice});
          end;

      if Components[i] is TMaskEdit then
        with TMaskEdit(Components[i]) do
          begin
            Enabled := IsEnabled(Tag);
            if IntToStr(Tag) = QID then
              RecordAnswer(QID, '', Answer, NO {MultiChoice});
          end;

    end;
end;

//------------------------------------------------------------------------------
//       Key Press and Mouse Events
//------------------------------------------------------------------------------


function TfrmMHA_DLL_DataEntry.KeyPressListBox(K: word; CurrentListBox: string): boolean;
var
  i, Choice                   : Integer;
begin
  Result := False;

  Choice := KeyToNumber(K);
  if Choice = -2 then
    Exit;
  if Choice = -1 then
    begin
      MessageBeep(MB_ICONASTERISK);
      //if gvVisualBeeps then
      //  MsgDlgFrm('Wrong key.', MHA_CAPTION,
      //    mtError, [mbOk], 0);
      Exit;
    end;

  for i := 0 to ComponentCount - 1 do
    begin
      // Find the Combo Box that has focus
      if Components[i] is TRzListBox then
        if TRzListBox(Components[i]).Name = CurrentListBox then
          begin
            Choice := AdjustKeyToItemIndex(Choice,
              TRzListBox(Components[i]).Items.Count,
              TRzListBox(Components[i]).Items[0]);
            if Choice = -1 then
              begin
                MessageBeep(MB_ICONASTERISK);
                //if gvVisualBeeps then
                //  MsgDlgFrm('Wrong key.', MHA_CAPTION,
                //    mtError, [mbOk], 0);
                Exit;
              end;
            TRzListBox(Components[i]).ItemIndex := Choice;
            Result := true;
            ProcessAnswer(IntToStr(TRzListBox(Components[i]).Tag),
              IntToStr(TRzListBox(Components[i]).ItemIndex));
          end;
    end;
end;


function TfrmMHA_DLL_DataEntry.KeyPressRadioGroup(K: word; CurrentRadioGrp: string): boolean;
var
  i, Choice, TempInt          : Integer;

begin
  Result := False;

  Choice := KeyToNumber(K);
  if Choice = -2 then
    Exit;
  if Choice = -1 then
    begin
      MessageBeep(MB_ICONASTERISK);
      //if gvVisualBeeps then
      //  MsgDlgFrm('Wrong key.', MHA_CAPTION,
      //    mtError, [mbOk], 0);
      Exit;
    end;

  for i := 0 to ComponentCount - 1 do
    begin
      // Find the radio group that has focus
      if Components[i] is TRzRadioGroup then
        begin
          if TRzRadioGroup(Components[i]).Name = CurrentRadioGrp then
            begin
              TempInt := TRzRadioGroup(Components[i]).ItemIndex;

              Choice := AdjustKeyToItemIndex(Choice,
                TRzRadioGroup(Components[i]).Items.Count,
                TRzRadioGroup(Components[i]).Items[0]);

              if Choice = -1 then
                begin
                  MessageBeep(MB_ICONASTERISK);
                  //if gvVisualBeeps then
                  //  MsgDlgFrm('Wrong key.', MHA_CAPTION,
                  //    mtError, [mbOk], 0);
                  Exit;
                end;

              TRzRadioGroup(Components[i]).ItemIndex := Choice;

              // This little slight-of-hand is needed when the TRzGroupButton
              // has focus and it is already checked.
              if TempInt = TRzRadioGroup(Components[i]).ItemIndex then
                if gvSpeedTab then
                  Perform(WM_NEXTDLGCTL, 0, 0);

              Result := True;
            end; // Current
        end; // if radio
    end; // for i
end;


function TfrmMHA_DLL_DataEntry.KeyPressComboBox(K: word; CurrentComboBox:
  string): Boolean;
var
  i, Choice                   : Integer;
begin
  Result := False;

  Choice := KeyToNumber(K);
  if Choice = -2 then
    Exit;
  if Choice = -1 then
    begin
      MessageBeep(MB_ICONASTERISK);
      Exit;
    end;

  for i := 0 to ComponentCount - 1 do
    begin
      // Find the Combo Box that has focus
      if Components[i] is TComboBox then
        if TComboBox(Components[i]).Name = CurrentComboBox then
          begin
            Choice := AdjustKeyToItemIndex(Choice,
              TComboBox(Components[i]).Items.Count,
              TComboBox(Components[i]).Items[0]);
            if Choice = -1 then
              begin
                MessageBeep(MB_ICONASTERISK);
                Exit;
              end;
            TComboBox(Components[i]).ItemIndex := Choice;
            TComboBox(Components[i]).Text :=
              TComboBox(Components[i]).Items[TComboBox(Components[i]).ItemIndex];
            Result := true;
          end;
    end;
end;

function TfrmMHA_DLL_DataEntry.KeyPressTrackBar(K: word; LastTrackBar: string): boolean;
var
  i, Choice                   : Integer;
begin
  Result := False;

  Choice := KeyToNumber(K);
  if Choice = -2 then
    Exit;
  if Choice = -1 then
    begin
      MessageBeep(MB_ICONASTERISK);
      //if gvVisualBeeps then
      //  MsgDlgFrm('Wrong key.', MHA_CAPTION,
      //    mtError, [mbOk], 0);
      Exit;
    end;

  for i := lcStartComponent to ComponentCount - 1 do
    begin
      // Find the track bar that has focus
      if Components[i] is TExTrackBar then
        if TExTrackBar(Components[i]).Name = LastTrackBar then
          begin
            if ((TExTrackBar(Components[i]).Max >= Choice) or
              (TExTrackBar(Components[i]).Min <= Choice)) then
              begin
                TExTrackBar(Components[i]).Position := Choice;
                Result := True;
              end;
          end;
    end;
end;

procedure TfrmMHA_DLL_DataEntry.OnClickRadioGroup(Sender: TObject);
// This will capture both clicks and keypresses within the radio group
begin
  if lvInitialize then
    Exit;

  with Sender as TRzRadioGroup do
    begin
      ProcessAnswer(IntToStr(Tag), IntToStr(ItemIndex));
      // This is needed to handle the case where the user clicks on the question's
      // text, not an item.
      if Color <> gvHighlightBackground then
        begin
          SetFocus;
          HighlightRadioGroup(Sender);
        end;

      if gvSpeedTab and (ItemIndex = -1) then
        exit;
    end;

  if gvSpeedTab then
    Perform(WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmMHA_DLL_DataEntry.OnClickListBox(Sender: TObject);
// Only mouse events are captured here
begin
  if lvInitialize then
    Exit;

  with Sender as TRzListBox do
    begin
      ProcessAnswer(IntToStr(Tag), IntToStr(ItemIndex));
      HighlightListBox(Sender);
    end;

  if gvSpeedTab then
    Perform(WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmMHA_DLL_DataEntry.OnClickComboBox(Sender: TObject);
// This picks up the use of the arrow keys, home, & end.
begin
  if lvInitialize then
    Exit;

  with Sender as TComboBox do
    begin
      ProcessAnswer(IntToStr(Tag), Text);
      HighlightComboBox(Sender);
    end;

  if gvSpeedTab then
    Perform(WM_NEXTDLGCTL, 0, 0);
end;

procedure TfrmMHA_DLL_DataEntry.OnClickLabel(sender: TObject);
var
  i, TempTag                  : Integer;

begin
  TempTag := 0;

  if (Sender is TLabel) then
    with Sender as TLabel do
      begin
        if ((POS(cIntroduction, Name) > 0) or
          (POS(cSection, Name) > 0)) then
          exit;
        TempTag := Tag;
      end;

  if TempTag = 0 then
    exit;

  for i := ComponentCount - 1 downto lcStartComponent do
    begin
      if (Components[i] is TEdit) then
        if TempTag = TEdit(Components[i]).Tag then
          begin
            TEdit(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TMaskEdit) then
        if TempTag = TMaskEdit(Components[i]).Tag then
          begin
            TMaskEdit(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TJvValidateEdit) then
        if TempTag = TJvValidateEdit(Components[i]).Tag then
          begin
            TJvValidateEdit(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TJvDatePickerEdit) then
        if TempTag = TJvDatePickerEdit(Components[i]).Tag then
          begin
            TJvDatePickerEdit(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TRzSpinEdit) then
        if TempTag = TRzSpinEdit(Components[i]).Tag then
          begin
            TRzSpinEdit(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TExTrackBar) then
        if TempTag = TExTrackBar(Components[i]).Tag then
          begin
            TExTrackBar(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TRzListBox) then
        if TempTag = TRzListBox(Components[i]).Tag then
          begin
            TRzListBox(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TRzCheckList) then
        if TempTag = TRzCheckList(Components[i]).Tag then
          begin
            TRzCheckList(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TComboBox) then
        if TempTag = TComboBox(Components[i]).Tag then
          begin
            TComboBox(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TORComboBox) then
        if TempTag = TORComboBox(Components[i]).Tag then
          begin
            TORComboBox(Components[i]).SetFocus;
            Break;
          end;
      if (Components[i] is TMemo) then
        if TempTag = TMemo(Components[i]).Tag then
          begin
            TMemo(Components[i]).SetFocus;
            Break;
          end;
    end;
end;


procedure TfrmMHA_DLL_DataEntry.CheckForRule(QID, Answer: string);
var
  TempMsg                     : string;
begin

  TempMsg := Rule_OPS.ProcessRule(gvInstrument, QID, Answer);

  if TempMsg <> '' then
    if gvUseScreenReader then
      MsgDlgFrm(TempMsg, TempMsg, mtInformation,
        [mbOk], 0)
    else
      MsgDlgFrm(TempMsg, MHA_DLL_CAPTION, mtInformation,
        [mbOk], 0);
end;


procedure TfrmMHA_DLL_DataEntry.ProcessAnswer(QID, Answer: string);
begin
  CheckForRule(QID, Answer);

  UpdateComponentsAndAnswerList(QID, Answer);

  lvOldRules := Rule_OPS.SkipQuestions;

//  if CheckForCustomOperation then
//    begin
//      lvInitialize := True;
//      BuildEvents; // reloads answer list, which may have changed
//      lvInitialize := False;
//    end;
end;


procedure TfrmMHA_DLL_DataEntry.GetScaleScore;
var
  Score,
    i, j, k                   : Integer;

begin
  Score := 0;

  if gvInstrument.ListOfScales.Count = 0 then
    Exit;

  for i := 0 to gvInstrument.ListOfScales.Count - 1 do
    begin
      for j := 0 to gvInstrument.ListOfKeys.Count - 1 do
        begin
          if TScale(gvInstrument.ListOfScales[i]).IEN =
            TKey(gvInstrument.ListOfKeys[j]).ScaleID then
            begin
              for k := 0 to gvInstrument.ListOfAnswers.Count - 1 do
                begin
                  if ((TAnswer(gvInstrument.ListOfAnswers[k]).QuestionID) =
                    (TKey(gvInstrument.ListOfKeys[j]).QuestionID)) and
                    ((TAnswer(gvInstrument.ListOfAnswers[k]).AnswerText) =
                    (TKey(gvInstrument.ListOfKeys[j]).AnswerText)) then
                    Score := Score + StrToInt(TKey(gvInstrument.ListOfKeys[j]).Value);

                end; // for k
            end;
        end; // for j

      gvScoreStr := gvScoreStr + '*' + TScale(gvInstrument.ListOfScales[i]).IEN + '~' +
        IntToStr(Score);

      Score := 0;
    end; // for i
end;

function TfrmMHA_DLL_DataEntry.GetLegacyValue(aQuestionID, ItemIndexStr: string): string;
var
  i, Index                    : Integer;

begin
  Result := ' ';

  if (ItemIndexStr = '') or
    (ItemIndexStr = NOT_ASKED) or (ItemIndexStr = SKIPPED) or
    (ItemIndexStr = '1155') or (ItemIndexStr = '1156') or
    (ItemIndexStr = '1157') then
    Exit;

  Index := StrToIntDef(ItemIndexStr, -1);

  if Index = -1 then
    Exit;

  for i := 0 to gvInstrument.ListOfQuestions.Count - 1 do
    if aQuestionID = TQuestion(gvInstrument.ListOfQuestions[i]).QuestionID then
      Result := Piece(TQuestion(gvInstrument.ListOfQuestions[i]).MultiChoice.choices[Index], U, 4);
end;

function TfrmMHA_DLL_DataEntry.GetChoiceID(aQuestionID, ItemIndexStr: string): string;
var
  i, Index                    : Integer;

begin
  if (ItemIndexStr = '') or
    (ItemIndexStr = NOT_ASKED) or (ItemIndexStr = SKIPPED) or
    (ItemIndexStr = '1155') or (ItemIndexStr = '1156') or
    (ItemIndexStr = '1157') then
    begin
      Result := ItemIndexStr;
      Exit;
    end;

  Result := CHOICE_ID_OF_SKIPPED_QUESTION;

  Index := StrToIntDef(ItemIndexStr, -1);

  if Index = -1 then
    Exit;

  for i := 0 to gvInstrument.ListOfQuestions.Count - 1 do
    if aQuestionID = TQuestion(gvInstrument.ListOfQuestions[i]).QuestionID then
      Result := Piece(TQuestion(gvInstrument.ListOfQuestions[i]).MultiChoice.choices[Index], U, 2);
end;


procedure TfrmMHA_DLL_DataEntry.RecordAnswer(QID, aAnswerValue, aAnswerText,
  aIsMultiChoice: string);

// The ListOfAnswers was constructed at gvInstrument.create with NOT_ASKED
// for AnswerValue. IsMultiChoice--Default is false.
// This will update the answer for the question in QID.
var
  i                           : Integer;
  TempStr                     : string;
begin

  if lvInitialize then
    Exit;

  gvNumberOfAnswers := 0;
  lvNumberOfSkippedAnswers := 0;
  gvSkipped := '';

  for i := 0 to gvInstrument.ListOfAnswers.Count - 1 do
    begin
//ShowMessage(TAnswer(gvInstrument.ListOfAnswers[i]).QuestionID+#13+
//TAnswer(gvInstrument.ListOfAnswers[i]).AnswerText+#13+
//TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue);
      if QID = TAnswer(gvInstrument.ListOfAnswers[i]).QuestionID then
        begin

          // aAnswerValue is: multiple-choice item index, SKIPPED value, etc.
          // It is blank when in use with date, edit, memo, maask-edit and check-list box
          if gvInstrument.IsLegacy then
            TAnswer(gvInstrument.ListOfAnswers[i]).AnswerLegacyValue :=
              GetLegacyValue(QID, aAnswerValue);

          if aIsMultiChoice = YES then
            TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue :=
              GetChoiceID(QID, aAnswerValue)
          else
            TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue :=
              aAnswerValue;

          // AnswerText is: multiple-choice item (less the designator), edit text,
          // date string, Mask edit text, etc.
          TAnswer(gvInstrument.ListOfAnswers[i]).AnswerText := aAnswerText;
          TAnswer(gvInstrument.ListOfAnswers[i]).IsMultiChoice := aIsMultiChoice = YES;
        end; // if QID

// Update the tally of Not Asked, and Skipped questions.
// A "Skipped" question is defined, operationally, as a question that has been
// highlighted but no answer was given, e.g., radio group itemIndex = -1, edit
// text blank.

     // gvSkipped will list all the blank questions regardless of reason
      if (TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue = NOT_ASKED) then
        gvSkipped := gvSkipped + TAnswer(gvInstrument.ListOfAnswers[i]).Designator + ', '
      else
        Inc(gvNumberOfAnswers);

      // Tally skipped blank questions
      if ((TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue =
        CHOICE_ID_OF_SKIPPED_REQUIRED_QUESTION) or
        (TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue =
        SKIPPED) or
        (TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue =
        CHOICE_ID_OF_SKIPPED_QUESTION)) then
        begin
          Inc(lvNumberOfSkippedAnswers);
          gvSkipped := gvSkipped + TAnswer(gvInstrument.ListOfAnswers[i]).Designator + ', ';
          TempStr := TempStr + TAnswer(gvInstrument.ListOfAnswers[i]).Designator + ', ';
        end;

    end; // for i

  if Length(TempStr) > 1 then
    begin
      // Remove last comma
      Delete(TempStr, Length(TempStr) - 1, 2);
      TempStr := 'Questions skipped: ' + TempStr;
    end;

  UpdateStatusBar(TempStr);

end;


procedure TfrmMHA_DLL_DataEntry.UpdateStatusBar(NewCaption: string);
begin
  if gvUseScreenReader then
    Exit;

  prgbrStatus.Position := Round(100 * (gvNumberofAnswers / gvInstrument.NumberOfQuestions));

  if lvNumberOfSkippedAnswers > 0 then
    begin
      prgbrStatus.BarColorFrom := 00600000;
      prgbrStatus.BarColorTo := 00600060;
    end
  else
    begin
      prgbrStatus.BarColorFrom := $0031D329;
      prgbrStatus.BarColorTo := $00ADEFAD;
    end;

  prgbrStatus.Refresh;

  pnlStatus.SimpleCaption := NewCaption;
  pnlStatus.Refresh;
end;


procedure TfrmMHA_DLL_DataEntry.OnChangeTrackBar(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  with Sender as TExTrackBar do
    begin
      Color := gvHighlightBackground;
      Font.Color := gvHighlightForeground;
      ProcessAnswer(IntToStr(Tag), IntToStr(Position));
    end;
end;

procedure TfrmMHA_DLL_DataEntry.OnChangeEvent(sender: TObject);
// OnChangeEvent is used primarily to handle rules for skipping
// subsequent questions, validating responses. OnChange for
// Radio Group, List Box, Check List box, Combo box and Track bar
// are processed elsewhere.
//
// TEdit, TMemo, TMaskEdit & TJvDatePickerEdit process their answers in the
// OnExit Event.
begin
  if lvInitialize then
    Exit;

  if Sender is TORComboBox then
    with Sender as TORComboBox do
      begin
        if Pos(cComboBoxConsult, Name) > 0 then
          ProcessAnswer(IntToStr(Tag), Piece(Items[ItemIndex], U, 1))
        else
          ProcessAnswer(IntToStr(Tag), Text);
      end;

  if Sender is TRzSpinEdit then
    with Sender as TRzSpinEdit do
      begin
        if Text = '' then // Blank will cause error
          ProcessAnswer(IntToStr(Tag), '')
        else
          ProcessAnswer(IntToStr(Tag), FloatToStr(Value));
      end;

  if Sender is TJvValidateEdit then // handles blank entry okay
    with Sender as TJvValidateEdit do
      ProcessAnswer(IntToStr(Tag), FloatToStr(Value));
end;


procedure TfrmMHA_DLL_DataEntry.OnExitEvent(sender: TObject);
// This event is used to catch questions that are skipped and
// to handle components that are not in OnChange Event (TEdit, TMaskEdit,
// TMemo, TJvDatePickerEdit).
var
  Skip                        : Boolean;
  i                           : Integer;
begin

  if lvInitialize then
    Exit;

  if Sender is TMemo then
    with Sender as TMemo do
      begin
        if Length(Text) = 0 then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', NO {not multichoice})
        else
          ProcessAnswer(IntToStr(Tag), Text);
      end;

  if Sender is TEdit then
    with Sender as TEdit do
      begin
        if Text = '' then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', NO {not multichoice})
        else
          ProcessAnswer(IntToStr(Tag), Text);
      end;

  if Sender is TMaskEdit then
    with Sender as TMaskEdit do
      begin
        if (Text = '') or (Text = MASK_BLANK) then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', NO {not multichoice})
        else
          ProcessAnswer(IntToStr(Tag), Text);
      end;

  if Sender is TJvDatePickerEdit then
    with Sender as TJvDatePickerEdit do
      begin
        if DateTimeToStr(Date) = BLANK_DATE then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, BLANK_DATE, NO {not multichoice})
        else // Non blank entry
          begin
            if Date > Now then
              begin
                MsgDlgFrm('Sorry, future dates are not allowed in this program. ' + #13 +
                  'Today''s will be substituded.', MHA_DLL_CAPTION, mtInformation, [mbOk], 0);
                Date := Today;
              end;
            ProcessAnswer(IntToStr(Tag), DateToStr(Date));
          end;
      end;

  if Sender is TComboBox then
    with Sender as TComboBox do
      begin
        if Text = '' then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', YES {MultiChoice})
        else
          // The combo box could have a default staff name that was not changed;
          // thus the OnExit event must be used to record it. The OnChange event is
          // needed in case there is a rule that is triggered by a selection.
          RecordAnswer(IntToStr(Tag), IntToStr(ItemIndex), Text, YES);
      end;

  if Sender is TORComboBox then
    with Sender as TORComboBox do
      begin
        // Allow a blank consult field (not skipped).
        if Pos(cComboBoxConsult, Name) > 0 then
          begin
            if Text = '' then
              RecordAnswer(IntToStr(Tag), 'None', 'None', NO {MultiChoice})
            else
              RecordAnswer(IntToStr(Tag), Piece(Items[ItemIndex], U, 1),
                Piece(Items[ItemIndex], U, 7), NO {MultiChoice});
          end
        else
        // The combo box could have a default staff name that was not changed;
        // thus the OnExit event must be used to record it. The OnChange event is
        // needed in case there is a rule that is triggered by a selection.
          begin
            if Text = '' then
              RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', NO {MultiChoice})
            else
              RecordAnswer(IntToStr(Tag), Text, Text, NO {MultiChoice});
          end;
      end;

  if Sender is TRzSpinEdit then
    with Sender as TRzSpinEdit do
      begin
        if Text = '' then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', NO {not multichoice})
        else
          // This handles the case when a default value is present, user accepts
          // it, thus no OnChange event triggered).
          ProcessAnswer(IntToStr(Tag), FloatToStr(Value));
      end;

  if Sender is TJvValidateEdit then
    with Sender as TJvValidateEdit do
      begin
        if Text = '' then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', NO {not multichoice})
        else
          // This handles the case when a default value is present, user accepts
          // it, thus no OnChange event triggered).
          ProcessAnswer(IntToStr(Tag), FloatToStr(Value));
      end;

  if Sender is TRzCheckList then
    with Sender as TRzCheckList do
      begin
        Skip := True;
        for i := 0 to Items.Count - 1 do
          if ItemChecked[i] then
            Skip := False;
        if Skip then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', NO {Multichoice});
      end;

  if Sender is TRzListBox then
    with Sender as TRzListBox do
      begin
        if ItemIndex = -1 then
          RecordAnswer(IntToStr(Tag), CHOICE_ID_OF_SKIPPED_QUESTION, '', YES {MultiChoice});
      end;

  if Sender is TRzRadioGroup then
    with Sender as TRzRadioGroup do
      begin
        if ItemIndex = -1 then
          RecordAnswer(IntToStr(Tag) {QuestionID}, CHOICE_ID_OF_SKIPPED_QUESTION, '', YES {MultiChoice});
      end;

// This is actually called when the user enters this component. This is okay
// for our purposes since the OnChange will get the real response, unless the
// user selects the position that is already dispayed (no change is triggered)
// and this will have recorded that answer. Recording twice? yep.

  if Sender is TExTrackBar then
    with Sender as TExTrackBar do
      RecordAnswer(IntToStr(Tag), IntToStr(Position), IntToStr(Position),
        NO {MultiChoice});
end;


procedure TfrmMHA_DLL_DataEntry.OnChangeCheckList(Sender: TObject;
  Index: Integer; NewState: TCheckBoxState);
var
  TempItems,
    TempStr                   : string;
  i                           : Integer;
begin

  if lvInitialize then
    Exit;

  with sender as TRzCheckList do
    begin
      // It makes no sense at all, but placing the following line in OnEnter
      // event where it logically belongs will cause the first item to be
      // checked, regardless of the item that is clicked, when the CheckBox is
      // entered with a click event.
      Font.Color := gvHighlightForeground;

      TempStr := '';
      TempItems := '';

      for i := 0 to Items.Count - 1 do
        if ItemChecked[i] then
          begin
            TempStr := TempStr + '1';
            TempItems := TempItems + ' ' + Items[i];
          end
        else
          TempStr := TempStr + '0';

      ProcessAnswer(IntToStr(Tag), TempStr);
      // Normally the Answer.Value is sufficient for the saving of a
      // component's answer. However, the text of items have to be saved too,
      // and check list boxes are special.
      RecordAnswer(IntToStr(Tag), TempStr, TempItems, NO);

    end;
end;

function TfrmMHA_DLL_DataEntry.GetItemIndex(aQuestionID, ChoiceID: string): string;
var
  j, i                        : Integer;
begin
  result := '-1';
  for i := 0 to gvInstrument.ListOfQuestions.Count - 1 do
    if aQuestionID = TQuestion(gvInstrument.ListOfQuestions[i]).QuestionID then
      for j := 0 to TQuestion(gvInstrument.ListOfQuestions[i]).MultiChoice.choices.Count - 1 do
        if Piece(TQuestion(gvInstrument.ListOfQuestions[i]).MultiChoice.choices[j], U, 2) =
          ChoiceID then
          result := IntToStr(j);
end;

function TfrmMHA_DLL_DataEntry.GetChoiceOnly(StringIn: string): string;
var
  i                           : Integer;
begin
  Result := StringIn;
  i := Pos('.', StringIn);
  if i = 0 then
    i := Pos(')', StringIn);
  if i = 0 then
    i := Pos(']', StringIn);
  if (i > 0) and ((i + 1) < Length(StringIn)) then
    result := Trim(Copy(StringIn, i + 1, Length(StringIn)));
end;

  (*
procedure TfrmMHA_DLL_DataEntry.OnExitTrackBar(Sender: TObject);
// This is actually called when the user enters this component. This is okay
// for our purposes since the OnChange will get the real response, unless the
// user selects the position that is already dispayed (no change is triggered)
// and this will have recorded that answer. Recording twice? yep.
begin
  if lvInitialize then
    Exit;

  with Sender as TExTrackBar do
    RecordAnswer(IntToStr(Tag), IntToStr(Position), IntToStr(Position),
      NO {MultiChoice});
end;*)


function TfrmMHA_DLL_DataEntry.GetDPI: integer;
var
  DC                          : hDC;
begin
  DC := GetDC(Handle);
  Result := GetDeviceCaps(DC, LOGPIXELSX);
  ReleaseDC(Handle, DC);
end;


procedure TfrmMHA_DLL_DataEntry.BuildForm;
var
  i, j, TempHeight            : Integer;
  TempIntro                   : string;
  TempStrList                 : TStringList;

  procedure Build_Items_DLL(Designator: TChoiceIdentifier;
    var StringListIn: TStringList);
  var
    i                         : Integer;
    TempSL                    : TStringList;
  begin
    if StringListIn.Count = 0 then
      Exit;

    TempSL := TStringList.Create;

    for i := 0 to StringListIn.Count - 1 do
      begin
        case Designator of
          ciNone: TempSL.Add(Piece(StringListIn[i], U, 3));
          ciZeroBased: TempSL.Add(inttostr(i) + '. ' + Piece(StringListIn[i], U, 3));
          ciOneBased: TempSL.Add(inttostr(i + 1) + '. ' + Piece(StringListIn[i], U, 3));
        end; //case Question.ChoiceIdentifier
      end;

    StringListIn.Clear;
    StringListIn.AddStrings(TempSL);
    TempSL.Free;
  end;

begin
  TempStrList := TStringList.Create;
  // Tabs
  tbctrlRight.Tabs.Clear;
  tbctrlRight.Tabs.Add('Top');
  gvDPI := GetDPI;

  gvQuestionSpace := 3 * TextHeightByFont(Font.Handle, 'Yy') div 2;
  gvQuestionTop := gvQuestionSpace;
  gvQuestionOrder := 1;
  gvScrollBarWidthWS := TextWidthbyFont(Font.handle, 'XXXX');
  gvNumberOfAnswers := 0;

  // If there are no sections for this instrument, do not show right tabs.
  // The width of the Preview form needs to have this set before its construction.
  if gvInstrument.ListOfSections.Count < 2 then
    tbctrlRight.Visible := False
  else
    begin
      tbctrlRight.Visible := True;
      gvScrollBarWidthWS := TextWidthbyFont(Font.handle, 'XXXX') +
        GUI_Control.GetStandardHeight(Font);
    end;

  for i := 0 to gvInstrument.ListOfQuestions.Count - 1 do
    begin
      with TQuestion(gvInstrument.ListOfQuestions[i]) do
        begin
          TempHeight := 0;
          TempIntro := '';
          Inc(gvQuestionOrder);

          // Check for a section label
          for j := 0 to gvInstrument.ListOfSections.Count - 1 do
            if (TSectionLabel(gvInstrument.ListOfSections.Items[j]).QuestionID = QuestionID) then
              begin
                Build_Section(TLabel.Create(self),
                  TSectionLabel(gvInstrument.ListOfSections.Items[j]).Display, 0,
                  TSectionLabel(gvInstrument.ListOfSections.Items[j]).SectionCaption,
                  sbDataEntry);
                if TSectionLabel(gvInstrument.ListOfSections[j]).TabCaption <> '' then
                  tbctrlRight.Tabs.Add(TSectionLabel(gvInstrument.ListOfSections[j]).TabCaption);
              end;

          // Build the introduction if there is one.
          if TIntroduction(gvInstrument.ListOfIntroductions[i]).iText <> '' then
            if TIntroduction(gvInstrument.ListOfIntroductions[i]).IsNew then
              if gvUseScreenReader then
                TempIntro := TIntroduction(gvInstrument.ListOfIntroductions[i]).iText
              else
                Build_Instructions(TLabel.Create(self),
                  TIntroduction(gvInstrument.ListOfIntroductions[i]).Display, 0,
                  TIntroduction(gvInstrument.ListOfIntroductions[i]).iText, sbDataEntry);

          // Build the Question text (except for radio groups which are self
          // contained. Screen readers, like JAWS, can not read all text of a
          // wrapped label, but it can read all the text of a group box label,
          // een if not visible. Go figure.
          if ((ResponseType = rtMultiChoice) and
            (AnswerDisplay.DisplayComponent = acRadioGroup)) then
            begin
              if gvUseScreenReader then
                begin
                  AnswerDisplay.DisplaySameLine := False;
                  if (TempIntro + qCaption <> '') then
                    begin
                      TempHeight := Build_508IntroCaption(TGroupBox.Create(self),
                        Display, TempIntro + ' ' + qCaption, qTag, ResponseType, sbDataEntry);
                      Inc(gvQuestionOrder);
                    end;
                end;
            end
          else
            if (qCaption <> '') then
              begin
                if gvUseScreenReader then
                  begin
                    AnswerDisplay.DisplaySameLine := False;
                    if (TempIntro + qCaption <> '') then
                      begin
                        TempHeight := Build_508IntroCaption(TGroupBox.Create(self),
                          Display, TempIntro + ' ' + qCaption, qTag, ResponseType, sbDataEntry);
                        Inc(gvQuestionOrder);
                      end;
                  end
                else
                  TempHeight := Build_Label(TLabel.Create(self),
                    Display, AnswerDisplay, qCaption,
                    qHint, qTag, ResponseType, sbDataEntry);
              end;

          // Is the answer component on the same line as the question text?
          if not AnswerDisplay.DisplaySameLine then // Component on next line
            gvQuestionTop := gvQuestionTop + TempHeight;

          if ResponseType = rtCheckList then
            begin
              TempStrList.Clear;
              TempStrList.AddStrings(MultiChoice.Choices);
              Build_Items_DLL(ChoiceIdentifier, TempStrList);

              Build_CheckListBox(TRzCheckList.Create(self),
                AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry, TempStrList);
            end;

          if (ResponseType = rtMultiChoice) and
            (AnswerDisplay.DisplayComponent = acComboBox) then
            begin
              TempStrList.Clear;
              TempStrList.AddStrings(MultiChoice.Choices);
              Build_Items_DLL(ChoiceIdentifier, TempStrList);

              Build_ComboBox(TComboBox.Create(self),
                AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry, TempStrList);
            end;

          if ResponseType = rtCurrency then
            Build_Currency(TJvValidateEdit.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, qMin, qMax, sbDataEntry);

          if ResponseType = rtDate then
            Build_Date(TJvDatePickerEdit.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry);

          if ResponseType = rtString then
            Build_Edit(TEdit.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry);

          if (ResponseType = rtMultiChoice) and
            (AnswerDisplay.DisplayComponent = acListBox) then
            begin
              TempStrList.Clear;
              TempStrList.AddStrings(MultiChoice.Choices);
              Build_Items_DLL(ChoiceIdentifier, TempStrList);

              Build_ListBox(TRzListBox.Create(self),
                AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry, TempStrList);
            end;

          if ResponseType = rtMaskEdit then
            Build_MaskEdit(TMaskEdit.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry);

          if ResponseType = rtMemo then
            Build_Memo(TMemo.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry);

          if (ResponseType = rtMultiChoice) and
            (AnswerDisplay.DisplayComponent = acRadioGroup) then
            begin
              TempStrList.Clear;
              TempStrList.AddStrings(MultiChoice.Choices);
              Build_Items_DLL(ChoiceIdentifier, TempStrList);

              if gvUseScreenReader then
                Build_ListBox(TRzListBox.Create(self),
                  AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry, TempStrList)
              else
                Build_RadioGroup(TRzRadioGroup.Create(self),
                  qCaption, qHint, qTag,
                  gvInstrument.IsLegacy,
                  Display, AnswerDisplay, sbDataEntry, TempStrList);
            end;

          if ResponseType = rtInteger then
            Build_SpinEdit(TRzSpinEdit.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, qMin,
              qMax, rtInteger, sbDataEntry);

          if ResponseType = rtTrackBar then
            begin
              Build_TrackBar(TExTrackBar.Create(self),
                AnswerDisplay, qHint, TempHeight, qTag, qMin, qMax, sbDataEntry);
              if MultiChoice.Choices.Count > 0 then
                begin
                  TempStrList.Clear;
                  TempStrList.AddStrings(MultiChoice.Choices);
                  Build_Items_DLL(ChoiceIdentifier, TempStrList);
                  Build_TrackLabel2(TLabel.Create(self),
                    AnswerDisplay, qTag, sbDataEntry, TempStrList);
                end;
            end;

          if (ResponseType = rtVista) and
            (AnswerDisplay.DisplayComponent = acStaff) then
            Build_StaffComboBox(TORComboBox.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry);

          if (ResponseType = rtVista) and
            (AnswerDisplay.DisplayComponent = acConsult) then
            Build_ConsultComboBox(TORComboBox.Create(self),
              AnswerDisplay, qHint, TempHeight, qTag, sbDataEntry);

        end; // with TQuestion(gvInstrument.ListOfQuestions[i])
    end; // for i

  // Add a little space (bottom margin) to the form
  gvQuestionTop := gvQuestionTop + (2 * gvQuestionSpace);
  sbDataEntry.VertScrollBar.Range := gvQuestionTop;
  TempStrList.Free;
end;

procedure TfrmMHA_DLL_DataEntry.BuildEvents;
// Setup the OnEnter, OnExit, etc. events for each component.
// Populate component with previous response, if applicable.
// The CheckList component will only check/uncheck items when this is
// run in FormShow (not FormCreate). Go figure...
var
  i, j                        : integer;
  TempStr                     : string;

begin
  Rule_OPS.SkipQuestions := '';
  
  if gvInstrument.ListOfQuestions.Count = 0 then
    exit;

  for i := lcStartComponent to ComponentCount - 1 do
    begin

      if Components[i] is TGroupBox then
        with TGroupBox(Components[i]) do
          begin
            if Parent = sbDataEntry then
              OnEnter := HighLightGroupBox;
          end;
      if Components[i] is TLabel then
        with TLabel(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnClick := OnClickLabel;
                OnDblClick := DoubleClickMessage;
              end;
          end;
      if Components[i] is TEdit then
        with TEdit(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                Text := GetDefaultEntry(Tag);
                OnEnter := HighLightEdit;
                OnExit := OnExitEvent;
                if gvPriorAnswers then
                  begin
                    Text := GetFormerAnswer(IntToStr(Tag));
                  end;
              end;
          end;
      if Components[i] is TMaskEdit then
        with TMaskEdit(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                Text := GetDefaultEntry(Tag);
                OnEnter := HighLightMaskEdit;
                OnExit := OnExitEvent;
                if gvPriorAnswers then
                  begin
                    Text := GetFormerAnswer(IntToStr(Tag));
                  end;
              end;
          end;
      if Components[i] is TJvValidateEdit then
        with TJvValidateEdit(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightCurrency;
                OnExit := OnExitEvent;
                OnChange := OnChangeEvent;
                if gvPriorAnswers then
                  Text := GetFormerAnswer(IntToStr(Tag));
              end;
          end;
      if Components[i] is TJvDatePickerEdit then
        with TJvDatePickerEdit(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLighTJvDatePickerEdit;
                OnExit := OnExitEvent;
                if gvPriorAnswers then
                  begin
                    TempStr := GetFormerAnswer(IntToStr(Tag));
                    if TempStr <> '' then
                      Date := StrToDate(TempStr);
                  end;
              end;
          end;

      if Components[i] is TRzSpinEdit then
        with TRzSpinEdit(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightSpinEdit;
                OnExit := OnExitEvent;
                OnChange := OnChangeEvent;
                if gvPriorAnswers then
                  //begin
                  Text := GetFormerAnswer(IntToStr(Tag));
                    //if TempStr <> '' then
                    //  Value := StrToIntDef(TempStr, 0);
                  //end;
              end;
          end;

      if Components[i] is TRzRadioGroup then
        with TRzRadioGroup(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightRadioGroup;
                OnExit := OnExitEvent;
                OnClick := OnClickRadioGroup;
                OnDblClick := DoubleClickMessage;

                if gvPriorAnswers then
                  begin
                    TempStr := GetFormerAnswer(IntToStr(Tag));
                    if TempStr <> '' then
                      ItemIndex := StrToIntDef(TempStr, -1);
                  end;
              end;
          end;

      if Components[i] is TRzListBox then
        with TRzListBox(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightListBox;
                OnExit := OnExitEvent;
                OnClick := OnClickListBox;
                OnDblClick := DoubleClickMessage;
                // No OnChange Event
                if gvPriorAnswers then
                  begin
                    TempStr := GetFormerAnswer(IntToStr(Tag));
                    if TempStr <> '' then
                      ItemIndex := StrToIntDef(TempStr, -1);
                  end;
              end;
          end;

      if Components[i] is TRzCheckList then
        with TRzCheckList(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightCheckListBox;
                OnChange := OnChangeCheckList;
                OnExit := OnExitEvent;
                if gvPriorAnswers then
                  begin
                    TempStr := GetFormerAnswer(IntToStr(Tag));

                    if TempStr <> '' then
                      for j := 0 to Items.Count - 1 do
                        if Pos(Items[j], TempStr) > 0 then
                          ItemChecked[j] := True
                        else
                          ItemChecked[j] := False;
                    (*if TempStr <> '' then
                    for j := 0 to Items.Count - 1 do
                    if TempStr[j + 1] = '1' then
                        ItemChecked[j] := True
                      else
                        ItemChecked[j] := False;*)
                  end;
              end;
          end;

      if Components[i] is TComboBox then
        with TComboBox(Components[i]) do
          if Parent = sbDataEntry then
            begin
              OnEnter := HighLightComboBox;
              OnExit := OnExitEvent;
              OnClick := OnClickComboBox;
              OnDblClick := DoubleClickMessage;
              if gvPriorAnswers then
                begin
                  TempStr := GetFormerAnswer(IntToStr(Tag));
                  if TempStr <> '' then
                    ItemIndex := StrToIntDef(TempStr, -1);
                end;
            end;

      if Components[i] is TORComboBox then
        with TORComboBox(Components[i]) do
          begin

            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightORComboBox;
                OnExit := OnExitEvent;
                OnChange := OnChangeEvent;

                if Pos(cComboBoxConsult, Name) > 0 then
                  begin
                    Items.AddStrings(Consult_OPS.LoadConsultSubSet(Patient.DFN,
                      gvBroker));
                    DropDownCount := Items.Count - 1;
                  end
                else
                  begin
                    OnNeedData := cmbStaffNeedData;
                    InitLongList('A');

                    //if gvPriorAnswers then
                    //  Text := GetFormerAnswer(IntToStr(Tag));
                  end;
              end;
          end;
      if Components[i] is TExTrackBar then
        with TExTrackBar(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightTrackBar;
                OnExit := OnExitEvent;
                OnChange := OnChangeTrackBar;
                if gvPriorAnswers then
                  begin
                    TempStr := GetFormerAnswer(IntToStr(Tag));
                    if TempStr <> '' then
                      Position := StrToIntDef(TempStr, 1);
                  end;
              end;
          end;
      if Components[i] is TMemo then
        with TMemo(Components[i]) do
          begin
            if Parent = sbDataEntry then
              begin
                OnEnter := HighLightMemo;
                OnExit := OnExitEvent;
                Text := GetDefaultEntry(Tag);
                if gvPriorAnswers then
                  Text := GetFormerAnswer(IntToStr(Tag));
              end;
          end;
    end; // for i
end;


procedure TfrmMHA_DLL_DataEntry.GoToFirstItem;
var
  i                           : Integer;
begin

  for i := lcStartComponent to ComponentCount - 1 do
    begin
      if Components[i] is TGroupBox then
        begin
          if TGroupBox(Components[i]).Parent = sbDataEntry then
            begin
              ActiveControl := TGroupBox(Components[i]);
              Break;
            end;
        end;
      if Components[i] is TEdit then
        if TEdit(Components[i]).Parent = sbDataEntry then
          begin
            if TEdit(Components[i]).Text <> '' then
              ProcessAnswer(IntToStr(TEdit(Components[i]).Tag),
                TEdit(Components[i]).Text);
            SetFocusedControl(TEdit(Components[i]));
            Break;
          end;
      if Components[i] is TMaskEdit then
        if TMaskEdit(Components[i]).Parent = sbDataEntry then
          begin
            if TMaskEdit(Components[i]).Text <> TMaskEdit(Components[i]).EditMask then
              ProcessAnswer(IntToStr(TMaskEdit(Components[i]).Tag),
                TMaskEdit(Components[i]).Text);
            SetFocusedControl(TMaskEdit(Components[i]));
            Break;
          end;
      if Components[i] is TJvValidateEdit then
        if TJvValidateEdit(Components[i]).Parent = sbDataEntry then
          begin
            if TJvValidateEdit(Components[i]).Text <> '' then
              ProcessAnswer(IntToStr(TJvValidateEdit(Components[i]).Tag),
                FloatToStr(TJvValidateEdit(Components[i]).Value));
            SetFocusedControl(TJvValidateEdit(Components[i]));
            Break;
          end;
      if Components[i] is TJvDatePickerEdit then
        if TJvDatePickerEdit(Components[i]).Parent = sbDataEntry then
          begin
            if TJvDatePickerEdit(Components[i]).Date <> Now then
              ProcessAnswer(IntToStr(TJvDatePickerEdit(Components[i]).Tag),
                DateToStr(TJvDatePickerEdit(Components[i]).Date));
            SetFocusedControl(TJvDatePickerEdit(Components[i]));
            Break;
          end;
      if Components[i] is TRzSpinEdit then
        if TRzSpinEdit(Components[i]).Parent = sbDataEntry then
          begin
            if TRzSpinEdit(Components[i]).Text <> '' then
              ProcessAnswer(IntToStr(TRzSpinEdit(Components[i]).Tag),
                FloatToStr(TRzSpinEdit(Components[i]).Value));
            SetFocusedControl(TRzSpinEdit(Components[i]));
            Break;
          end;
      if Components[i] is TRzRadioGroup then
        if TRzRadioGroup(Components[i]).Parent = sbDataEntry then
          begin
            if TRzRadioGroup(Components[i]).ItemIndex <> -1 then
              ProcessAnswer(IntToStr(TRzRadioGroup(Components[i]).Tag),
                IntToStr(TRzRadioGroup(Components[i]).ItemIndex));
            SetFocusedControl(TRzRadioGroup(Components[i]));
            Break;
          end;
      if Components[i] is TRzListBox then
        if TRzListBox(Components[i]).Parent = sbDataEntry then
          begin
            if TRzListBox(Components[i]).ItemIndex <> -1 then
              ProcessAnswer(IntToStr(TRzListBox(Components[i]).Tag),
                IntToStr(TRzListBox(Components[i]).ItemIndex));
            //SetFocusedControl(TRzListBox(Components[i]));
            ActiveControl := TRzListBox(Components[i]);
            Break;
          end;
      if Components[i] is TRzCheckList then
        if TRzCheckList(Components[i]).Parent = sbDataEntry then
          begin
            SetFocusedControl(TRzCheckList(Components[i]));
            Break;
          end;
      if Components[i] is TComboBox then
        if TComboBox(Components[i]).Parent = sbDataEntry then
          begin
            if TComboBox(Components[i]).ItemIndex <> -1 then
              ProcessAnswer(IntToStr(TComboBox(Components[i]).Tag),
                IntToStr(TComboBox(Components[i]).ItemIndex));
            SetFocusedControl(TComboBox(Components[i]));
            Break;
          end;
      if Components[i] is TORComboBox then
        if TORComboBox(Components[i]).Parent = sbDataEntry then
          begin
            if TORComboBox(Components[i]).ItemIndex <> -1 then
              begin
                if Pos(cComboBoxConsult, Name) > 0 then
                // This is Consult number
                  ProcessAnswer(IntToStr(TORComboBox(Components[i]).Tag),
                    Piece(TORComboBox(Components[i]).Items[TORComboBox(Components[i]).ItemIndex], U, 1))
                else
                  ProcessAnswer(IntToStr(TORComboBox(Components[i]).Tag),
                    IntToStr(TORComboBox(Components[i]).ItemIndex));
              end;
            SetFocusedControl(TORComboBox(Components[i]));
            Break;
          end;
      if Components[i] is TExTrackBar then
        if TExTrackBar(Components[i]).Parent = sbDataEntry then
          begin
            if TExTrackBar(Components[i]).Position <> 0 then
              ProcessAnswer(IntToStr(TExTrackBar(Components[i]).Tag),
                IntToStr(TExTrackBar(Components[i]).Position));
            SetFocusedControl(TExTrackBar(Components[i]));
            Break;
          end;
      if Components[i] is TMemo then
        if TMemo(Components[i]).Parent = sbDataEntry then
          begin
            SetFocusedControl(TMemo(Components[i]));
            Break;
          end;
    end;
end;

function TfrmMHA_DLL_DataEntry.GetDefaultEntry(QID: integer): string;
var
  TempStr                     : string;
  i                           : Integer;
const
  Delimiter                   : Char = '|';
begin
  Result := '';

  for i := 0 to gvInstrument.ListOfQuestions.Count - 1 do
    begin
      if TQuestion(gvInstrument.ListOfQuestions[i]).QuestionID = IntToStr(QID) then
        begin
          TempStr := TQuestion(gvInstrument.ListOfQuestions[i]).AnswerDisplay.DisplayMask;
          TempStr := Piece(TempStr, DELIMITER, 2);
          if (TempStr = 'NA') or (TempStr = '') then
            Exit;
        end;
    end;

  result := TempStr;
end;


//------------------------------------------------------------------------------
//            Tab Control, right side of scroll box
//------------------------------------------------------------------------------

function TfrmMHA_DLL_DataEntry.AdjustTabWidth: integer;
// make room for multiple rows of tabs.
var
  Longest,
    i                         : Integer;
begin
  Longest := 0;

  for i := 0 to tbctrlRight.Tabs.Count - 1 do
    if Longest < TextWidthByFont(tbctrlRight.Font.Handle, tbctrlRight.Tabs[i]) then
      Longest := TextWidthByFont(tbctrlRight.Font.Handle, tbctrlRight.Tabs[i]);

  Result := GUI_Control.QuestionHeight * (1 + ((Longest * (tbctrlRight.Tabs.Count
    + 1)) div pnlTop.Height)) + GUI_Control.QuestionHeight div 4;
end;

procedure TfrmMHA_DLL_DataEntry.BuildTabsRight;
// Insert the captions in each tab and configure the scroll bar to
// move to that section when the tab is clicked.
var
  i, j                        : Integer;
  TempStr                     : string;
begin

  // If there are no sections for this instrument, do not show right tabs.
  if (gvInstrument.ListOfSections.Count < 2) or
    (gvUseScreenReader) then
    begin
      tbctrlRight.Visible := False;
      Exit;
    end;

  tbctrlRight.Visible := True;
  tbctrlRight.Font.Assign(gvFont);

  for i := 0 to RIGHT_TAB_MAX do
    lvRightTab[i] := 0;

  // Find the place on the form where this section appears, then set
  // the tab to go there when clicked. Place is stored in RightTab array.
  j := 1;
  for i := 0 to ComponentCount - 1 do
    if Components[i] is TLabel then
      begin
        TempStr := TLabel(Components[i]).Name;
        if TempStr = cSection then
          begin
            lvRightTab[j] := TLabel(Components[i]).Top;
            Inc(j);
          end;
      end;

  // make room for multiple rows of tabs.
  tbctrlRight.Width := AdjustTabWidth;

end;

procedure TfrmMHA_DLL_DataEntry.tbctrlRightChange(Sender: TObject);
begin
  if gvUseScreenReader then
    Exit;

  sbDataEntry.VertScrollBar.Position := lvRightTab[tbctrlRight.TabIndex];
end;

procedure TfrmMHA_DLL_DataEntry.btnCancelClick(Sender: TObject);
begin
  if (gvNumberOfAnswers = 1) and
    (lvNumberOfSkippedAnswers = 1) then
    FinishedAs := faNotStarted
  else
    FinishedAs := faCancelled;
  lvInitialize := True;
  Close;
end;

procedure TfrmMHA_DLL_DataEntry.btnFinishedClick(Sender: TObject);
begin

  if (gvNumberOfAnswers = 1) and
    (lvNumberOfSkippedAnswers = 1) then
    FinishedAs := faNotStarted;
  lvInitialize := True;
  Close;
end;


procedure TfrmMHA_DLL_DataEntry.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  Reply                       : TModalResult;
begin

  CanClose := True;

  if (FinishedAs = faNotStarted) then
    Exit;

  if (FinishedAs = faCancelled) then
    begin
      Reply := MsgDlgFrm(
        'You can finish this later today as long as this session of CPRS remains ' +
        'open, otherwise you will have to start over. ' + #13 + #13 +
        'Are you sure you want to quit?',
        gvInstrument.InstrumentName, mtConfirmation, [mbYes, mbNo], 0);

      if Reply = mrNo then
        begin
          lvInitialize := False;
          CanClose := False;
        end
      else
        Exit;
    end;

  // Not all questions have been asked.
  if not gvAllQuestionsRequired then
    begin
      if (gvNumberOfAnswers < gvInstrument.NumberOfQuestions) then
        begin
          Reply := MsgDlgFrm('Some questions have not been answered and ' +
            'the instrument is incomplete. ' +
            'You can finish it later today as long as this session of CPRS remains ' +
            'open, otherwise you will have to start over. '
            + #13 + #13 + 'Are you sure you are done?',
            gvInstrument.InstrumentName, mtConfirmation, [mbYes, mbNo], 0);

          if Reply = mrYes then
            FinishedAs := faInComplete;

          if Reply = mrNo then
            begin
              lvInitialize := False;
              CanClose := false;
            end;
        end;

  // Some questions have been skipped.
      if (gvNumberOfAnswers = gvInstrument.NumberOfQuestions) and
        (lvNumberOfSkippedAnswers > 0) then
        begin
          Reply := MsgDlgFrm('Some questions have been skipped. ' +
            'If you end now, the instrument will be saved with the ' +
            'skipped question(s) as blanks.' +
            #13 + #13 + 'Are you sure you are finished?',
            gvInstrument.InstrumentName, mtConfirmation, [mbYes, mbNo], 0);

          if Reply = mrYes then
            begin
           // make sure required questions are answered
              if not VerifyAnswers then
                Exit;
              FinishedAs := faComplete;
              //patch 123
              //GetScaleScore;
              Exit;
            end;

          if Reply = mrNo then
            begin
              lvInitialize := False;
              CanClose := false;
            end;
        end;

  // All questions "answered" but this includes skipped questions
      if (gvNumberOfAnswers = gvInstrument.NumberOfQuestions) then
        begin
      // make sure required questions are answered
          if not VerifyAnswers then
            Exit;
          FinishedAs := faComplete;
          //patch 123
          //GetScaleScore;
          Exit;
        end;
    end // not All Questions Required
  else
    begin
     // Make sure all questions are answered
      if (lvNumberOfSkippedAnswers > 0) or
        (gvNumberOfAnswers <> gvInstrument.NumberOfQuestions) or
        (gvSkipped <> '') then
        begin
          Reply := MsgDlgFrm('Some questions have not been answered ' +
            'and nothing will be saved in Vista. ' +
            '(Should you return later today in this session of CPRS, the ' +
            'current responses will be present.) ' + #13 + #13 +
            'Are you sure you are done?',
            gvInstrument.InstrumentName, mtConfirmation, [mbYes, mbNo], 0);

          if Reply = mrYes then
            FinishedAs := faInComplete;

          if Reply = mrNo then
            begin
              lvInitialize := False;
              CanClose := False;
            end;
        end
      else
        begin
          if not VerifyAnswers then
            Exit;
          FinishedAs := faComplete;
          //patch 123
          //GetScaleScore;
        end;
    end;

end;

(*procedure TfrmMHA_DLL_DataEntry.MakeActiveThisButton(
  RadioGroupName: string; KeyIn: Word);
var
  i, j                        : Integer;
  Designator                  : string;
begin

  for i := 0 to ComponentCount - 1 do
    begin
      if Components[i] is TRzRadioGroup then
        if TRzRadioGroup(Components[i]).Name = RadioGroupName then
          begin
            for j := 0 to TRzRadioGroup(Components[i]).Items.Count - 1 do
              begin
                Designator := Copy(TRzRadioGroup(Components[i]).Items[j], 1, 1);

                case KeyIn of
                  48:
                    if Designator = '0' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  49:
                    if Designator = '1' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  50:
                    if Designator = '2' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  51:
                    if Designator = '3' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  52:
                    if Designator = '4' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  53:
                    if Designator = '5' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  54:
                    if Designator = '6' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  55:
                    if Designator = '7' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  56:
                    if Designator = '8' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                  57:
                    if Designator = '9' then
                      TRzRadioGroup(Components[i]).ItemIndex := j;
                end; // case
              end;
          end;
    end;
end;  *)

procedure TfrmMHA_DLL_DataEntry.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssShift]) or (Shift = [ssALT]) or (Shift = [ssCTRL]) then
    Exit;

  // This is the case where a Radio Group has a button clicked and the user
  // presses the Return Key.  Go to next item without changing last item.
  if (ActiveControl.ClassName = 'TRzGroupButton') and
    ((Key = vk_Return) or (Key = vk_Tab)) then
    begin
      Perform(WM_NEXTDLGCTL, 0, 0);
      Key := 0; {- requires "Message" in "uses" -}
    end;
end;


procedure TfrmMHA_DLL_DataEntry.FormKeyPress(Sender: TObject;
  var Key: Char);
begin

  // Note: use this here to avoid a beep
  if Key = #13 then {- Go to next field -}
    begin
      if ActiveControl.ClassName = 'TMemo' then
        Exit;
      Perform(WM_NEXTDLGCTL, 0, 0);
      Key := #0; {- requires "Message" in "uses" -}
    end;
end;

procedure TfrmMHA_DLL_DataEntry.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ScrollAmount                : Integer;
begin

// This is the case where a mouse click, or keypress, gives focus to a radio group
// item that is already checked. Number input would not normally be recognized.
  if ActiveControl.ClassName = 'TRzGroupButton' then
    begin
      if KeyPressRadioGroup(Key, ActiveControl.Parent.Name) then
        if gvSpeedTab then
          Perform(WM_NEXTDLGCTL, 0, 0);
      Exit;
    end;

  if (Shift = [ssALT]) and (Key = vk_F4) then
    begin
      FinishedAs := faCancelled;
      Close;
      exit;
    end;

  if Key = vk_Escape then
    begin
      FinishedAs := faCancelled;
      Close;
      Key := 0;
      Exit;
    end;

  if lvInitialize then
    Exit;

  ScrollAmount := sbDataEntry.Height - 20;

  with sbDataEntry.VertScrollBar do
    begin
      if Key = vk_Prior then
        begin
          if Position >= ScrollAmount then
            Position := Position - ScrollAmount
          else
            Position := 0;
        end;

      if Key = vk_Next then
        begin
          if Position <= Range - ScrollAmount then
            Position := Position + ScrollAmount
          else
            Position := Range;
        end;
    end;

  if (Shift = [ssShift]) or (Shift = [ssALT]) or (Shift = [ssCTRL]) then
    Exit;

  if ActiveControl.ClassName = 'TExTrackBar' then
    begin
      // These two keys will advance or decrease the position of the track-bar.
      if (Key = vk_Prior) or (Key = vk_Next) then
        begin
          Key := 0;
          Exit;
        end;
      if KeyPressTrackBar(Key, ActiveControl.Name) then
        if gvSpeedTab then
          begin
            Perform(WM_NEXTDLGCTL, 0, 0);
            exit;
          end;
    end;

  if ActiveControl.ClassName = 'TRzListBox' then
    if KeyPressListBox(Key, ActiveControl.Name) then
      if gvSpeedTab then
        begin
          Perform(WM_NEXTDLGCTL, 0, 0);
          exit;
        end;

  if ActiveControl.ClassName = 'TComboBox' then
    if KeyPressComboBox(Key, ActiveControl.Name) then
      if gvSpeedTab then
        begin
          Perform(WM_NEXTDLGCTL, 0, 0);
          exit;
        end;

  if ActiveControl.ClassName = 'TRzRadioGroup' then
    begin
      if KeyPressRadioGroup(Key, ActiveControl.Name) then
        if gvSpeedTab then
          Perform(WM_NEXTDLGCTL, 0, 0);
    end;
end;

procedure TfrmMHA_DLL_DataEntry.cbSpeedTabClick(Sender: TObject);
begin
  gvSpeedTab := cbSpeedTab.Checked;

  if cbSpeedTab.Checked then
    lblHint.caption := 'Hint: Use the number key of the item to speed data entry.'
  else
    lblHint.caption := 'Hint: Press carriage return to move to next question.';
end;

function TfrmMHA_DLL_DataEntry.VerifyAnswers: boolean;
var
  TempStr1                    : string;
  i                           : Integer;

begin
  result := True;

  //NumberOfSkippedRequired := 0;
  TempStr1 := '';

  //Check for unanwered required questions
  for i := 0 to gvInstrument.ListOfQuestions.Count - 1 do
    begin

      if (TQuestion(gvInstrument.ListOfQuestions[i]).IsRequired) then
        begin
          if (TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue =
            SKIPPED) or
            (TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue =
            NOT_ASKED) then
            begin
             // Inc(NumberOfSkippedRequired);
              TempStr1 := TempStr1 +
                TQuestion(gvInstrument.ListOfQuestions[i]).Designator + ', ';
            end;
        end;
    end;

  //gvSkipped := gvSkipped + '*SKIPPED REQUIRED: ' + TempStr1;
  gvSkipped := gvSkipped + TempStr1;

  if TempStr1 <> '' then
    begin
      Delete(TempStr1, Length(TempStr1) - 1, 1);
      if gvUseScreenReader then
        MsgDlgFrm('  These required questions are not answered: ' + #13 + TempStr1 +
          #13 + #13 + 'Please answer before continuing.',
          '  These required questions are not answered: ' + #13 + TempStr1 +
          #13 + #13 + 'Please answer before continuing.',
          mtInformation, [mbOk], 0)
      else
        MsgDlgFrm(
          '  These required questions are not answered: ' + #13 + TempStr1 +
          #13 + #13 + 'Please answer before continuing.',
          MHA_DLL_CAPTION, mtInformation, [mbOk], 0);
      Result := False;
    end;

end;

procedure TfrmMHA_DLL_DataEntry.DoubleClickMessage(Sender: TObject);
begin
  MsgDlgFrm('Sorry, this question does not respond to double-clicks of the mouse.',
    MHA_DLL_CAPTION, mtInformation, [mbOk], 0);
end;


procedure TfrmMHA_DLL_DataEntry.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

(*function TfrmMHA_DLL_DataEntry.CheckForCustomOperation: boolean;
var
  AnswerString,
    ResultString,
    TempStr                   : string;
  i                           : Integer;
  dllHandle                   : THandle;
begin
  result := False;
  dllHandle := LoadLibrary(MHA_DLL_SCORE);

  if dllHandle = 0 then
    begin
      MsgDlg('Could not find DLL used for scoring instruments.', ID_CAPTION,
        mtWarning, [mbOk], 0);
      FreeLibrary(dllHandle);
      Exit;
    end
  else
    begin
      try
        @CustomDLL := GetProcAddress(dllHandle, 'Custom');

        if @CustomDLL = nil then
          begin
          // function not found
            FreeLibrary(dllHandle);
            Exit;
          end;

        AnswerString := '';
        ResultString := '';

        for i := 0 to gvInstrument.ListOfAnswers.Count - 1 do
          AnswerString := AnswerString +
            TAnswer(gvInstrument.ListOfAnswers[i]).QuestionID + EQ +
            TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue + U + U +
            TAnswer(gvInstrument.ListOfAnswers[i]).AnswerID + RECORD_END;

        if Assigned(CustomDLL) then
          CustomDLL(gvInstrument.Name,
            'Perkins, Lenwood (Fictitious name)', //Patient.Name,
            'March 14,1950', //Patient.DOB,
            'MALE', //Patient.Sex,
            AnswerString,
            ResultString);

        if (ResultString = '') or
          (ResultString = AnswerString) then
          begin
            FreeLibrary(dllHandle);
            Exit;
          end
        else
          begin
            for i := 0 to gvInstrument.ListOfAnswers.Count - 1 do
              begin
                // ResultString starts at 1, ListOfAnswers at 0
                TempStr := Piece(ResultString, RECORD_END, i + 1);
                TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue :=
                  Piece(Piece(TempStr, EQ, 2), U, 1);
                //TAnswer(gvInstrument.ListOfAnswers[i]).AnswerText :=
                //  TAnswer(gvInstrument.ListOfAnswers[i]).AnswerValue;
              end;
            result := True;
          end;

      finally
        FreeLibrary(dllHandle);
      end; {try..finally}
    end;

end;*)

end.

