unit uMHA_AUX_BAM;

interface

uses
  DateUtils,
  SysUtils,
  Dialogs;

function Verify_BAM(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

function Verify_BAMC(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;


function ScoreAnswers_BAMC(
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

function ProgressNote_BAMC(
  PatientName,
  PatientDOB,
  PatientSex,
  ScoreString,
  AnswerString: string): string;

function ScoreAnswers_BAMR(
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

function ProgressNote_BAMR(
  PatientName,
  PatientDOB,
  PatientSex,
  ScoreString,
  AnswerString: string): string;


implementation

uses
  uMHA_AUX_Const,
  //patch 129 removed fIA_dialogs,
  //fIA_dialogs,
  uMHA_AUX_Utils;


function Verify_BAM(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

var
  Alc1,
    Alc2,
    Sub1,
    Sub2,
    Count, i                  : Integer;
  AlcDays1,
    AlcDays2,
    SubDays1,
    SubDays2,
    TempStr,
    TempStr1                  : string;

begin

  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems

  // Remeber to add a "V" to result if there is a message for user. This
  // separates multiple messages.
  Count := NumberOfPieces(AnswerString, RECORD_END);
  Sub1 := 0;
  Alc1 := 0;

  AlcDays1 := '';
  AlcDays2 := '';
  SubDays1 := '';
  SubDays2 := '';

  if Count < 1 then
    Exit;

  for i := 6 to Count - 1 do
    begin
      TempStr := Piece(AnswerString, RECORD_END, i);
      TempStr1 := Piece(Piece(TempStr, EQ, 2), U, 1);

      if i = 6 then
        begin
          AlcDays1 := TempStr1;
          Alc1 := StrToIntDef(AlcDays1, 0);
        end;

      if i = 7 then
        begin
          AlcDays2 := TempStr1;
          if AlcDays2 = '1156' then
            Alc2 := 0
          else
            Alc2 := StrToIntDef(AlcDays2, 0);
          if Alc1 < Alc2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4 should be equal to, or more than, ' +
                'the number of days in Question 5.' + RECORD_END;
            end;
        end;

      if i = 8 then
        begin
          SubDays1 := TempStr1;
          if SubDays1 = '1156' then
            Sub1 := 0
          else
            Sub1 := StrToIntDef(SubDays1, 0);
        end;

      if i = 9 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7A should be equal to, or less than, ' +
                'the number of days in Question 6.' + RECORD_END;
            end;
        end;

      if i = 10 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7B should be equal to, or less than, ' +
                'the number of days in Question 6.' + RECORD_END;
            end;
        end;

      if i = 11 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7C should be equal to, or less than, ' +
                'the number of days in Question 6.' + RECORD_END;
            end;
        end;

      if i = 12 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7D should be equal to, or less than, ' +
                'the number of days in Question 6.' + RECORD_END;
            end;
        end;

      if i = 13 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7E should be equal to, or less than, ' +
                'the number of days in Question 6.' + RECORD_END;
            end;
        end;

      if i = 14 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7F should be equal to, or less than, ' +
                'the number of days in Question 6.' + RECORD_END;
            end;
        end;

      if i = 15 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7G should be equal to, or less than, ' +
                'the number of days in Question 6.' + RECORD_END;
            end;
        end;
    end; // for i
end;

function Verify_BAMC(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

var
  Alc1,
    Alc2,
    Sub1,
    Sub2,
    AllSub,
    Count, i                  : Integer;
  AlcDays1,
    AlcDays2,
    SubDays1,
    SubDays2,
    TempStr,
    TempStr1                  : string;

begin

  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems

  // Remeber to add a "V" to result if there is a message for user. This
  // separates multiple messages.
  Count := NumberOfPieces(AnswerString, RECORD_END);
  Sub1 := 0;
  Alc1 := 0;
  AllSub := 0;

  AlcDays1 := '';
  AlcDays2 := '';
  SubDays1 := '';
  SubDays2 := '';

  if Count < 1 then
    Exit;

  for i := 3 to Count - 1 do
    begin
      TempStr := Piece(AnswerString, RECORD_END, i);
      TempStr1 := Piece(Piece(TempStr, EQ, 2), U, 1);

      if i = 3 then
        begin
          AlcDays1 := TempStr1;
          if AlcDays1 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 1 should not be a blank.' + RECORD_END;
              AlcDays1 := '0';
            end;
          Alc1 := StrToIntDef(AlcDays1, 0);
        end;

      if i = 4 then
        begin
          AlcDays2 := TempStr1;
          if AlcDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 2 should not be a blank.' + RECORD_END;
              AlcDays2 := '0';
            end;

          if AlcDays2 = '1156' then
            Alc2 := 0
          else
            Alc2 := StrToIntDef(AlcDays2, 0);
          if Alc1 < Alc2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 1 should be equal to, or more than, ' +
                'the number of days in Question 2.' + RECORD_END;
            end;
        end;

      if i = 5 then
        begin
          SubDays1 := TempStr1;
          if SubDays1 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 3 should not be a blank.' + RECORD_END;
              SubDays1 := '0';
            end;

          if SubDays1 = '1156' then
            Sub1 := 0
          else
            Sub1 := StrToIntDef(SubDays1, 0);
        end;

      if i = 6 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4A should not be a blank.' + RECORD_END;
              SubDays2 := '0';
            end;

          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          AllSub := AllSub + Sub2;

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4A should be equal to, or less than, ' +
                'the number of days in Question 3.' + RECORD_END;
            end;
        end;

      if i = 7 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4B should not be a blank.' + RECORD_END;
              SubDays2 := '0';
            end;

          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          AllSub := AllSub + Sub2;

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4B should be equal to, or less than, ' +
                'the number of days in Question 3.' + RECORD_END;
            end;
        end;

      if i = 8 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4C should not be a blank.' + RECORD_END;
              SubDays2 := '0';
            end;

          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          AllSub := AllSub + Sub2;

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4C should be equal to, or less than, ' +
                'the number of days in Question 3.' + RECORD_END;
            end;
        end;

      if i = 9 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4D should not be a blank.' + RECORD_END;
              SubDays2 := '0';
            end;

          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          AllSub := AllSub + Sub2;

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4D should be equal to, or less than, ' +
                'the number of days in Question 3.' + RECORD_END;
            end;
        end;

      if i = 10 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4E should not be a blank.' + RECORD_END;
              SubDays2 := '0';
            end;

          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          AllSub := AllSub + Sub2;

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4E should be equal to, or less than, ' +
                'the number of days in Question 3.' + RECORD_END;
            end;
        end;

      if i = 11 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4F should not be a blank.' + RECORD_END;
              SubDays2 := '0';
            end;

          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          AllSub := AllSub + Sub2;

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4F should be equal to, or less than, ' +
                'the number of days in Question 3.' + RECORD_END;
            end;
        end;

      if i = 12 then
        begin
          SubDays2 := TempStr1;
          if SubDays2 = '1155' then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4G should not be a blank.' + RECORD_END;
              SubDays2 := '0';
            end;

          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);

          AllSub := AllSub + Sub2;

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4G should be equal to, or less than, ' +
                'the number of days in Question 3.' + RECORD_END;
            end;
        end;

    end; // for i

  if AllSub < Sub1 then
    Result := Result +
      'There is an inconsistency: The addition of all the itemized substances in questions ' +
      '4A through 4G should be equal to, or greater than, the number of days ' +
      'entered in Question 3.' + RECORD_END;
end;


function ScoreAnswers_BAMC(
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;
var
  i, Count                    : integer;
  TempStr,
    TempStr1,
    Alcohol,
    Heavy,
    Drug                      : string;

begin

  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems

  if AnswerString = 'BAM-C' then
    begin
      Result := 'YES';
      exit;
    end;

  Count := NumberOfPieces(AnswerString, RECORD_END);
  Alcohol := '';
  Heavy := '';
  Drug := '';

  if Count < 1 then
    Exit;

  for i := 3 to 5 do
    begin
      TempStr := Piece(AnswerString, RECORD_END, i);
      TempStr1 := Piece(Piece(TempStr, EQ, 2), U, 1);

      if TempStr1 = '1156' then
        TempStr1 := '0';
      if TempStr1 = '1155' then
        TempStr1 := ''; // if 'Skipped' used it screws up the graphing.

      if i = 3 then
        Alcohol := TempStr1;
      if i = 4 then
        Heavy := TempStr1;
      if i = 5 then
        Drug := TempStr1;
    end; // for i

  Result := 'Days Alcohol Use^^' + Alcohol + RECORD_END +
    'Days Heavy Alcohol Use^^' + Heavy + RECORD_END +
    'Days Other Drug Use^^' + Drug + RECORD_END;
end;


function ProgressNote_BAMC(
  PatientName,
  PatientDOB,
  PatientSex,
  ScoreString,
  AnswerString: string): string;
// The header, footer and questions and answers are handled elsewhere; avoiding
// broker calls here. <.DLL_String.> provides location for this string in the
// report.
var
  Alcohol, Heavy, Drug        : string;

begin
  Result := '';
  Alcohol := '';
  Heavy := '';
  Drug := '';

  if (ScoreString = '') then
    Exit;

  Alcohol := '';
  Heavy := '';
  Drug := '';

  Alcohol := Piece(Piece(ScoreString, RECORD_END, 1), U, 3); // 6~
  Heavy := Piece(Piece(ScoreString, RECORD_END, 2), U, 3); // 6~
  Drug := Piece(Piece(ScoreString, RECORD_END, 3), U, 3); // 6~

  Result := #13 +
    'Days of Alcohol Use: ' + Alcohol + #13 +
    'Days of Heavy Alcohol Use: ' + Heavy + #13 +
    'Days Other Drug Use: ' + Drug + #13 + #13 +
    '    Range is 0 to 30. If a patient scores a 1 or greater, it calls for ' + #13 +
    '    further examination and clinical attention, e.g. consider addition of ' + #13 +
    '    pharmacotherapy or higher level of care, add motivational interviewing.';
end;

function ScoreAnswers_BAMR(
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;
var
  i, Count,

  Use,
    Risk,
    Protect,
    DaysAU,
    DaysHA,
    DaysDrug,
    Health,
    Sleep,
    Distress,
    Urges,
    Risky,
    Relation,
    Confidence,
    Self,
    Spirit,
    Work,
    Income,
    Support                   : integer;

  TempStr,
    TempStr1
                              : string;

  function ScoreAdjustment(ScoreIn: string): integer;
  begin
    result := 0;
    if ScoreIn = '1' then
      result := 8;
    if ScoreIn = '2' then
      result := 15;
    if ScoreIn = '3' then
      result := 22;
    if ScoreIn = '4' then
      result := 30;
  end;

begin

  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems

  if AnswerString = 'BAM-R' then
    begin
      Result := 'YES';
      exit;
    end;

  //showmessage('in uMHA_AUX_BAM-R, AnswerString = ' + AnswerString);

  Count := NumberOfPieces(AnswerString, RECORD_END);

  if Count < 1 then
    Exit;

  Use := 0;
  Risk := 0;
  Protect := 0;
  DaysAU := 0;
  DaysHA := 0;
  DaysDrug := 0;
  Health := 0;
  Sleep := 0;
  Distress := 0;
  Urges := 0;
  Risky := 0;
  Relation := 0;
  Confidence := 0;
  Self := 0;
  Spirit := 0;
  Work := 0;
  Income := 0;
  Support := 0;

  for i := 3 to Count - 1 do
    begin
      TempStr := Piece(AnswerString, RECORD_END, i);
      TempStr1 := Piece(Piece(TempStr, EQ, 2), U, 1);

      if TempStr1 = '1156' then
        TempStr1 := '0';
      if TempStr1 = '1155' then
        TempStr1 := '0'; // if 'Skipped' used it screws up the graphing.

      if i = 3 then // Question 1 Health
        begin
          Health := StrToIntDef(TempStr1, 0);
          Risk := Risk + ScoreAdjustment(TempStr1);
        end;
      if i = 4 then // Question 2 Sleep
        begin
          Sleep := StrToIntDef(TempStr1, 0);
          Risk := Risk + StrToIntDef(TempStr1, 0);
        end;
      if i = 5 then // Question 3 Distressed
        begin
          Distress := StrToIntDef(TempStr1, 0);
          Risk := Risk + StrToIntDef(TempStr1, 0);
        end;
      if i = 6 then // Question 4 Days Alcohol use
        begin
          DaysAU := StrToIntDef(TempStr1, 0);
          Use := StrToIntDef(TempStr1, 0);
        end;
      if i = 7 then // Question 5 Heavy Alchol Use
        begin
          DaysHA := StrToIntDef(TempStr1, 0);
          Use := Use + StrToIntDef(TempStr1, 0);
        end;
      if i = 8 then // Question 6 Days Drug use
        begin
          DaysDrug := StrToIntDef(TempStr1, 0);
          Use := Use + StrToIntDef(TempStr1, 0);
        end;

      // Questions 7, 7A - 7G not scored

      if i = 16 then // Question 8
        begin
          Urges := StrToIntDef(TempStr1, 0);
          Risk := Risk + ScoreAdjustment(TempStr1);
        end;
      if i = 17 then // Question 9
        begin
          Confidence := StrToIntDef(TempStr1, 0);
          Protect := Protect + ScoreAdjustment(TempStr1);
        end;
      if i = 18 then // Question 10
        begin
          Self := StrToIntDef(TempStr1, 0);
          Protect := Protect + StrToIntDef(TempStr1, 0);
        end;
      if i = 19 then // Question 11
        begin
          Risky := StrToIntDef(TempStr1, 0);
          Risk := Risk + StrToIntDef(TempStr1, 0);
        end;
      if i = 20 then // Question 12
        begin
          Spirit := StrToIntDef(TempStr1, 0);
          Protect := Protect + ScoreAdjustment(TempStr1);
        end;
      if i = 21 then // Question 13
        begin
          Work := StrToIntDef(TempStr1, 0);
          Protect := Protect + StrToIntDef(TempStr1, 0);
        end;
      if i = 22 then // Question 14
        begin
          if TempStr1 = '1' then
            begin
              Income := 4;
              Protect := Protect + 30;
            end;
        end;
      if i = 23 then // Question 15
        begin
          Relation := StrToIntDef(TempStr1, 0);
          Risk := Risk + ScoreAdjustment(TempStr1);
        end;
      if i = 24 then // Question 16
        begin
          Support := StrToIntDef(TempStr1, 0);
          Protect := Protect + StrToIntDef(TempStr1, 0);
        end;
    end; // for i

  Result := 'Use' + U + U + InttoStr(Use) + RECORD_END +
    'Risk Factors' + U + U + InttoStr(Risk) + RECORD_END +
    'Protective Factors' + U + U + InttoStr(Protect) + RECORD_END +
    'Days Alcohol Use' + U + U + InttoStr(DaysAU) + RECORD_END +
    'Days Heavy Alcohol Use' + U + U + InttoStr(DaysHA) + RECORD_END +
    'Days Other Drug Use' + U + U + InttoStr(DaysDrug) + RECORD_END +
    'Physical Health' + U + U + InttoStr(Health) + RECORD_END +
    'Days Sleep Problems' + U + U + InttoStr(Sleep) + RECORD_END +
    'Days Distressed' + U + U + InttoStr(Distress) + RECORD_END +
    'Urges, Cravings' + U + U + InttoStr(Urges) + RECORD_END +
    'Days Risky Situations' + U + U + InttoStr(Risky) + RECORD_END +
    'Relationship Problems' + U + U + InttoStr(Relation) + RECORD_END +
    'Confidence in No Use' + U + U + InttoStr(Confidence) + RECORD_END +
    'Days Self-help' + U + U + InttoStr(Self) + RECORD_END +
    'Spiritual Supportive' + U + U + InttoStr(Spirit) + RECORD_END +
    'Days Work/School' + U + U + InttoStr(Work) + RECORD_END +
    'Adequate Income' + U + U + InttoStr(Income) + RECORD_END +
    'Days Supportive Persons' + U + U + InttoStr(Support) + RECORD_END;

end;


function ProgressNote_BAMR(
  PatientName,
  PatientDOB,
  PatientSex,
  ScoreString,
  AnswerString: string): string;

// The header, footer and questions and answers are handled elsewhere; avoiding
// broker calls here. <.DLL_String.> provides location for this string in the
// report.
var
  Alcohol, Heavy, Drug        : string;

begin
  Result := '';
  Alcohol := '';
  Heavy := '';
  Drug := '';

  if (ScoreString = '') then
    Exit;

  Result := #13 +
    'Clinical Subscales' + #13 + #13 +
    '  Use: ' + Piece(Piece(ScoreString, RECORD_END, 1), U, 3) + #13 +
    '  Items 4, 5, 6. A high score indicates more use, range is 0 to 90. If a patient ' + #13 +
    '  scores a 1 or greater, it calls for further assessment and clinical attention, ' + #13 +
    '  e.g., consider addition/change of pharmacotherapy or psychosocial intervention.' + #13 + #13 +

    '  Risk Factors: ' + Piece(Piece(ScoreString, RECORD_END, 2), U, 3) + #13 +
    '  Items 1, 2, 3, 8, 11, 15. A high score indicates increased risk, range is 0 to 180.' + #13 +
    '  For subscale scores, items with ordinal response options (0-4) were converted to' + #13 +
    '  contribute proportionately consistent with items on days of use (0-30). Clinicians' + #13 +
    '  are encouraged to consider scores on individual Risk items in offering' + #13 +
    '  interventions as indicated during initial treatment planning and following re-assessment.' + #13 + #13 +

    '  Protective Factors: ' + Piece(Piece(ScoreString, RECORD_END, 3), U, 3) + #13 +
    '  Items 9, 10, 12, 13, 14, 16. A high score indicates greater protective factors,' + #13 +
    '  range is 0 to 180. For subscale scores, items with ordinal response options (0-4)'+ #13 +
    '  were converted to contribute proportionately consistent with items on days of use' + #13 +
    '  (0-30). Clinicians are encouraged to consider scores on individual Protective items'+ #13 +
    '  in offering interventions as indicated during initial treatment planning and'+ #13 +
    '  following re-assessment. ';
end;

end.

