unit uMHA_AUX_PSF;

interface

uses
  DateUtils,
  SysUtils;

function DefaultAnswers_PTSD_Status_Form(
  InstrumentName,
  UserName,
  StationCode,
  StationSuffix,
  PatientName,
  PatientSSN,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

function Verify_PTSD_Status_Form(InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

function GroomAnswers_PTSD_Status_Form(InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

implementation

uses
  uMHA_AUX_Const,
  fIA_dialogs,
  uMHA_AUX_Utils;

(*function IncrementCheck(Input: string): string;
var
  TempInt                     : integer;
begin
  Result := 'OK';

  if (Input = NOT_ASKED) or
    (Input = SKIPPED) or
    (Input = CHOICE_ID_OF_SKIPPED_MULTIPLE_CHOICE_QUESTION) or
    (Input = CHOICE_ID_OF_SKIPPED_BY_RULE_MC_QUESTION) or
    (Input = CHOICE_ID_OF_SKIPPED_REQUIRED_ANSWER) then
    Exit;

  TempInt := StrToInt(Input);

  if ((TempInt > 100) or (TempInt < 0)) then
    begin
      Result := 'For questions 10 and 11, the number must be in range of 0% to 100%, in ' +
        'increments of 10%, like 20% or 60%. (You do not have to ' +
        'enter the percent sign.)';
      Exit;
    end;

  if TempInt mod 10 <> 0 then
    begin
      Result := 'For questions 10 and 11, the number must be in increments of 10%, like 20% or 60%. ' +
        '(You do not have to enter the percent sign.)';
      Exit;
    end;

end;*)


function ConvertStrDateToTDate(DateIn: string): TDateTime;
// DateIn is in Format: JUL 01, 1934
var
  TempDate,
    TempStr,
    TempMo                    : string;
begin
  TempDate := DateIn;
  Result := StrToDate('01/01/1700'); // Default as error

  if Length(DateIn) < 12 then
    Exit;

  TempMo := Copy(TempDate, 1, 3);
  TempStr := '01/';
  if TempMo = 'FEB' then
    TempStr := '02/';
  if TempMo = 'MAR' then
    TempStr := '03/';
  if TempMo = 'APR' then
    TempStr := '04/';
  if TempMo = 'MAY' then
    TempStr := '05/';
  if TempMo = 'JUN' then
    TempStr := '06/';
  if TempMo = 'JUL' then
    TempStr := '07/';
  if TempMo = 'AUG' then
    TempStr := '08/';
  if TempMo = 'SEP' then
    TempStr := '09/';
  if TempMo = 'OCT' then
    TempStr := '10/';
  if TempMo = 'NOV' then
    TempStr := '11/';
  if TempMo = 'DEC' then
    TempStr := '12/';

  TempStr := TempStr + Copy(TempDate, 5, 2) + '/' + Copy(TempDate, 9, 4);
  Result := StrToDate(TempStr);
end;

function DefaultAnswers_PTSD_Status_Form(
  InstrumentName,
  UserName,
  StationCode,
  StationSuffix,
  PatientName,
  PatientSSN,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;
var
  i, Count                    : Integer;
  TempResult                  : string;
begin

  Result := AnswerString;
  Count := NumberOfPieces(Result, RECORD_END);

  if Count < 1 then
    Exit;

  for i := 1 to Count do
    begin
      // Clinician's name and Data entered by
      if (i = 1) or (i = 2) then
        begin
          TempResult := Piece(Result, RECORD_END, i);
          TempResult := Piece(TempResult, EQ, 1) + EQ +
            UserName + U + Piece(TempResult, U, 2) + U;
          SetPiece(Result, RECORD_END, i, TempResult);
        end;


(*
      // Station Code
      if i = 3 then
        begin
          TempResult := Piece(Result, V, i);
          TempResult := Piece(TempResult, EQ, 1) + EQ +
            StationCode + U + Piece(TempResult, U, 2) + U;
          SetPiece(Result, V, i, TempResult);
        end;
      // Station Suffix
      if i = 4 then
        begin
          TempResult := Piece(Result, V, i);
          TempResult := Piece(TempResult, EQ, 1) + EQ +
            StationSuffix + U + Piece(TempResult, U, 2) + U;
          SetPiece(Result, V, i, TempResult);
        end;
      // 1. Veteran's name
      if i = 5 then
        begin
          TempResult := Piece(Result, V, i);
          TempResult := Piece(TempResult, EQ, 1) + EQ +
            PatientName + U + Piece(TempResult, U, 2) + U;
          SetPiece(Result, V, i, TempResult);
        end;
      // 2. Veteran's SSN
      if i = 6 then
        begin
          TempResult := Piece(Result, V, i);
          TempResult := Piece(TempResult, EQ, 1) + EQ +
            PatientSSN + U + Piece(TempResult, U, 2) + U;
          SetPiece(Result, V, i, TempResult);
        end;
      // 3. Veteran's DOB
      if i = 7 then
        begin
          TempResult := Piece(Result, V, i);
          TempResult := Piece(TempResult, EQ, 1) + EQ +
            DateTimeToStr(ConvertStrDateToTDate(PatientDOB)) +
            U + Piece(TempResult, U, 2) + U;
          SetPiece(Result, V, i, TempResult);
        end;
      // 4. Veteran's gender
      if i = 8 then
        begin
          TempResult := Piece(Result, V, i);
          if PatientSex = 'F' then
          TempResult := Piece(TempResult, EQ, 1) + EQ +
            '1' + U + Piece(TempResult, U, 2) + U
            else
            TempResult := Piece(TempResult, EQ, 1) + EQ +
            '0' + U + Piece(TempResult, U, 2) + U;
          SetPiece(Result, V, i, TempResult);
        end;
        *)
    end; // for i
end;

function GroomAnswers_PTSD_Status_Form(InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;
var
  i, Count                    : Integer;
  PreviousAns7,
    PreviousAns8,
    PreviousAns9,
    TempAnswer,
    //TempAnswerText,
  TempResult                  : string;

begin
// AnswerString is in this format:
//  AnswerString := AnswerString +
//            TAnswer(Instrument.ListOfAnswers[i]).QuestionID + EQ +
//            TAnswer(Instrument.ListOfAnswers[i]).AnswerValue + U +
//            TAnswer(Instrument.ListOfAnswers[i]).AnswerText + U +
//            TAnswer(Instrument.ListOfAnswers[i]).AnswerID + RECORD_END;

  Result := AnswerString;
  Count := NumberOfPieces(Result, RECORD_END);

  if Count < 1 then
    Exit;

  for i := 1 to Count do
    begin
      TempResult := Piece(Result, RECORD_END, i);
    // 10. For Psychiatric (including PTSD)
    // 11. For Physical
    // Change answer to 000 for blank, 0.
    // If Answer is disabled (1156) then make the answer an "N"
      if i = 7 then
        begin

          PreviousAns7 := Piece(Piece(TempResult, EQ, 2), U, 1);
        end;
      if i = 8 then
        begin

          PreviousAns8 := Piece(Piece(TempResult, EQ, 2), U, 1);
        end;
      if i = 9 then
        begin

          PreviousAns9 := Piece(Piece(TempResult, EQ, 2), U, 1);
        end;
      if (i = 10) or (i = 11) then
        begin

          TempAnswer := Piece(Piece(TempResult, EQ, 2), U, 2);

          if (TempAnswer = '0') or (TempAnswer = '00') or
            (TempAnswer = '000') or (TempAnswer = ' ') or
            (TempAnswer = '') then
            begin
              TempResult := Piece(TempResult, EQ, 1) + EQ +
                '0' + U + '000';
              SetPiece(Result, RECORD_END, i, TempResult);
            end;

          if (TempAnswer = '1156') then
            begin
              TempResult := Piece(TempResult, EQ, 1) + EQ +
                CHOICE_ID_OF_SKIPPED_BY_RULE_MC_QUESTION + U +
                CHOICE_ID_OF_SKIPPED_BY_RULE_MC_QUESTION + U +
                Piece(Piece(TempResult, EQ, 2), U, 3);

               //CHOICE_ID_OF_SKIPPED_BY_RULE_MC_QUESTION;
              SetPiece(Result, RECORD_END, i, TempResult);
            end;

          if (PreviousAns7 = SKIPPED) and (PreviousAns8 = SKIPPED) and (i = 10) then
            begin
              TempResult := Piece(TempResult, EQ, 1) + EQ +
               //' ' + U + ' ' + U +
              SKIPPED + U + SKIPPED + U +
                Piece(Piece(TempResult, EQ, 2), U, 3);
              SetPiece(Result, RECORD_END, i, TempResult);
            end;
          if (PreviousAns9 = SKIPPED) and (i = 11) then
            begin
              TempResult := Piece(TempResult, EQ, 1) + EQ +
               //' ' + U + Piece(TempResult, U, 2);
              SKIPPED + U + SKIPPED + U +
                Piece(Piece(TempResult, EQ, 2), U, 3);
              SetPiece(Result, RECORD_END, i, TempResult);
            end;
        end;
    end; // Designator 10, 11
end;


function Verify_PTSD_Status_Form(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;
var
  Count, i                    : Integer;
  GotPersianGulf              : Boolean;
  TempStr,
    TempResult,
    TempAnswer                : string;
  ThisYear, ThisMonth, ThisDay: Word;
  VetDOB                      : TDateTime;

begin
  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems
  // Remeber to add a "~" to result if there is a message for user. This
  // separates multiple messages.
  Count := NumberOfPieces(AnswerString, RECORD_END);
  GotPersianGulf := False;

  if Count < 1 then
    Exit;

  for i := 1 to Count do
    begin
      // Service dates verified with veteran's DOB; JUL 22, 1922
      // if (Designator = '13.') and (PatientDOB <> '') then
      if (i = 16) and (PatientDOB <> '') then
        begin
          TempStr := Piece(AnswerString, RECORD_END, i);
          VetDOB := ConvertStrDateToTDate(PatientDOB);
          if DateToStr(VetDOB) <> '01/01/1700' then
            begin
              // TempAnswer is in format: 100000
              TempAnswer := Piece(Piece(TempStr, EQ, 2), U, 1);
              if Length(TempAnswer) = 8 then
                begin
                  if TempAnswer[1] = '1' then // Pre WW II
                    if VetDOB > StrToDate('09/15/1924') then
                      begin
                        Result := 'This veteran may not be old enough for service ' +
                          'prior to World War II (1939-1945). Please verify ' +
                          'the birth date.' + RECORD_END;

                      end;
                  if TempAnswer[2] = '1' then // WW II
                    if VetDOB > StrToDate('07/25/1931') then
                      begin
                        Result := 'This veteran may not be old enough for service ' +
                          'during World War II (1939-1945). Please verify ' +
                          'the birth date.' + RECORD_END;

                      end;
                  if TempAnswer[3] = '1' then // Pre Korea 26, 6, 1950-16,
                    if VetDOB > StrToDate('06/26/1934') then
                      begin
                        Result := 'This veteran may not be old enough for service ' +
                          'prior to Korean War (1950-1953). Please verify ' +
                          'the birth date.' + RECORD_END;

                      end;
                  if TempAnswer[4] = '1' then // Korea  31, 1, 1955-16
                    if VetDOB > StrToDate('01/31/1939') then
                      begin
                        Result := 'This veteran may not be old enough for service ' +
                          'during the Korean War (1950-1953). Please verify ' +
                          'the birth date.' + RECORD_END;

                      end;
                  if TempAnswer[5] = '1' then // Between Korea & Vietnam 4, 8, 1964-16
                    if VetDOB > StrToDate('08/04/1948') then
                      begin
                        Result := 'This veteran may not be old enough for service ' +
                          'between Korean War (1950-1953) and Vietnam War (1965-1973). Please verify ' +
                          'the birth date.' + RECORD_END;

                      end;
                  if TempAnswer[6] = '1' then // Vietnam  7, 5, 1975-16
                    if VetDOB > StrToDate('05/07/1959') then
                      begin
                        Result := 'This veteran may not be old enough for service ' +
                          'in Vietnam War (1965-1973). Please verify ' +
                          'the birth date.' + RECORD_END;

                      end;
                  if TempAnswer[7] = '1' then // Post Vietnam 31, 7, 1990-16
                    if VetDOB > StrToDate('07/31/1974') then
                      begin
                        Result := 'This veteran may not be old enough for service ' +
                          'after Vietnam War (1965-1973). Please verify ' +
                          'the birth date.' + RECORD_END;

                      end;
                  // The Persian War is used as the catch-all category for
                  // recent vets. There should be no lower age limit except for
                  // 16, and younger.
                  if TempAnswer[8] = '1' then // Persian Gulf
                    begin
                      GotPersianGulf := True;
                      DecodeDate(Now, ThisYear, ThisMonth, ThisDay);
                      if VetDOB > StrToDate(IntToStr(ThisMonth) + '/' +
                        IntToStr(ThisDay) + '/' +
                        IntToStr(ThisYear - 16)) then
                        begin
                          Result := 'This veteran may not be old enough for service ' +
                            'in Persian Gulf War (1991) or afterwards. Please verify ' +
                            'the birth date.' + RECORD_END;

                        end;
                    end;
                end;
            end;
        end; // if i = 15

      if (i = 17) or (i = 18) then
        begin
          if not GotPersianGulf then
            begin
              TempResult := Piece(AnswerString, RECORD_END, i);
              TempAnswer := Piece(Piece(TempResult, U, 1), EQ, 2);
              if TempAnswer = '1' then
                begin
                  Result := Result +
                    'For consistency, if the veteran served in Iraq or ' +
                    'Afghanistan, Question 13 must have the item, "8. Persian Gulf War" checked. ' +
                    'Please make that change.' + RECORD_END;
                end;
            end;
        end;
    end; // for i
end;

end.

 