unit uIA_Display_OPS;

interface

uses
  Classes,          dialogs,
  graphics,
  SysUtils,
  uIA_Const,
  uIA_Display;

type

  TDisplay_OPS = class
  private
  protected
  public
    function StrToAlignment(AAlignment: string): TAlignment;
    function AlignmentToStr(AAlignment: TAlignment): string;
    function StrToAnswerComponent(AComponent: string): TAnswerComponent;
    function AnswerComponentToStr(AAnswerComponent: TAnswerComponent): string;
    function StyleToString(StyleIn: TFontStyles): string;
  end;

var
  Display_OPS                 : TDisplay_OPS;

implementation


function TDisplay_OPS.StyleToString(StyleIn: TFontStyles): string;
// Used in Export
begin
  Result := '';
  if fsBold in StyleIn then
    Result := 'Y' + U
  else
    Result := 'N' + U;
  if fsItalic in StyleIn then
    Result := Result + 'Y' + U
  else
    Result := Result + 'N' + U;
  if fsUnderline in StyleIn then
    Result := Result + 'Y' + U
  else
    Result := Result + 'N' + U;
end;

function TDisplay_OPS.StrToAlignment(AAlignment: string): TAlignment;
begin
  //taLeftJustify is the default
  Result := taLeftJustify;

  if (AAlignment = CENTER_JUSTIFY) then
    Result := taCenter;
  if (AAlignment = RIGHT_JUSTIFY) then
    Result := taRightJustify;

end;

function TDisplay_OPS.StrToAnswerComponent(AComponent: string): TAnswerComponent;
var
  Abbr                        : string;
begin
  if Length(AComponent) >= 2 then
    Abbr := UpperCase(AComponent[1] + AComponent[2]);

  Result := acRadioGroup;

  if Abbr = COMBOBOX_AC then
    Result := acComboBox;
  if (Abbr = CHECKLIST_AC) or (Abbr = 'CK') then
    Result := acCheckListBox;
  if Abbr = LISTBOX_AC then
    Result := acListBox;
  if Abbr = EDIT_AC then
    Result := acEdit;
  if Abbr = MASKEDIT_AC then
    Result := acMaskEdit;
  if Abbr = SPINEDIT_AC then
    Result := acSpinEdit;
  if Abbr = MEMO_AC then
    Result := acMemo;
  if Abbr = DATEPICKER_AC then
    Result := acDatePicker;
  if Abbr = TRACKBAR_AC then
    Result := acTrackBar;
  if (Abbr = ORCOMBOBOX_AC) or
  (Abbr = ORSTAFFCOMBOBOX_AC) or
  (AComponent = 'Staff combo') then
    Result := acStaff;
  if (Abbr = ORCONSULTCOMBOBOX_AC) or
   (AComponent = 'Consultation combo') then
    Result := acConsult;

end;


function TDisplay_OPS.AnswerComponentToStr(AAnswerComponent: TAnswerComponent): string;
begin
  case AAnswerComponent of
    acComboBox: Result := COMBOBOX_AC;
    acCheckListBox: Result := CHECKLIST_AC;
    acListBox: Result := LISTBOX_AC;
    acRadioGroup: Result := RADIOGROUP_AC;
    acEdit: Result := EDIT_AC;
    acMaskEdit: Result := MASKEDIT_AC;
    acSpinEdit: Result := SPINEDIT_AC;
    acMemo: Result := MEMO_AC;
    acDatePicker: Result := DATEPICKER_AC;
    acTrackBar: Result := TRACKBAR_AC;
    //acORCombo: Result := ORCOMBOBOX_AC;
    acORCombo: Result := ORSTAFFCOMBOBOX_AC;
    acStaff: Result := ORSTAFFCOMBOBOX_AC;
    acConsult: Result := ORCONSULTCOMBOBOX_AC;
  end;
end;

function TDisplay_OPS.AlignmentToStr(AAlignment: TAlignment): string;
begin
  case AAlignment of
    taLeftJustify: Result := LEFT_JUSTIFY;
    taCenter: Result := CENTER_JUSTIFY;
    taRightJustify: Result := RIGHT_JUSTIFY;
  end;
end;

end.

 