unit uIA_ScaleGroup;

interface

uses
  Classes;

type
  TScaleGroup = class
  private
    FGroupName,
      FIEN,
      FOrdinateTitle: string;
      FOrdinateMax,
      FOrdinateIncrement,
      FOrdinateMin,
      FGrid1Ordinate,
      FGrid2Ordinate,
      FGrid3Ordinate,
      FNumberOfScales,
      FSequence: Integer;
  protected
  public

    property GroupName: string read FGroupName write FGroupName;
    {** Maximum ordinate value on graph}
    property OrdinateMax: Integer read FOrdinateMax write FOrdinateMax;
    {** Minimum ordinate value on graph}
    property OrdinateMin: Integer read FOrdinateMin write FOrdinateMin;
    {** Caption for the ordinate}
    property OrdinateTitle: string read FOrdinateTitle write FOrdinateTitle;
    {** Ordinate value of third grid line (-1 if none)}
    property Grid3Ordinate: Integer read FGrid3Ordinate write FGrid3Ordinate;
    {** Ordinate value of second grid line (-1 if none)}
    property Grid2Ordinate: Integer read FGrid2Ordinate write FGrid2Ordinate;
    {** Ordinate value of first grid line (-1 if none)}
    property Grid1Ordinate: Integer read FGrid1Ordinate write FGrid1Ordinate;
    {** Ordinate increment on graph}
    property OrdinateIncrement: Integer read FOrdinateIncrement write FOrdinateIncrement;
    property NumberOfScales: Integer read FNumberOfScales write FNumberOfScales;
    property IEN: string read FIEN write FIEN;
    property Sequence: Integer read FSequence write FSequence;
    // The sequence of the scale group within an instrument: Starts at 1, not zero
    procedure Clear;
  end; { TScaleGroup }

implementation

procedure TScaleGroup.Clear;
begin
  FGroupName := '';
  FIEN := '';
  FOrdinateTitle := '';
  FOrdinateMax := 0;
  FOrdinateIncrement := 0;
  FOrdinateMin := 0;
  FGrid2Ordinate := 0;
  FGrid1Ordinate := 0;
  FGrid3Ordinate := 0;
  FNumberOfScales := 0;
  FSequence := 0;
end;


end.

