unit uIA_ScaleGroup_OPS;

interface

uses
  Classes,
   Trpcb,
   uIA_Instrument,
  uIA_ScaleGroup;

type

  TScaleGroup_OPS = class
  private
  protected
  public
    function BuildScaleGroupsAndScales(Broker: TRPCBroker;
    var Instrument: TInstrument): string;
  published
  end;

var
  ScaleGroup_OPS       : TScaleGroup_OPS;

implementation

uses
  uIA_Const,
  uIA_Scales_IO,
  uIA_Keys_IO;


function TScaleGroup_OPS.BuildScaleGroupsAndScales(Broker: TRPCBroker;
    var Instrument: TInstrument): string;
begin
  result := OK;
  Instrument.ListOfScaleGroups.Clear;
  Instrument.ListOfScales.Clear;
  Instrument.ListOfKeys.Clear;

  Result := ReadScaleGroupsAndScales(Broker, Instrument); // Scale_IO

  if result <> OK then
  begin
    Result := 'Unable to read scales in Vista for '+ Instrument.InstrumentName;
    exit;
  end;

  if not ReadScoringKeys(Broker, Instrument) then
    Result := 'Unable to load the scoring keys for ' + Instrument.InstrumentName;

end;


end.

