unit uIA_SectionLabel;

interface

uses
  uIA_Display;

type
  TSectionLabel = class
    Display: TDisplay;
  private
    FIEN,
      FTabCaption,
      FSectionCaption,
      FQuestionID: string; // QuestionID that follows the section label
  protected
  public
    destructor Destroy; override;
    constructor Create;

    property IEN: string read FIEN write FIEN;

    // Short label for tabs
    property TabCaption: string read FTabCaption write FTabCaption;

    // Longer label to appear on the form: Max 50 Char
    property SectionCaption: string read FSectionCaption write FSectionCaption;

     // This is QuestionID of the question that follows the section on the form
    property QuestionID: string read FQuestionID write FQuestionID;

    procedure Clear;

  end; { TSection }


implementation

uses
  SysUtils,
  uIA_Instrument;


procedure TSectionLabel.Clear;
begin
  FIEN := '';
  FTabCaption := '';
  FSectionCaption := '';
  FQuestionID := '';
end;

constructor TSectionLabel.Create;
begin
  inherited Create;
  Display := TDisplay.Create;
end;


destructor TSectionLabel.Destroy;
begin
  if Display <> nil then
    Display.Free;
  inherited Destroy;
end;


end.

